# Makefile for tine client utilities
# Insert the proper lib and include locations for your installation

# FIND ANACONDA DISTRIBUTIONS, USE LAST IN ALPABETICAL ORDER

# THE VARIABLES 
# ANACONDA_INCLUDE and DESTINATION
# MUST BE GIVEN AS ENVIRONMENT VARIABLES!


TINE_VERSION=$(shell cat LIBNO | sed  's/^.*=[ ]*//')
TINE_MAJOR_VERSION=$(shell cat LIBNO | sed  -e 's/^.*=[ ]*//' -e 's/\..*//')
LIB_NAME=PyTine.so
LIB_VERSION=$(LIB_NAME).$(TINE_VERSION)
INCL = /usr/include/tine
INCLP = $(ANACONDA_INCLUDE)

CC = gcc -g -fPIC -Wall -I${INCL} -I${INCLP} -c
CCL = g++ -shared -Wl,-soname,`basename $@ | sed -e "s/\(.*\.so\)\.\(.*\)\.\(.*\)/\1.\2/"` -o

all: $(LIB_VERSION)

$(DESTINATION):
	mkdir -p $(DESTINATION)

$(LIB_VERSION): pytine.o
	ln -sf libtinemt.so.$(TINE_VERSION) libtinemt.so
	ln -sf libtbufsrv.so.$(TINE_VERSION) libtbufsrv.so
	${CCL} $@ pytine.o -L. -ltinemt -ltbufsrv -lrt
#	${CCL} $@ pytine.o libtinemt.so.$(TINE_VERSION) libtbufsrv.so.$(TINE_VERSION) -lrt
		
pytine.o: pytine.cpp 
	${CC} pytine.cpp 

install: $(DESTINATION)
	install $(LIB_VERSION) $(DESTINATION)
	(cd $(DESTINATION); \
		cp $(LIB_VERSION) $(LIB_NAME); \
	)
	# THIS DOES NOT WORK (Links are not copied to deb)
	#ln -sf $(LIB_VERSION) $(LIB_NAME); \
	#ln -sf $(LIB_VERSION) $(LIB_NAME).$(TINE_MAJOR_VERSION); \

clean:
	rm -f pytine.o
	rm -f $(LIB_VERSION)
