import os
from distutils.core import setup, Extension

ANACONDA_LIST = []
ANACONDA_LIST.append(os.environ.get("ANACONDA_HOME"))
ANACONDA_LIST.append("/include/python3.4m");
ANACONDA = ''.join(ANACONDA_LIST);

TINE_SOURCE_LIST = []
TINE_SOURCE_LIST.append(os.environ.get('TINE_ROOT'))
TINE_SOURCE_LIST.append("/source")
TINE_SOURCE = ''.join(TINE_SOURCE_LIST)

print(ANACONDA)
print(TINE_SOURCE)

ptmodule = Extension(	'PyTine',
			sources = ['pytine.cpp'],
			include_dirs=[
				ANACONDA,		
				TINE_SOURCE,
				'./include/'
				'./source/'
				],
			library_dirs=[TINE_SOURCE],
			libraries=['tinemt','tbufsrv']
			)

setup (name = 'PyTine',
       version = '1.0.0',
       description = 'PyTine package',
       ext_modules = [ptmodule])

