# file: Makefile
#
# SDK Makefile for cpu named ref_system_cpu
# 2003.10.06 10:37:02
# D:/w_altera/ethernet_kit_reference_design_copy/ref_system.ptf
#


NIOS_SYSTEM_NAME = ref_system

CPU_ARCHITECTURE = nios_32
GNU_TOOLS_PREFIX = nios-elf
AS = $(GNU_TOOLS_PREFIX)-as
CC = $(GNU_TOOLS_PREFIX)-gcc
AR = $(GNU_TOOLS_PREFIX)-ar
LD = $(GNU_TOOLS_PREFIX)-ld
M = 32
PROGRAM_PREFIX = nios_jumptostart.s.o
TEST_CODE_PREFIX = nios_jumptostart.s.o

OBJDIR = .
SRC = .
E = echo \\\# `date +%Y.%m.%d.%H:%M:%S` ---

ASFlags = --defsym __nios$(M)__=1 -m$(M) -I ../inc -I ../..   \
	--defsym __nios_system_name__=$(NIOS_SYSTEM_NAME)

ASFlags_debug = $(ASFlags) --defsym __nios_debug__=1

CCFlags = -W -g -c -O2 -mno-zero-extend -m$(M) -I ../inc -I ../..   \
	-D __nios_system_name__=$(NIOS_SYSTEM_NAME)

CCFlags_debug = $(CCFlags) -O0 -D __nios_debug__=1

LIBRARY = libniosbsd.a

SINCLUDES =  \
	../inc/excalibur.s \
	../inc/excalibur.s \
	../inc/nios_macros.s

CINCLUDES =  \
	../inc/excalibur.h \
	../inc/cs8900.h \
	../inc/excalibur.h \
	../inc/excalibur.h \
	../inc/pio_lcd16207.h \
	../inc/plugs.h \
	../inc/wosfs.h

OBJECTS =  \
	$(OBJDIR)/nios_bsdlib.o \
	$(OBJDIR)/nios_syslib.o 

# +--------------------------------------------
# | Default make target is "all"

all : clean $(LIBRARY) 

# |
# +--------------------------------------------

$(OBJDIR)/%.s.o : $(SRC)/%.s $(SINCLUDES)
	@$(E) Assembling $<
	@$(AS) $(ASFlags) $< -o $@

$(OBJDIR)/%.o : $(SRC)/%.c $(CINCLUDES)
	@$(E) Compiling $<
	@$(CC) $(CCFlags) $< -o $@

$(OBJDIR) :
	@$(E) Making $@ Directory
	@mkdir $@

clean : $(OBJDIR) clean-lib
	@$(E) Removing objects
	@rm -f $(OBJECTS) $(LIBRARY)

clean-lib :
	@$(E) Deleting $(LIBRARY) 
	@rm -f $(LIBRARY) 

$(LIBRARY) : clean-lib $(OBJDIR) $(OBJECTS)
	@$(E) Building $@
	@$(AR) -r $(LIBRARY) $(OBJECTS)

# end of file
