#include "project.def"
#include "socket.h"

int debuglevel = 0;
int plugs_debuglevel = 0; //ne_plugs_flag_debug_rx|ne_plugs_flag_debug_tx;
SckMemPool sckPool[MAX_NUM_SCK];
int nSckInPool = 1;  // start here at 1 (wastes the first entry, but can't have a socket 0)
int lastSocketError = 0;
#define ccerr(i) { cc=i; goto err; }
#define TRUE -1
#define FALSE 0
#define MAX(a,b) ((a)>(b)?a:b)
#define MIN(a,b) ((a)<(b)?a:b)

void sleep(int msec) { nr_delay(msec); }
int tcpLsnCallback(int plug_handle,void *context,host_32 ip,host_16 port);
int plugsCallback(int plug_handle, void *context, ns_plugs_packet *p, void *payload, int payload_length);

char *inet_ntoa(struct in_addr in)
{
  static char ipstr[32];

  sprintf(ipstr,"%d.%d.%d.%d",
  (u_char)in.S_un.S_un_b.s_b1,
  (u_char)in.S_un.S_un_b.s_b2,
  (u_char)in.S_un.S_un_b.s_b3,
  (u_char)in.S_un.S_un_b.s_b4);

  return ipstr;
}
struct hostent *gethostbyname(const char *hstname)
{
  static struct hostent hst;

  hst.h_name = (char *)hstname;
  hst.h_aliases = 0;
  hst.h_addrtype = AF_INET;
  hst.h_length = 4;
  hst.h_addr = 0;

  return &hst;
}

/*
struct hostent *gethostbyaddr(const char *hstaddr, int hstlen, int hsttype)
{
  static struct hostent hst;
  static char haddr[4];
  char *c;
  int i = 0;

  hst.h_name = (char *)hstaddr;
  hst.h_aliases = 0;
  hst.h_addrtype = hsttype;
  hst.h_length = hstlen;

  for (c=strtok((char *)hstaddr,"."); c != NULL; c=strtok((char *)NULL,".")) // "string.h" needed? grev

  {
    haddr[3-i++] = atoi(c);
  }

  hst.h_addr = haddr;

  return &hst;
}
unsigned long inet_addr (char *cp)
{
  struct hostent *hst = gethostbyaddr(cp,strlen(cp),AF_INET);
  return hst == NULL ? 0 : hst->h_addr;
}
*/

struct hostent *gethostbyaddr(const char *hstaddr, int hstlen, int hsttype)
{
  static struct hostent hst;
  static char haddr[4];
  static char *addr; // SW!! 15.12.03
  char *c;
  int i = 0;
  unsigned long *tmp,tmp1,tmp2;

  hst.h_name = (char *)hstaddr;
  hst.h_aliases = 0;
  hst.h_addrtype = hsttype;
  hst.h_length = hstlen;

  for (c=strtok((char *)hstaddr,"."); c != NULL; c=strtok((char *)NULL,".")) // "string.h" needed? grev
  {
    haddr[i++] = atoi(c);
    if (debuglevel > 0) printf("GHBYADDR %d %d\n", haddr[3-(i-1)], atoi(c) );
  }

  // SW!! 15.12.03
  addr = (char *) &(haddr[0]);
  hst.h_addr_list = (char **) &addr;

  return &hst;
}

unsigned long inet_addr (char *cp)
{
  int len = strlen(cp);
  struct hostent *hst = gethostbyaddr(cp,len,AF_INET);

  unsigned long *data = NULL;

  if (hst != NULL)
  {
    data = (unsigned long *) hst->h_addr;
  }
  return hst == NULL ? 0 : (unsigned long) *data;
}


/*
sck [in] Descriptor identifying a connected socket. 
name [out] The structure that receives the name of the peer. 
namelen [in, out] Pointer to the size of the name structure. 
*/
int getpeername(SOCKET sck,struct sockaddr *name,int *namelen)
{
  int i, cc=0, sckPtr;

  if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK);
  if (namelen == NULL || *namelen < (int)sizeof(struct sockaddr)) ccerr(EINVAL);
  sckPtr = sckPool[sck].sndBufferHead;
  memcpy(name,&sckPool[sck].sckRcvPackets[sckPtr].sckAddr,sizeof(struct sockaddr));
err:
  lastSocketError = cc;
  if (debuglevel) printf("connect : return <%d>\n",cc);
  return cc ? -1 : 0;
}

unsigned short htons (unsigned short n) { return nr_h2n16(n); }
unsigned long htonl (unsigned long n) { return nr_h2n32(n); }
unsigned short ntohs (unsigned short n) { return nr_n2h16(n); }; 
unsigned long  ntohl (unsigned long n) { return nr_n2h32(n); }

int socket(int af, int type, int protocol)
{
 int cc = 0, sck = -1;  
 if (nSckInPool >= MAX_NUM_SCK) ccerr(ENOBUFS);
 sck = nSckInPool++; 
 sckPool[sck].typ = type;
 sckPool[sck].flg = plugs_debuglevel;
 sckPool[sck].sckRcvPackets = NULL; // SW! 15.01.04
 sckPool[sck].sckSndPackets = NULL; // SW! 15.01.04
 sckPool[sck].nrcvready = 0;// SW! 15.01.04
 sckPool[sck].nsndready = 1;// SW! 15.01.04
 sckPool[sck].naccready = 0; // if it's a tcp socket ...

 /* sckPool[sck].sck will get filled in with the nios plug at socketInit() time */

err:
 if (debuglevel) printf("socket : return %d <%d>\n",sck,cc);
 lastSocketError = cc;
 return sck;
}

/* cache the incoming data, sender address, raise a flag for select => move head (head-tail -> flag) */
int plugsCallback(int plug_handle, void *context, ns_plugs_packet *p, void *payload, int payload_length)
{
  int i, cc=0;
  void *tcpheader = p[ne_plugs_tcp].header;
  void *udpheader = p[ne_plugs_udp].header;
  void *ipheader = p[ne_plugs_ip].header;
  unsigned long ip = ((unsigned int *)ipheader)[3];
  unsigned short port; // = ((unsigned short *)udpheader)[0];
  u_char *ipaddrblk = (u_char *)ipheader;
//  udp_status *status = context;				
  net_32 iptosendto;
  net_16 porttosendto;
  int sckPtr;

  if (payload_length > RCVBUF_MTU) ccerr(EMSGSIZE);
  for (i=0; i<nSckInPool && plug_handle != sckPool[i].sck; i++);
  if (i == nSckInPool) ccerr(ENOTSOCK);
//  i = *(int *)context;
//  if (plug_handle != sckPool[i].sck) ccerr(ENOTSOCK);
  if (sckPool[i].nrcvready == sckPool[i].numRcvBuffers) ccerr(ENOBUFS);
  port = (sckPool[i].typ == SOCK_DGRAM) ? ((unsigned short *)udpheader)[0] : ((unsigned short *)tcpheader)[0];
  sckPtr = sckPool[i].rcvBufferHead;
  sckPool[i].nrcvready++;
  sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_family = PF_INET; /* hardwire this */
  sckPool[i].sckRcvPackets[sckPtr].h_addr = ip; // pass it in network order
  sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_port = port; // pass it in network order
  sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_addr.S_un.S_un_b.s_b1 = ipaddrblk[12];
  sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_addr.S_un.S_un_b.s_b2 = ipaddrblk[13];
  sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_addr.S_un.S_un_b.s_b3 = ipaddrblk[14];
  sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_addr.S_un.S_un_b.s_b4 = ipaddrblk[15];
  memset(sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_zero,0,8);

  memcpy(sckPool[i].sckRcvPackets[sckPtr].buf,payload,payload_length);
  sckPool[i].sckRcvPackets[sckPtr].bufMsgSize = payload_length;

  if (debuglevel) printf("sck %d ptr %d plugsCallback from %d.%d.%d.%d:%d %d bytes (iphex=%x)\n",
	  i,sckPtr,ipaddrblk[12],ipaddrblk[13],ipaddrblk[14],ipaddrblk[15],nr_n2h16(port),sckPool[i].sckRcvPackets[sckPtr].bufMsgSize, ip);

  if (sckPool[i].sckRcvPackets[sckPtr].bufMsgSize == 0 && sckPool[i].typ == SOCK_STREAM)  // close it !
  {
    if (debuglevel) printf("close tcp connection for sck %d (plug %d)\n",i,sckPool[i].sck);
    if ((cc=nr_plugs_connect(sckPool[i].sck,0,0,0)) != 0) ccerr(cc);
    if ((cc=nr_plugs_listen(sckPool[i].sck,tcpLsnCallback,&i)) != 0) ccerr(cc);
  }
  sckPool[i].rcvBufferHead = (sckPool[i].rcvBufferHead + 1) % sckPool[i].numRcvBuffers;
err:
  lastSocketError = cc;
  if (debuglevel) printf("plugsCallback : return <%d>\n",cc);
  return cc ? -1 : 0;
}

int socketInit(int sck)
{
  static int done=0;
  int type;
  int cc=0;
  ns_plugs_network_settings network_settings;
  struct sockaddr_in *sa;

  if (!done)
  {
	  if ((cc=nr_plugs_initialize(
		      0, // -> ???? ne_plugs_flag_dhcp, /* important if board uses DHCP !!! */
		      0,
		      __adapter__,
		      __adapter_irq__,
		      __adapter_struct_addr__
       )) != 0) ccerr(cc);
    done = TRUE;
    if (debuglevel) printf("nr_plugs_initialized\n");
  }

  if (sckPool[sck].initialized) return 0;
  switch (sckPool[sck].typ)
  {
    case SOCK_DGRAM:
      type = ne_plugs_udp;
      break;
    case SOCK_STREAM:
      type = ne_plugs_tcp;
      break;
    default:
      ccerr(ENOPROTOOPT);
  }

  if ((cc=nr_plugs_create(
        &sckPool[sck].sck,
        type,
        sckPool[sck].name.sin_port,
        plugsCallback,
        &sck, //&sckPool[sck].sts,
        sckPool[sck].flg
      )) != 0) ccerr(cc);

  if (debuglevel) 
  {
    printf("nr_plugs_create\n");
    printf("sck   : %d\n",sck);
    printf("type  : %d\n",type);
    printf("port  : %d\n",sckPool[sck].name.sin_port);
    printf("plug  : %d\n",sckPool[sck].sck);
    printf("status: %d\n",sckPool[sck].sts);
  }

  if ((type == ne_plugs_udp) && (cc=nr_plugs_connect(
        sckPool[sck].sck,
        0,
        -1, 
        -1
      )) != 0) ccerr(cc);

  sa = (struct sockaddr_in *)&sckPool[sck].name;
  sa->sin_addr.s_addr = network_settings.ip_address;
  memset(sa->sin_zero,0,8);

  sckPool[sck].initialized = TRUE;
  if (debuglevel) printf("done socketInit\n");

err:
  lastSocketError = cc;
  if (cc < 0 && cc > -101) nr_plugs_print_error_message("socketInit",cc);
  if (debuglevel) printf("socketInit : return <%d>\n",cc);
  return cc ? -1 : 0;
}
unsigned short nextFreePort(void)
{
  static unsigned short p = USER_PORT_BASE;
  int i, n;

  for (n=0; n<65535; n++)
  {
    for (i=0; i < nSckInPool && sckPool[i].name.sin_port != p; i++);
    if (i == nSckInPool) return p;
    p++;
  }
  return FALSE;		// 28.10.03, grev
}
int bind(SOCKET s,const struct sockaddr *name, int namelen)
{
  int i, cc=0;
  int optval;
  struct sockaddr_in *sa = (struct sockaddr_in *)name;
  if (s < 0 || s >= nSckInPool) ccerr(ENOTSOCK);

  if (sa == NULL) 
  {
    sckPool[s].name.sin_family  = AF_INET;
    sckPool[s].name.sin_port = nextFreePort();
  }
  else
  {
    /* let's ignore the namelen for now ... */
    if (!(sckPool[s].opt & SO_REUSEADDR))
    {
      for (i=0; i < nSckInPool && sckPool[i].name.sin_port != sa->sin_port; i++);
      if (i < nSckInPool) ccerr(EADDRINUSE);
    }

    sckPool[s].name.sin_addr.s_addr = sa->sin_addr.s_addr;
    sckPool[s].name.sin_family  = sa->sin_family;
    sckPool[s].name.sin_port = ntohs(sa->sin_port);
  }

  /* the port is established, now make sure it's initialized */
  if (!sckPool[s].initialized && (cc=socketInit(s)) != 0) ccerr(cc);

  if (sckPool[s].numRcvBuffers == 0) 
  {
    optval = DEFAULT_RCVBUF_SIZE;
    cc = setsockopt(s,SOL_SOCKET,SO_RCVBUF,(const char *)&optval,sizeof(int));
  }
  if (sckPool[s].numSndBuffers == 0) 
  {
    optval = DEFAULT_SNDBUF_SIZE;
    cc = setsockopt(s,SOL_SOCKET,SO_SNDBUF,(const char *)&optval,sizeof(int));
  }

err:
 lastSocketError = cc;
 if (debuglevel) printf("bind : socket %d return <%d>\n",s,cc);
 return cc ? -1 : 0;
}
  /*
  s 
  [in] Descriptor identifying a socket. 
  level 
  [in] Level at which the option is defined; the supported levels include SOL_SOCKET and IPPROTO_TCP. See the Windows Sockets 2 Protocol-Specific Annex (a separate document included with the Platform SDK) for more information on protocol-specific levels. 
  optname 
  [in] Socket option for which the value is to be set. 
  optval 
  [in] Pointer to the buffer in which the value for the requested option is supplied. 
  optlen 
  [in] Size of the optval buffer. 
  */
int setsockopt(SOCKET s, int level, int optname, const char *optval, int optlen)
{
  int i, n, cc=0;
  if (s < 0 || s >= nSckInPool) ccerr(ENOTSOCK);
  if (level != SOL_SOCKET) ccerr(EOPNOTSUPP);
  switch (optname)
  {
    case SO_RCVBUF:
 //     if (optlen >= sizeof(int)) n = *(int *)optval; else ccerr(EINVAL);
      if ((unsigned)optlen >= sizeof(int)) n = *(int *)optval; else ccerr(EINVAL);	//271003, grev
      if (sckPool[s].sckRcvPackets != NULL) ccerr(EALREADY);
      if ((sckPool[s].sckRcvPackets=(SckPacket *)SystemCalloc(n,sizeof(SckPacket))) == NULL) ccerr(ENOMEM);
      sckPool[s].numRcvBuffers = n;
      break;
    case SO_SNDBUF:
//      if (optlen >= sizeof(int)) n = *(int *)optval; else ccerr(EINVAL);
      if ((unsigned)optlen >= sizeof(int)) n = *(int *)optval; else ccerr(EINVAL);	//271003, grev
      if (sckPool[s].sckSndPackets != NULL) ccerr(EALREADY);
      if ((sckPool[s].sckSndPackets=(SckPacket *)SystemCalloc(n,sizeof(SckPacket))) == NULL) ccerr(ENOMEM);
      sckPool[s].numSndBuffers = n;
      break;
    case SO_REUSEADDR:
//      if (sckPool[s].typ == SOCK_DGRAM) sckPool[s].flg |= ne_plugs_flag_ethernet_all; // kluge!
      break;

    default:
  }
err:
  lastSocketError = cc;
  if (debuglevel) printf("setsockopt : socket %d return <%d>\n",s,cc);
  return cc ? -1 : 0;
}

/*
Parameters
nfds [in] Ignored. The nfds parameter is included only for compatibility with Berkeley sockets. 
readfds [in/out] Optional pointer to a set of sockets to be checked for readability. 
writefds [in/out] Optional pointer to a set of sockets to be checked for writability 
exceptfds [in/out] Optional pointer to a set of sockets to be checked for errors. 
timeout [in] Maximum time for select to wait, provided in the form of a TIMEVAL structure. Set the timeout parameter to NULL for blocking operation. 
*/
int select(int nfds, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, const struct timeval *timeout)
{
  int i, nrd=0, nwrt=0, cc=0;
  fd_set rd, wr;
  int a,b;

  if (debuglevel > 5) printf("select1 readfds=%x writefds = %x excepfds=%x\n", readfds, writefds, exceptfds);

  // SW!! 16.12.03
  // we don't use exceptfds here, so zero them all

  if (readfds != NULL) rd = *readfds;
  if (writefds != NULL) wr = *writefds;

  if (readfds != NULL) FD_ZERO(readfds);//memset( (void *) readfds,0, sizeof(fd_set));
  if (writefds != NULL) FD_ZERO(writefds); //memset( (void *) writefds,0, sizeof(fd_set));
  if (exceptfds != NULL) FD_ZERO(exceptfds); //memset( (void *) exceptfds,0, sizeof(fd_set));

  for (i=0; i<nSckInPool; i++)
  {
     if (debuglevel > 5) printf("select readfds=%x writefds = %x\n", readfds, writefds);
     if (readfds != 0)
     {
       if (FD_ISSET(i,&rd))
       { 
         if (sckPool[i].nrcvready > 0) 
         {
           if (debuglevel > 5) printf("select read sock=%d, nrcvready=%d\n", i, sckPool[i].nrcvready);
           FD_SET(i,readfds);
           nrd++;
         }
       }
     }
     if (writefds != ((void *) 0)) 
     {
       sckPool[i].nsndready = 1; // hard wire this for now
       if (debuglevel > 5) printf("In writefds writefds = %x\n", writefds);
       if (FD_ISSET(i,&wr))
       {
         if (sckPool[i].nsndready > 0) 
         {
           FD_SET(i,writefds);
           nwrt++;
         }
       }
     }
  }
  
err:
  lastSocketError = cc;
  if (debuglevel > 5) printf("select : return <%d>\n",cc);
  if (debuglevel > 5) printf("select : nrd=%d nwrt=%d\n",nrd,nwrt);
  return cc ? -1 : nrd + nwrt;
}
/*
Parameters
s [in] Descriptor identifying a socket. 
cmd [in] Command to perform on the socket s. 
argp [in/out] Pointer to a parameter for cmd. 
*/
int ioctl(SOCKET sck,long cmd, u_long *argp)
{
  int cc=0;
  /* used mostly to set NON-BLOCKING IO */
  
  if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK);
  if (argp == NULL) ccerr(EINVAL);
  if (*argp != 0) sckPool[sck].opt |= cmd; else sckPool[sck].opt &= ~cmd;
err:
  lastSocketError = cc;
  if (debuglevel) printf("soioctl : return <%d>\n",cc);
  return cc ? -1 : 0;
}

/* return socket resources to the pool */
int soclose (int sck)
{
  int i, cc=0;
  /* don't worry about this yet */
  if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK);
  if (sckPool[sck].sck != 0)
  {
    nr_plugs_destroy(sckPool[sck].sck);
    sckPool[sck].sck = 0;
  }
err:
  lastSocketError = cc;
  if (debuglevel) printf("soclose : return <%d>\n",cc);
  return cc ? -1 : 0;
}
/*
Parameters
s        [in] Descriptor identifying a socket that has been placed in a listening 
              state with the listen function. The connection is actually made with 
              the socket that is returned by accept. 
addr    [out] Optional pointer to a buffer that receives the address of the connecting 
              entity, as known to the communications layer. The exact format of the addr 
              parameter is determined by the address family established when the socket 
              was created. 
addrlen [out] Optional pointer to an integer that contains the length of addr. 
*/
int accept(SOCKET sck, struct sockaddr *addr, int *addrlen)
{
  int i=0, cc=0;

  if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK);

  for (i=0; i<nSckInPool; i++)
  {
    if (sckPool[i].tcpparent == sck && sckPool[i].naccready > 0)
    {
      sckPool[i].naccready--;
      ccerr(0);
    }
  }
  if (sckPool[sck].opt & FIONBIO) cc = EWOULDBLOCK;
  /* we're only going to support NON-BLOCKING IO  here (at least for now) */

err:
  lastSocketError = cc;
  if (debuglevel && cc != EWOULDBLOCK) printf("accept : sck %d err <%d>\n",i,cc);
  return cc ? -1 : i;
}

/*
Parameters
sck [in] Descriptor identifying an unconnected socket. 
name [in] Name of the socket to which the connection should be established. 
namelen [in] Length of name. 
*/
int connect(SOCKET sck,const struct sockaddr *name, int namelen)
{
  int i, cc=0;
  struct sockaddr_in *sa = (struct sockaddr_in *)name;
  host_32 ipto;

  if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK);

  if (sckPool[sck].typ != SOCK_STREAM) ccerr(0);

  ipto = nm_ip2h(sa->sin_addr.S_un.S_un_b.s_b1,sa->sin_addr.S_un.S_un_b.s_b2,
                 sa->sin_addr.S_un.S_un_b.s_b3,sa->sin_addr.S_un.S_un_b.s_b4);

  if ((cc=nr_plugs_connect(
        sckPool[sck].sck,
        0,
        ipto, 
        sa->sin_port
      )) != 0) ccerr(cc);

err:
  lastSocketError = cc;
  if (debuglevel) printf("connect : return <%d>\n",cc);
  return cc ? -1 : 0;
}

int tcpLsnCallback(int plug_handle,void *context,host_32 ip,host_16 port)
{
  int i, parent, cc=0;
  u_char *ipaddrblk = (u_char *)&ip;

  for (i=0; i<nSckInPool && plug_handle != sckPool[i].sck; i++);
  if (i == nSckInPool) ccerr(ENOTSOCK);
  parent = sckPool[i].tcpparent;
  sckPool[i].naccready++;

  if (debuglevel) printf("sck %d parent %d tcpLsnCallback from %d.%d.%d.%d:%d (iphex=%x)\n",
	  i,parent,ipaddrblk[0],ipaddrblk[1],ipaddrblk[2],ipaddrblk[3],port, ip);

err:
  lastSocketError = cc;
  if (debuglevel) printf("plugsCallback : return <%d>\n",cc);
  return cc ? -1 : 0;
}

/*
sck     [in] Descriptor identifying a bound, unconnected socket. 
backlog [in] Maximum length of the queue of pending connections. 
             If set to SOMAXCONN, the underlying service provider responsible for 
             socket s will set the backlog to a maximum reasonable value. There is 
             no standard provision to obtain the actual backlog value. 
*/
int listen(SOCKET sck, int backlog)
{
  int i, s=nSckInPool, cc=0;

  if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK);
  sckPool[sck].tcpbacklog = backlog;
  for (i=s; i<s+backlog && i<MAX_NUM_SCK; i++)
  {
    if (!sckPool[i].initialized)
    {
      sckPool[i].name = sckPool[sck].name;
      sckPool[i].typ = sckPool[sck].typ;
      sckPool[i].flg =  sckPool[sck].flg;
      sckPool[i].sckRcvPackets = NULL;
      sckPool[i].sckSndPackets = NULL;
      sckPool[i].nrcvready = 0;
      sckPool[i].nsndready = 1;
      sckPool[i].naccready = 0;
      sckPool[i].name.sin_port = htons(sckPool[i].name.sin_port);
      sckPool[i].opt |= SO_REUSEADDR;
      nSckInPool++;
      if ((cc=bind(i,(struct sockaddr *)&sckPool[i].name,16)) != 0) ccerr(cc);
    }
    sckPool[i].tcpparent = sck;
    if ((cc=nr_plugs_listen(sckPool[i].sck,tcpLsnCallback,&sck)) != 0) ccerr(cc);
  }
err:
  lastSocketError = cc;
  if (debuglevel) printf("listen (%d, %d): return <%d>\n",sck,backlog,cc);
  if (cc < 0 && cc > -101) nr_plugs_print_error_message("listen",cc);
  return cc ? -1 : 0;
}
/*
socket  [in] A descriptor identifying a bound socket. 
buf     [out] A buffer for the incoming data. 
len     [in] The length of buf. 
flags   [in] An indicator specifying the way in which the call is made. 
from    [out] An optional pointer to a buffer that will hold the source address upon return. 
fromlen [in/out] An optional pointer to the size of the from buffer. 
*/
int recvfrom(int sck, char *buf, int len, int flags, struct sockaddr *from, int *fromlen)
{
  int sckPtr, plen, cc=0;
  int bytesread=0;
  if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK);

  if (!sckPool[sck].initialized)
  {
    /* if it's not initialized yet, then I haven't bound it ! */
    if ((cc=bind(sck,NULL,0)) != 0) ccerr(cc);
  }
  if (sckPool[sck].nrcvready > 0)
  {
    sckPool[sck].nrcvready--;
    sckPtr = sckPool[sck].rcvBufferTail;
    plen = MIN(len,sckPool[sck].sckRcvPackets[sckPtr].bufMsgSize);
    if (debuglevel > 1)
      printf("sck %d ptr %d recvfrom %d bytes (min of %d and %d)\n",
              sck,sckPtr,plen,len,sckPool[sck].sckRcvPackets[sckPtr].bufMsgSize);
    memcpy(buf,sckPool[sck].sckRcvPackets[sckPtr].buf,plen);
    if (fromlen != (int *)NULL && (unsigned)(*fromlen) < sizeof(struct sockaddr_in)) ccerr(ENOBUFS);	//271003, grev
    if (from != NULL) *from = *(struct sockaddr *)&sckPool[sck].sckRcvPackets[sckPtr].sckAddr;
    sckPool[sck].rcvBufferTail = (sckPool[sck].rcvBufferTail + 1) % sckPool[sck].numRcvBuffers;
    bytesread = plen;
  }
  else
  {
    if (sckPool[sck].opt & FIONBIO) cc = EWOULDBLOCK;
    /* we're only going to support NON-BLOCKING IO  here (at least for now) */
  }
  
err:
  lastSocketError = cc;
  if (debuglevel) printf("recvfrom : bytes %d return <%d>\n",bytesread,cc);
  return cc ? -1 : bytesread;
}
/*
socket  [in] A descriptor identifying a socket. 
buf     [in] A buffer containing the data to be transmitted. 
len     [in] The length of the data in buf. 
flags   [in] An indicator specifying the way in which the call is made. 
to      [in] An optional pointer to the address of the target socket. 
tolen   [in] The size of the address in to. 
*/
int sendto (int sck, char *buf, int len, int flags, struct sockaddr *to, int tolen)
{
  int sckPtr, cc=0;
  int bytessent=0;
  u_long ipto;
  struct sockaddr_in *sa = (struct sockaddr_in *)to;
 
  if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK);

  if (!sckPool[sck].initialized)
  {
    /* if it's not initialized yet, then I haven't bound it ! */
    if ((cc=bind(sck,NULL,0)) != 0) ccerr(cc);
  }

  sckPtr = sckPool[sck].sndBufferHead = (sckPool[sck].sndBufferHead + 1) % sckPool[sck].numSndBuffers;
  if (sa == NULL) sa = &sckPool[sck].sckRcvPackets[sckPtr].sckAddr;
  ipto = nr_h2n32(nm_ip2h(sa->sin_addr.S_un.S_un_b.s_b1,sa->sin_addr.S_un.S_un_b.s_b2,
                          sa->sin_addr.S_un.S_un_b.s_b3,sa->sin_addr.S_un.S_un_b.s_b4));

  /*
    future: this should go into a send queue which gets checked regularly.
            the tail should be incremented following a successful send
            and the head shouldn't be incremented unless there's room
    Right now, we're just sending it out as it comes and hoping for the best ...
  */
  if (debuglevel > 1)
  {
    printf("send to %d.%d.%d.%d:%d (%x %d) on socket %d (plug %d)\n",
            (u_char)sa->sin_addr.S_un.S_un_b.s_b1,
            (u_char)sa->sin_addr.S_un.S_un_b.s_b2,
            (u_char)sa->sin_addr.S_un.S_un_b.s_b3,
            (u_char)sa->sin_addr.S_un.S_un_b.s_b4,
            nr_n2h16(sa->sin_port),
            ipto, 
            nr_n2h16(sa->sin_port),
            sck,
            sckPool[sck].sck);
  }
  sckPool[sck].sndBufferTail = sckPool[sck].sndBufferHead;
  switch (sckPool[sck].typ)
  {
    case SOCK_DGRAM:
      if ((cc=nr_plugs_send_to( 
            sckPool[sck].sck,
            buf,
            len,
            plugs_debuglevel, 
            ipto,
            sa->sin_port
          )) == 0) bytessent = len;
      break;
    case SOCK_STREAM:
      if ((cc=nr_plugs_send( 
            sckPool[sck].sck,
            buf,
            len,
            plugs_debuglevel
          )) == 0) bytessent = len;
      break;
    default:
      ccerr(ENOPROTOOPT);
  }
err:
  if (cc) nr_plugs_print_error_message("send_to",cc);
  if (debuglevel) printf("sendto : bytes %d return <%d>\n",bytessent,cc);
  lastSocketError = cc;
  return cc ? -1 : bytessent;
}
