// UCOS version
//#include "project.def"
#include <stdio.h>
#include <stdlib.h>
#include "includes.h"
//#include "ucosii/devices.h"
//#include "alt_lwip_dev"
#include <string.h>
#include "socket.h"
#include "lwip/tcpip.h"
#include "lwip/inet.h"
#include "lwip/tcp.h"
#include "lwip/udp.h"
#include <fcntl.h>
#include "lwip/mem.h"
#include "lwip/sys.h"
//#include "lwip/ip_addr.h"
//#include <os_cpu.h>
//#include <os_cfg.h>
//#include <ucos_ii.h>
#include "user.h"



int bsd_debuglevel = 4;
int lwip_debuglevel = 0; // debug level of lwip
SckMemPool sckPool[MAX_NUM_SCK];
int nSckInPool = 0;
int lastSocketError = 0;
int tcp_timer_start = 0;
#define ccerr(i) { cc=i; goto err; }
//#define TRUE -1
//#define FALSE 0
#define MAX(a,b) ((a)>(b)?a:b)
#define MIN(a,b) ((a)<(b)?a:b)
//void doLWIPInit();
OS_EVENT *socksem;
//static sys_mbox_t sembox;
OS_EVENT *mboxsem;
OS_EVENT *mboxevent;

void sleep(int msec) 
{ 
  INT8U  lsec =  (INT8U)  (msec / 1000) % 60;
  INT16U lmsec = (INT16U) (msec % 1000);
  INT8U  lmin =  (INT8U)  (((msec / 1000) / 60) % 60);
  INT8U  lhour = (INT8U)  (((msec / 1000) / 60) / 60);

  OSTimeDlyHMSM(lhour,lmin,lsec,lmsec);
}


// SW! added function
unsigned long makeIP(int a, int b, int c, int d)
{
 return( ((a&0xFF)<<24) + ((b&0xFF)<<16) +((c&0xFF)<<8) + (d&0xFF) );
}

// SW! does not do dns lookup since lwip does not support it, only IP adresses are supported
struct hostent *gethostbyname(const char *hstname)
{
  static struct hostent hst;
  struct hostent *phst;
  static char hstbuf[128];

  strncpy(hstbuf,hstname,128);
  if ((phst=gethostbyaddr(hstbuf, strlen(hstbuf), AF_INET)) != NULL) return phst;
  hst.h_name = (char *)hstname;
  hst.h_aliases = 0;
  hst.h_addrtype = AF_INET;
  hst.h_length = strlen(hstname);
  hst.h_addr = 0;

  return &hst;
}

struct hostent *gethostbyaddr(const char *hstaddr, int hstlen, int hsttype)
{
  static struct hostent hst;
  static char haddr[4];
  static char *addr; // SW!! 15.12.03
  char *c;
  int i = 0;
  unsigned long *tmp,tmp1,tmp2;

  hst.h_name = (char *)hstaddr;
  hst.h_aliases = 0;
  hst.h_addrtype = hsttype;
  hst.h_length = hstlen;

  for (c=strtok((char *)hstaddr,"."); c != NULL; c=strtok((char *)NULL,".")) // "string.h" needed? grev
  {
    haddr[i++] = atoi(c);
    if (bsd_debuglevel > 4) printf("GHBYADDR %d %d\n", haddr[3-(i-1)], atoi(c) );
  }

  // SW!! 15.12.03
  addr = (char *) &(haddr[0]);
  hst.h_addr_list = (char **) &addr;

  return &hst;
}


/*
sck [in] Descriptor identifying a connected socket. 
name [out] The structure that receives the name of the peer. 
namelen [in, out] Pointer to the size of the name structure. 
*/

int getpeername(SOCKET sck,struct sockaddr *name,int *namelen)
{
  int i, cc=0, sckPtr;

  if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK);
  if (namelen == NULL || *namelen < (int)sizeof(struct sockaddr)) ccerr(EINVAL);
  sckPtr = sckPool[sck].rcvBufferTail;
  // back up one, because we've already moved the tail ...
  sckPtr = (sckPtr - 1 + sckPool[sck].numRcvBuffers) % sckPool[sck].numRcvBuffers;
  memcpy(name,&sckPool[sck].sckRcvPackets[sckPtr].sckAddr,sizeof(struct sockaddr));
err:
  lastSocketError = cc;
  if (bsd_debuglevel) printf("getpeername : return <%d>\n",cc);
  return cc ? -1 : 0;
}


int socket(int af, int type, int protocol)
{
 int i, cc = 0, sck = -1;  
 INT8U err;
      if (!socksem)
        socksem = OSSemCreate(1);
        
      OSSemPend(socksem, 0, &err);  
 if (nSckInPool >= MAX_NUM_SCK) ccerr(ENOBUFS);
 for (i=0; i<MAX_NUM_SCK && sckPool[i].sts != SOCK_ISAVAILABLE; i++);
 if  ( i == MAX_NUM_SCK)ccerr(ENOBUFS); 

 sck = i;
 sckPool[sck].sckRcvPackets = NULL; // SW! 15.01.04
 sckPool[sck].sckSndPackets = NULL; // SW! 15.01.04
 sckPool[sck].sts = 0;
 sckPool[sck].initialized = 0;
 sckPool[sck].typ = type;
 sckPool[sck].flg = 0;
 sckPool[sck].nrcvready = 0;// SW! 15.01.04
 sckPool[sck].nsndready = 1;// SW! 15.01.04
 sckPool[sck].naccready = 0; // if it's a tcp socket ...
 sckPool[sck].tcpparent = -1; // SW! 22.04.04 must not be '0' // if it's a tcp socket ...
 sckPool[sck].numSndBuffers = 0;
 sckPool[sck].numRcvBuffers = 0;
 sckPool[sck].sent_pending = 0;

  nSckInPool++; 

 // sckPool[sck].sck will get filled in with the nios plug at socketInit() time

err:
  OSSemPost(socksem);
 if (bsd_debuglevel) printf("socket : return %d <%d>\n",sck,cc);
 lastSocketError = cc;
 return sck;
}

// SW! added function

void lwipUDPCallback( void *arg, struct udp_pcb *upcb, struct pbuf *p, struct ip_addr *addr, u16_t port)
{
  int i, cc=0;
  int sckPtr;
  char err;
  void *payload;
  int payload_length;
  
  for (i=0; i<MAX_NUM_SCK; i++)
  {
   if (upcb == sckPool[i].udppcb) break;
  }
  if (i == MAX_NUM_SCK) ccerr(ENOTSOCK);
  if (sckPool[i].nrcvready == sckPool[i].numRcvBuffers) ccerr(ENOBUFS);

  payload = p->payload; // SW! 17.11.03
  payload_length = p->len; // SW! 17.11.03
  if (payload_length > RCVBUF_MTU) ccerr(EMSGSIZE);
   
     if (!mboxevent)
        mboxevent = OSMboxCreate((void*)0); 
        
         
  sckPtr = sckPool[i].rcvBufferHead;

  if (bsd_debuglevel>2) printf("sck %d ptr %d udpCallback from %d.%d.%d.%d:%d %d  (%x %x %d)bytes\n",
	  i,sckPtr,(addr->addr)&0xFF,(addr->addr >> 8)&0xFF,(addr->addr >> 16)&0xFF,(addr->addr >> 24)&0xFF,port,
          sckPool[i].sckRcvPackets[sckPtr].bufMsgSize, htonl(addr->addr), addr->addr, port);

  sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_family = PF_INET; // hardwire this
  sckPool[i].sckRcvPackets[sckPtr].h_addr = addr->addr;
  sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_port = htons(port);
  addr->addr = htonl( addr->addr );
  sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_addr.s_addr = htonl( addr->addr );
  memset(sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_zero,0,8);

  if (payload_length > 0)
  {
    memcpy(sckPool[i].sckRcvPackets[sckPtr].buf,payload,payload_length);
    sckPool[i].sckRcvPackets[sckPtr].bufMsgSize = payload_length;
    sckPool[i].nrcvready++;
    sckPool[i].rcvBufferHead = (sckPool[i].rcvBufferHead + 1) % sckPool[i].numRcvBuffers;
  }
  else 
  {
    if (bsd_debuglevel && sckPool[i].typ == SOCK_DGRAM) printf("no payload ! (%d)\n",payload_length);
    sckPool[i].sckRcvPackets[sckPtr].bufMsgSize = 0;
  }

   err = pbuf_free( p );
   OSMboxPost(mboxevent,(void*)1);
   if (bsd_debuglevel > 2) printf("pbuf_free UDPcallb %d\n", err);
 
err:
  lastSocketError = cc;
  if (bsd_debuglevel>2) printf("plugsCallback : return <%d>\n",cc);

}

err_t lwipTCPSentCallback( void *arg, struct tcp_pcb *tcpb, u16_t len)
{
 int i;
 int cc=0;

 if (len > 0) len--;
 
 if (bsd_debuglevel>2) printf("lwipTCPSentCallback called: arg=%d tcpb=%x len=%d\n", arg, tcpb, len);
 
 i = (int) arg;
 if (i < 0 || i >= MAX_NUM_SCK) ccerr(ENOTSOCK);

 sckPool[i].sent_pending -= len;
 if (sckPool[i].sent_pending < 0) 
 {
  sckPool[i].sent_pending = 0;
  if (bsd_debuglevel>2) printf("lwipTCPSentCallback: len subtracts to less than zero in total!!!\n");
 }  

err:
 if (cc != 0 && bsd_debuglevel) printf("lwipTCPSentCallback return %d\n", cc);
 return ERR_OK;
}

void lwipTCPErrorCallback( void *arg, err_t error)
{
 int cc=0,i;
 
 if (bsd_debuglevel > 2) printf("lwipTCPErrCallback called: arg=%d error=%d\n", arg, error);
 
 i = (int) arg;
 if (i < 0 || i >= MAX_NUM_SCK) ccerr(ENOTSOCK);
  
 switch( error )
 {
   case ERR_MEM: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_MEM happened on socket %d\n", i);
                 break;

   case ERR_BUF: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_BUF happened on socket %d\n", i);
                 break;
   case ERR_ABRT: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_ABRT happened on socket %d\n", i);
                 break;
   case ERR_RST: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_RST happened on socket %d\n", i);
                 break;
   case ERR_CLSD: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_CLSD happened on socket %d\n", i);
                 break;
   case ERR_CONN: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_CONN happened on socket %d\n", i);
                 break;
   case ERR_VAL: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_VAL happened on socket %d\n", i);
                 break;
   case ERR_ARG: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_ARG happened on socket %d\n", i);
                 break;

   case ERR_RTE: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_RTE happened on socket %d\n", i);
                 break;
   case ERR_USE: if (bsd_debuglevel) printf("lwipTCPErrCallback: ERR_USE happened on socket %d\n", i);
                 break;
 
   default: if (bsd_debuglevel) printf("lwipTCPErrCallback: illegal error code on socket %d\n",i);
            ccerr(-1);
            break;
 } 

 if (error == ERR_RST || error == ERR_ABRT || error == ERR_CLSD)
 {
      // close socket by aborting tcp transfer
      if (bsd_debuglevel>2) printf("lwipTCPErrCallb: close tcp connection for sck %d\n",i);
      if (sckPool[i].nrcvready) 
      {
        sckPool[i].sts = SOCK_CLOSEDWITHDATA;
        if (bsd_debuglevel) printf("lwipTCPErrCallb: socket closed with pending data\n");
      }
      if (sckPool[i].sts != SOCK_CLOSEDWITHDATA) sckPool[i].sts = 0;
      //soclose(i);
 }

err:
 lastSocketError = cc;
 if (bsd_debuglevel>2) printf("lwipTCPErrCallback : return <%d>\n",cc);
}


err_t lwipTCPCallback( void *arg, struct tcp_pcb *tcpb, struct pbuf *p, err_t errcb)
{
  void *payload;
  int payload_length;
  int i;
  err_t errcls;
  struct ip_addr ip;
  unsigned short port;
  int cc=0;
  int sckPtr;
  
  if (bsd_debuglevel > 2) printf("lwipTCPCallback: started\n");
  
  i = (int) arg;
  if (i < 0 || i >= MAX_NUM_SCK) ccerr(ENOTSOCK);
  
   if (!mboxevent)
     mboxevent = OSMboxCreate((void*)0);  
              
  
  if (p == NULL)
  {
      if (bsd_debuglevel) printf("lwipTCPCallback: close tcp connection for sck %d (tcppcb %x)\n",i,sckPool[i].tcppcb);
      if (sckPool[i].nrcvready) 
      {
       //vahan
       sleep(250);
       if (sckPool[i].nrcvready){
        sckPool[i].sts = SOCK_CLOSEDWITHDATA;
        if (bsd_debuglevel) printf("lwipTCPCallback: socket closed with pending data\n");
       }
      }

        if (bsd_debuglevel) printf("lwipTCPCallback: close tcp socket\n");
        
//        tcp_recv(sckPool[i].tcppcb, NULL);
//        tcp_err( sckPool[i].tcppcb, NULL );
//        tcp_sent( sckPool[i].tcppcb, NULL );
//        tcp_accept( sckPool[i].tcppcb, NULL);
//                
//        errcls = tcp_close( sckPool[i].tcppcb );
//        if (errcls != ERR_OK) tcp_abort( sckPool[i].tcppcb );
//        if (sckPool[i].sts != SOCK_CLOSEDWITHDATA) sckPool[i].sts = SOCK_ISAVAILABLE;
       // if (sckPool[i].sts != SOCK_ISAVAILABLE) soclose(i);
  }
  else
  {
    payload = p->payload; // SW! 17.11.03
    payload_length = p->len; // SW! 17.11.03

    if (payload_length > RCVBUF_MTU) printf("!!! SEVERE pll=%d\n", payload_length);

    if (sckPool[i].nrcvready == sckPool[i].numRcvBuffers) ccerr(ENOBUFS);
  
    port = sckPool[i].remote_tcp.sin_port = tcpb->remote_port;
    ip = tcpb->remote_ip;
    memcpy( &(sckPool[i].remote_tcp.sin_addr.s_addr), &tcpb->remote_ip, sizeof(struct ip_addr) );

    sckPtr = sckPool[i].rcvBufferHead;
    sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_family = AF_INET; // hardwire this 
    sckPool[i].sckRcvPackets[sckPtr].h_addr = sckPool[i].remote_tcp.sin_addr.s_addr; // pass it in network order
    sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_port = port; // pass it in network order
    sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_addr = sckPool[i].remote_tcp.sin_addr;    

    memset(sckPool[i].sckRcvPackets[sckPtr].sckAddr.sin_zero,0,8);

    if (bsd_debuglevel > 2) printf("lwipTCPCallback: payload_length=%d, sckPtr=%d, sckPool[i].sckRcvPackets = %x sckPool[i].sckRcvPackets[sckPtr]=%x payload=%x from host:%s\n", payload_length, sckPtr, sckPool[i].sckRcvPackets, sckPool[i].sckRcvPackets[sckPtr], payload, inet_ntoa(sckPool[i].remote_tcp.sin_addr));

    if (payload_length > 0)
    {
      memcpy(sckPool[i].sckRcvPackets[sckPtr].buf,payload,payload_length);
      sckPool[i].sckRcvPackets[sckPtr].bufMsgSize = payload_length;
      sckPool[i].nrcvready++;
      sckPool[i].rcvBufferHead = (sckPool[i].rcvBufferHead + 1) % sckPool[i].numRcvBuffers;
    }
    else 
    {
      if (bsd_debuglevel && sckPool[i].typ == SOCK_STREAM) printf("no payload on sock_stream ! (%d)\n",payload_length);
      sckPool[i].sckRcvPackets[sckPtr].bufMsgSize = 0;
    }

    tcp_recved( sckPool[i].tcppcb, payload_length );
    
      OSMboxPost(mboxevent,(void*)1);

    if (bsd_debuglevel>2) printf("sck %d ptr %d lwipTCPCallback %d bytes\n",
	  i,sckPtr,sckPool[i].sckRcvPackets[sckPtr].bufMsgSize);
  }
err:

  if (p != NULL) pbuf_free(p);

  lastSocketError = cc;
  if (bsd_debuglevel>2) printf("lwipTCPCallback : return <%d>\n",cc);
  return ERR_OK;
}




int socketInit(int sck)
{
  int optval;
  int type;
  int cc=0;
  struct sockaddr_in *sa;

  if (sckPool[sck].initialized) return 0;
  switch (sckPool[sck].typ)
  {
    case SOCK_DGRAM:
      sckPool[sck].udppcb = udp_new();
      if (sckPool[sck].udppcb == NULL)
      {
       if (bsd_debuglevel) printf("Error alloc udp_pcb in socketInit\n");
       ccerr(ENOMEM);
      }
      //printf("UDP Receive\n"); 
      udp_recv(sckPool[sck].udppcb, lwipUDPCallback, &sckPool[sck].sts);
      //type = ne_plugs_udp;
      break;
    case SOCK_STREAM:
      sckPool[sck].tcppcb = tcp_new();
      if (sckPool[sck].tcppcb == NULL)
      {
       if (bsd_debuglevel) printf("Error alloc tcp_pcb in socketInit\n");
       ccerr(ENOMEM);
      }
      tcp_arg(sckPool[sck].tcppcb, (void *) sck);
      tcp_recv(sckPool[sck].tcppcb, lwipTCPCallback);
      tcp_err( sckPool[sck].tcppcb, lwipTCPErrorCallback );
      tcp_sent( sckPool[sck].tcppcb, lwipTCPSentCallback );

      //type = ne_plugs_tcp;
      break;
    default:
      ccerr(ENOPROTOOPT);
      break;
  }

  sa = (struct sockaddr_in *)&sckPool[sck].name;
  sa->sin_addr.s_addr = htonl(makeIP(IPADDR0, IPADDR1, IPADDR2, IPADDR3));
  
  //SW!!!
  
 // printf("socketInit !!!!!!!!!!!!!!!!!!!!!!! %xh port:%d\n", sa->sin_addr.s_addr,sa->sin_port );
  
  //SW!!!
  memset(sa->sin_zero,0,8);

  if (sckPool[sck].numRcvBuffers == 0) 
  {
    optval = DEFAULT_RCVBUF_SIZE;
    setsockopt(sck,SOL_SOCKET,SO_RCVBUF,(const char *)&optval,sizeof(int));
  }
  if (sckPool[sck].numSndBuffers == 0) 
  {
    optval = DEFAULT_SNDBUF_SIZE;
    setsockopt(sck,SOL_SOCKET,SO_SNDBUF,(const char *)&optval,sizeof(int));
  }

  sckPool[sck].initialized = TRUE;

err:
  lastSocketError = cc;
  if (bsd_debuglevel) printf("socketInit : return <%d>\n",cc);
  return cc ? -1 : 0;
}


unsigned short nextFreePort(void)
{
  static unsigned short p = USER_PORT_BASE;
  int i, n;

  for (n=0; n<65535; n++)
  {
    for (i=0; i < MAX_NUM_SCK && sckPool[i].name.sin_port != p; i++);
    if (i == MAX_NUM_SCK) return p;
    p++;
  }
  return FALSE;		// 28.10.03, grev
}


int bind(SOCKET s,const struct sockaddr *name, int namelen)
{
  int i, cc=0;
  err_t binderr;
  struct sockaddr_in *sa = (struct sockaddr_in *)name;
  if (s < 0 || s >= MAX_NUM_SCK) ccerr(ENOTSOCK);

  if (sa == NULL) 
  {
    sckPool[s].name.sin_family  = AF_INET;
    sckPool[s].name.sin_port = nextFreePort(); //vahan
    sckPool[s].name.sin_addr.s_addr = htonl(makeIP(IPADDR0, IPADDR1, IPADDR2, IPADDR3));
  }
  else
  {
    // let's ignore the namelen for now ...
    if (!(sckPool[s].opt & SO_REUSEADDR))
    {
      for (i=0; i < nSckInPool && sckPool[i].name.sin_port != sa->sin_port; i++);
      if (i < nSckInPool) ccerr(EADDRINUSE);
    }
    if ( sa->sin_addr.s_addr == 0 ) sa->sin_addr.s_addr = htonl(makeIP(IPADDR0, IPADDR1, IPADDR2, IPADDR3));
     
    sckPool[s].name.sin_addr.s_addr = sa->sin_addr.s_addr;
    sckPool[s].name.sin_family  = sa->sin_family;
    sckPool[s].name.sin_port = sa->sin_port;
    
  }

  // the port is established, now make sure it's initialized
  if (!sckPool[s].initialized && (cc=socketInit(s)) != 0) ccerr(cc);

  switch (sckPool[s].typ)
  {
    case SOCK_DGRAM:
           // bind the port 
            binderr = udp_bind(sckPool[s].udppcb, (struct ip_addr *) &(sckPool[s].name.sin_addr.s_addr), ntohs(sckPool[s].name.sin_port));
 
      break;
    case SOCK_STREAM:
           binderr = tcp_bind( sckPool[s].tcppcb, (struct ip_addr *) &(sckPool[s].name.sin_addr.s_addr), ntohs(sckPool[s].name.sin_port));
      break;
    default:
      ccerr(ENOPROTOOPT);
      break;
  }
  
  if (binderr != ERR_OK) ccerr(binderr);

err:
 lastSocketError = cc;
 if (bsd_debuglevel) printf("bind : socket %d return <%d>\n",s,cc);
 return cc ? -1 : 0;
}

  /*
  s 
  [in] Descriptor identifying a socket. 
  level 
  [in] Level at which the option is defined; the supported levels include SOL_SOCKET and IPPROTO_TCP. See the Windows Sockets 2 Protocol-Specific Annex (a separate document included with the Platform SDK) for more information on protocol-specific levels. 
  optname 
  [in] Socket option for which the value is to be set. 
  optval 
  [in] Pointer to the buffer in which the value for the requested option is supplied. 
  optlen 
  [in] Size of the optval buffer. 
  */

int setsockopt(SOCKET s, int level, int optname, const char *optval, int optlen)
{
  int i, n, cc=0;
  if (s < 0 || s >= MAX_NUM_SCK) ccerr(ENOTSOCK);
  if (level != SOL_SOCKET) ccerr(EOPNOTSUPP);
  switch (optname)
  {
    case SO_RCVBUF:
 //     if (optlen >= sizeof(int)) n = *(int *)optval; else ccerr(EINVAL);
      if ((unsigned)optlen >= sizeof(int)) n = *(int *)optval; else ccerr(EINVAL);	//271003, grev
      if (sckPool[s].sckRcvPackets != NULL) ccerr(EALREADY);
      if ((sckPool[s].sckRcvPackets=(SckPacket *)SystemCalloc(n,sizeof(SckPacket))) == NULL) ccerr(ENOMEM);
      sckPool[s].numRcvBuffers = n;
      break;
    case SO_SNDBUF:
//      if (optlen >= sizeof(int)) n = *(int *)optval; else ccerr(EINVAL);
      if ((unsigned)optlen >= sizeof(int)) n = *(int *)optval; else ccerr(EINVAL);	//271003, grev
      if (sckPool[s].sckSndPackets != NULL) ccerr(EALREADY);
      if ((sckPool[s].sckSndPackets=(SckPacket *)SystemCalloc(n,sizeof(SckPacket))) == NULL) ccerr(ENOMEM);
      sckPool[s].numSndBuffers = n;
      break;
    case SO_REUSEADDR:
//      if (sckPool[s].typ == SOCK_DGRAM) sckPool[s].flg |= ne_plugs_flag_ethernet_all; // kluge!
      break;
    default:
      break;
  }
err:
  lastSocketError = cc;
  if (bsd_debuglevel) printf("setsockopt sizeof(sckpacket)=%d: socket %d return <%d>\n",sizeof(SckPacket),s,cc);
  return cc ? -1 : 0;
}

/*
Parameters
nfds [in] Ignored. The nfds parameter is included only for compatibility with Berkeley sockets. 
readfds [in/out] Optional pointer to a set of sockets to be checked for readability. 
writefds [in/out] Optional pointer to a set of sockets to be checked for writability 
exceptfds [in/out] Optional pointer to a set of sockets to be checked for errors. 
timeout [in] Maximum time for select to wait, provided in the form of a TIMEVAL structure. Set the timeout parameter to NULL for blocking operation. 
*/

int select(int nfds, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, const struct timeval *timeout)
{
  int i, nrd=0, nwrt=0, cc=0, retries=0;
  fd_set rd, wr;
  int a,b;
  INT8U err;
  u32_t msectimeout;
 u32_t start = 0, end = 0; 
 
  if (bsd_debuglevel > 5) printf("select1 readfds=%x writefds = %x excepfds=%x\n", readfds, writefds, exceptfds);

  // SW!! 16.12.03
  // we don't use exceptfds here, so zero them all

  if (readfds != NULL) rd = *readfds;
  if (writefds != NULL) wr = *writefds;

  if (readfds != NULL) FD_ZERO(readfds);//memset( (void *) readfds,0, sizeof(fd_set));
  if (writefds != NULL) FD_ZERO(writefds); //memset( (void *) writefds,0, sizeof(fd_set));
  if (exceptfds != NULL) FD_ZERO(exceptfds); //memset( (void *) exceptfds,0, sizeof(fd_set));

 //printf("select readfds=%d writefds = %d timeout = %dsec %dusec\n", *readfds, *writefds, timeout->tv_sec,timeout->tv_usec);
 
// retry:
 
       if (!socksem)
        socksem = OSSemCreate(1);
        
      OSSemPend(socksem, 0, &err);  
  for (i=0; i<MAX_NUM_SCK; i++)
  {
     if (bsd_debuglevel > 5) printf("select readfds=%x writefds = %x\n", readfds, writefds);
     if (readfds != 0)
     {
       if (FD_ISSET(i,&rd))
       { 
         if (sckPool[i].nrcvready > 0 || sckPool[i].naccready > 0) 
         {
           if (bsd_debuglevel > 5) printf("select read sock=%d, nrcvready=%d naccready=%d\n", i, sckPool[i].nrcvready, sckPool[i].naccready);
           FD_SET(i,readfds);
           nrd++;
         }
       }
     }
     if (writefds != ((void *) 0)) 
     {
       sckPool[i].nsndready = 1; // hard wire this for now
       if (bsd_debuglevel > 5) printf("In writefds writefds = %x\n", writefds);
       if (FD_ISSET(i,&wr))
       {
         if (sckPool[i].nsndready > 0) 
         {
           FD_SET(i,writefds);
           nwrt++;
         }
       }
     }
  }
  OSSemPost(socksem);
  //vahan
  
//       if(!(nrd+nwrt) && !retries){
//        if (timeout && timeout->tv_sec == 0 && timeout->tv_usec == 0){
//                 ccerr(0);
//                }
//             if (!mboxevent)
//         mboxevent = OSMboxCreate((void*)0);  
//              
//        if (timeout == 0)
//            /* Wait forever */
//            msectimeout = 0;
//        else
//            msectimeout =  ((timeout->tv_sec * 1000) + ((timeout->tv_usec + 500)/1000));
//printf("timeout = %d\n", msectimeout);
//start = OSTimeGet();
//        OSMboxPend(mboxevent, msectimeout,&err);
//end =  OSTimeGet();
//printf("timeout = %d timeout_was = %d\n", msectimeout, (end - start));
//    
//        if  (err == OS_TIMEOUT) {
//             ccerr(0);
//            }
//        retries++;
//        goto retry;
//         
//        }
     
err:
  lastSocketError = cc;
  if (bsd_debuglevel > 5) printf("select : return <%d>\n",cc);
  if (bsd_debuglevel > 5) printf("select : nrd=%d nwrt=%d\n",nrd,nwrt);
  return cc ? -1 : nrd + nwrt;
}
/*
int select(int nfds, fd_set *readfds, fd_set *writefds, fd_set *exceptfds, const struct timeval *timeout)
{
  int i, nrd=0, nwrt=0, cc=0;
  fd_set rd, wr;
  int a,b;

  if (bsd_debuglevel > 5) printf("select1 readfds=%x writefds = %x excepfds=%x\n", readfds, writefds, exceptfds);

  // SW!! 16.12.03
  // we don't use exceptfds here, so zero them all

  if (readfds != NULL) rd = *readfds;
  if (writefds != NULL) wr = *writefds;

  if (readfds != NULL) FD_ZERO(readfds);//memset( (void *) readfds,0, sizeof(fd_set));
  if (writefds != NULL) FD_ZERO(writefds); //memset( (void *) writefds,0, sizeof(fd_set));
  if (exceptfds != NULL) FD_ZERO(exceptfds); //memset( (void *) exceptfds,0, sizeof(fd_set));

  for (i=0; i<nSckInPool; i++)
  {
     if (bsd_debuglevel > 5) printf("select readfds=%x writefds = %x\n", readfds, writefds);
     if (readfds != 0)
     {
       if (FD_ISSET(i,&rd))
       { 
         if (sckPool[i].nrcvready > 0 || sckPool[i].naccready > 0) 
         {
           if (bsd_debuglevel > 5) printf("select read sock=%d, nrcvready=%d naccready=%d\n", i, sckPool[i].nrcvready, sckPool[i].naccready);
           FD_SET(i,readfds);
           nrd++;
         }
       }
     }
     if (writefds != ((void *) 0)) 
     {
       sckPool[i].nsndready = 1; // hard wire this for now
       if (bsd_debuglevel > 5) printf("In writefds writefds = %x\n", writefds);
       if (FD_ISSET(i,&wr))
       {
         if (sckPool[i].nsndready > 0) 
         {
           FD_SET(i,writefds);
           nwrt++;
         }
       }
     }
  }
  
err:
  lastSocketError = cc;
  if (bsd_debuglevel > 5) printf("select : return <%d>\n",cc);
  if (bsd_debuglevel > 5) printf("select : nrd=%d nwrt=%d\n",nrd,nwrt);
  return cc ? -1 : nrd + nwrt;
}*/
/*
Parameters
s [in] Descriptor identifying a socket. 
cmd [in] Command to perform on the socket s. 
argp [in/out] Pointer to a parameter for cmd. 
*/

int ioctlsck(SOCKET sck,long cmd, u_long *argp)
{
  int cc=0;
  // used mostly to set NON-BLOCKING IO

  if (sck < 0 || sck >= MAX_NUM_SCK) ccerr(ENOTSOCK);
  if (argp == NULL) ccerr(EINVAL);
  if (*argp != 0) sckPool[sck].opt |= cmd; else sckPool[sck].opt &= ~cmd;
err:
  lastSocketError = cc;
  if (bsd_debuglevel) printf("ioctl : return <%d>\n",cc);
  return cc ? -1 : 0;
}

int shutdown(int s, int how)
{
  return lwip_shutdown(s,how);
}

/* return socket resources to the pool */

int soclose (int sck)
{
  int i, timeout, cc=0;
  err_t ret;
  INT8U err;
  
  if (bsd_debuglevel > 1) printf("soclose: started typ=%d sck=%d, sts=%d, SOCK_ISCONN=%d\n", sckPool[sck].typ, sck, sckPool[sck].sts, SOCK_ISCONN );
  // don't worry about this yet
        if (!socksem)
        socksem = OSSemCreate(1);
  OSSemPend(socksem, 0, &err);
 // if (sck < 0 || sck >= nSckInPool) ccerr(ENOTSOCK); !SW
   
   if (sck < 0 || sck >= MAX_NUM_SCK) ccerr(ENOTSOCK); //vahan

  if (sckPool[sck].typ == SOCK_STREAM)
  {
   OSSchedLock();
   if (sckPool[sck].sts == SOCK_ISCONN || sckPool[i].sts == SOCK_CLOSEDWITHDATA)
   {
     if (bsd_debuglevel) printf("soclose: closing tcp socket in soclose\n");
     
     tcp_output( sckPool[sck].tcppcb );
     tcp_arg(sckPool[sck].tcppcb, (void *) -1);
     tcp_recv(sckPool[sck].tcppcb, NULL);
     tcp_err( sckPool[sck].tcppcb, NULL );
     tcp_sent( sckPool[sck].tcppcb, NULL );
     tcp_accept( sckPool[sck].tcppcb, NULL);

     ret = tcp_close( sckPool[sck].tcppcb );
     if (ret != ERR_OK) 
     {
        tcp_abort( sckPool[sck].tcppcb );
        if (bsd_debuglevel) printf("soclose: problem with disconnecting tcp socket ret=%d\n", ret);
        OSSchedUnlock();
        ccerr(ret);
     }
   }
   else
   {
     if (bsd_debuglevel) printf("aborting tcp connection in soclose\n");

     tcp_output( sckPool[sck].tcppcb );
     tcp_arg(sckPool[sck].tcppcb, (void *) -1);

     tcp_recv(sckPool[sck].tcppcb, NULL);
     tcp_err( sckPool[sck].tcppcb, NULL );
     tcp_sent( sckPool[sck].tcppcb, NULL );
     tcp_accept( sckPool[sck].tcppcb, NULL);

     tcp_abort( sckPool[sck].tcppcb );
   }
   OSSchedUnlock();
  } 
    
//  if (sckPool[sck].sck != 0 && sckPool[sck].typ == SOCK_DGRAM)
   if (sckPool[sck].typ == SOCK_DGRAM)
  {
    udp_recv(sckPool[sck].udppcb, NULL, (void *) 0);
    udp_remove( sckPool[sck].udppcb );
    sckPool[sck].sck = 0;
  }
  
  if (sckPool[sck].sckRcvPackets != NULL) SystemFree( (void *) sckPool[sck].sckRcvPackets );
  if (sckPool[sck].sckSndPackets != NULL) SystemFree( (void *) sckPool[sck].sckSndPackets );

  sckPool[sck].sts = 0;
  sckPool[sck].nrcvready = 0;
  sckPool[sck].nsndready = 0;
  sckPool[sck].rcvBufferTail = 0;
  sckPool[sck].rcvBufferHead = 0;
  sckPool[sck].initialized = 0;
  sckPool[sck].sts = SOCK_ISAVAILABLE;
  
  nSckInPool--;

err:
  OSSemPost(socksem);
  lastSocketError = cc;
  if (bsd_debuglevel) printf("soclose : return <%d>\n",cc);
  return cc ? -1 : 0;
}

/*
Parameters
s [in] Descriptor identifying a socket that has been placed in a listening state with the listen function. The connection is actually made with the socket that is returned by accept. 
addr [out] Optional pointer to a buffer that receives the address of the connecting entity, as known to the communications layer. The exact format of the addr parameter is determined by the address family established when the socket was created. 
addrlen [out] Optional pointer to an integer that contains the length of addr. 
*/

int accept(SOCKET sck, struct sockaddr *addr, int *addrlen)
{
  int i=0, cc=0;

  if (sck < 0 || sck >= MAX_NUM_SCK) ccerr(ENOTSOCK);

  for (i=0; i<MAX_NUM_SCK; i++)
  {
    if (sckPool[i].tcpparent == sck && sckPool[i].naccready > 0)
    {
      sckPool[i].naccready=0;
      if (bsd_debuglevel > 2) printf("accept: sckPool[parent=%d].naccready before = %d\n", sck, sckPool[sck].naccready );
      sckPool[sck].naccready--;
      if (bsd_debuglevel > 2) printf("accept: sckPool[parent=%d].naccready after = %d\n", sck, sckPool[sck].naccready );
      if (sckPool[sck].naccready < 0) sckPool[sck].naccready = 0;
      if (bsd_debuglevel > 2) printf("accept: sckPool[parent=%d].naccready after2 = %d\n", sck, sckPool[sck].naccready );
      sckPool[i].sts = SOCK_ISCONN;
      if (bsd_debuglevel > 1) printf("socket that will returned by accept is %d\n",i);
      ccerr(0);
    }
  }
  if (sckPool[sck].opt & FIONBIO) cc = EWOULDBLOCK;
  // we're only going to support NON-BLOCKING IO  here (at least for now)

err:
  lastSocketError = cc;
  if (bsd_debuglevel && cc != EWOULDBLOCK) printf("accept : sck %d err <%d>\n",i,cc);
  return cc ? -1 : i;
}

/*
Parameters
sck [in] Descriptor identifying an unconnected socket. 
name [in] Name of the socket to which the connection should be established. 
namelen [in] Length of name. 
*/

err_t lwipTCPConnectCallback( void *arg, struct tcp_pcb *tcpb, err_t err1)
{
 int i;
 int cc=0;

 i = (int) arg;
 if (i < 0 || i >= MAX_NUM_SCK) ccerr(ENOTSOCK);
 
 if (bsd_debuglevel > 1) printf("lwipTCPConnCallb socket=%d\n",i);
 
 if (err1 != ERR_OK)
 {
   if (bsd_debuglevel) printf("lwipTCPConnCallb: Error on connecting to host.\n");
   ccerr(err1);
 }
//    if (!socksem)
//        socksem = OSSemCreate(1);
//      if (!sembox)
//         sembox = sys_mbox_new();
      if (!mboxsem)
         mboxsem = OSMboxCreate((void*)0);         
 if (bsd_debuglevel) printf("lwipTCPConnCallb: connection established\n");

   tcp_arg(sckPool[i].tcppcb, (void *) i);
   tcp_recv(sckPool[i].tcppcb, lwipTCPCallback);
   tcp_err( sckPool[i].tcppcb, lwipTCPErrorCallback );
   tcp_sent( sckPool[i].tcppcb, lwipTCPSentCallback );
   
 sckPool[i].sts = SOCK_ISCONN;
// sys_mbox_post(sembox, NULL);
  OSMboxPost(mboxsem,(void*)1);
err:
  lastSocketError = cc;
  if (bsd_debuglevel) printf("connect callback: return <%d>\n",cc);
  return cc ? -1 : ERR_OK;
}


int connect(SOCKET sck,const struct sockaddr *name, int namelen)
{
  int cc=0;
  struct sockaddr_in *sa = (struct sockaddr_in *)name;
  short sin_port;
  u32_t ipto;  
  u32_t timeout = 5000;
  err_t ret;
  u32_t tim;
  INT8U err;
  
  if (sck < 0 || sck >= MAX_NUM_SCK) ccerr(ENOTSOCK);

  if (sckPool[sck].sts == SOCK_ISCONN) ccerr(EISCONN);

  if (!sckPool[sck].initialized)
  {
   if (sckPool[sck].typ == SOCK_DGRAM)
   {
    // if it's not initialized yet, then I haven't bound it !
    if ((cc=bind(sck,NULL,0)) != 0) ccerr(cc);
   }
   else
   { // SOCK_STREAM
    if ((cc = socketInit(sck))<0) ccerr(cc);
   }
  }
//    if (!socksem)
//        socksem = OSSemCreate(1);
      if (!mboxsem)
         mboxsem = OSMboxCreate((void*)0);
          
  if (sckPool[sck].typ == SOCK_DGRAM)
  {
   ret = udp_connect( sckPool[sck].udppcb, (struct ip_addr *) &(sa->sin_addr.s_addr), ntohs(sa->sin_port) );
    if (bsd_debuglevel > 1) printf("SW! ret on udp_connect = %d\n", ret);
  }
  else
  {
   ret = tcp_connect( sckPool[sck].tcppcb, (struct ip_addr *) &(sa->sin_addr.s_addr), ntohs(sa->sin_port), lwipTCPConnectCallback );
   if (bsd_debuglevel > 1) printf("SW! ret on tcp_connect = %d\n", ret);


  }
  
//  tim = time(NULL)+10;
//  
//  while(tim > time(NULL))
//  {
//  // sleep(250);
//   if (sckPool[sck].sts == SOCK_ISCONN || sckPool[sck].sts == SOCK_CLOSEDWITHDATA) break;
//   sleep(250);
//  }

// tim = sys_arch_mbox_fetch(sembox, NULL, timeout); 
// printf("timeout = %d\nOS_TICKS_PER_SEC = %d\n", tim, OS_TICKS_PER_SEC);

  OSMboxPend(mboxsem, timeout,&err);

 printf("sckPool[sck].sts = %d\n", sckPool[sck].sts);// OSSemPend(socksem, 0, &err);
  if (sckPool[sck].sts != SOCK_ISCONN && sckPool[sck].sts != SOCK_CLOSEDWITHDATA) ccerr(ECONNREFUSED); // hardwire this for now

err:
  lastSocketError = cc;
  if (bsd_debuglevel) printf("connect : socket %d return <%d>\n",sck, cc);
  return cc ? -1 : 0;
}


err_t lwipLsnCallback(void *arg, struct tcp_pcb *newpcb, err_t err )
{
  int i,j, parent, cc=0;
  int optval;
  int *ipint;
  struct ip_addr ip = newpcb->remote_ip;
  u16_t port = newpcb->remote_port;
  INT8U semerr;
  // i is the listening socket 
  i = (int) arg;
  
  printf("parent = %d nSckInPool = %d sckPool[parent].naccready = %d\n",i,nSckInPool,sckPool[i].naccready);
  
  if (nSckInPool >= MAX_NUM_SCK){tcp_close(newpcb); ccerr(ENOBUFS);}
        if (!socksem)
        socksem = OSSemCreate(1);
  OSSemPend(socksem, 0, &semerr);
  if (i >= MAX_NUM_SCK){ tcp_close(newpcb);OSSemPost(socksem);ccerr(ENOTSOCK);}
  //vahan
  parent = i;
//  printf("naccready =%d : tcpbacklog =%d\n", sckPool[parent].naccready,sckPool[parent].tcpbacklog);
  if(sckPool[parent].naccready >= sckPool[parent].tcpbacklog){tcp_close(newpcb);OSSemPost(socksem);ccerr(ENOTSOCK);}
  
  printf("lsnCallback: socket found for arg=%x : socket=%d\n", arg, i);
  
  for (j=0;j<MAX_NUM_SCK;j++)
  {
   if (!sckPool[j].initialized) break;
  }
  if (j == MAX_NUM_SCK) 
  {
   if (bsd_debuglevel) printf("lsnCallback: not enough sockets available\n");
    OSSemPost(socksem);
   ccerr(ENOMEM);
  }
      if (!mboxevent)
         mboxevent = OSMboxCreate((void*)0);  
  if (bsd_debuglevel > 1) printf("lsnCallback: I have found a suitable listening socket at socknr=%d\n", j);
   
  sckPool[j].typ = SOCK_STREAM;
  sckPool[j].flg =  0;
  sckPool[j].tcpparent = i;
  sckPool[j].sckRcvPackets = NULL;
  sckPool[j].sckSndPackets = NULL;
  sckPool[j].nrcvready = 0;
  sckPool[j].nsndready = 0;
  sckPool[j].naccready = 0;
  sckPool[j].opt |= SO_REUSEADDR;
  sckPool[j].initialized = TRUE;
  sckPool[j].numSndBuffers = 0;
  sckPool[j].numRcvBuffers = 0;
  sckPool[j].sent_pending = 0;

  nSckInPool++;

  optval = DEFAULT_RCVBUF_SIZE;
  setsockopt(j,SOL_SOCKET,SO_RCVBUF,(const char *)&optval,sizeof(int));
  optval = DEFAULT_SNDBUF_SIZE;
  setsockopt(j,SOL_SOCKET,SO_SNDBUF,(const char *)&optval,sizeof(int));

//  parent = sckPool[j].tcpparent;
  sckPool[parent].naccready++;
  
  memcpy( &(sckPool[j].remote_tcp.sin_addr.s_addr), &ip, sizeof(struct ip_addr) );
  //ipint = (int *) &(ip);
  sckPool[j].remote_tcp.sin_port = htons(port);
  sckPool[j].remote_tcp.sin_family = AF_INET;

  sckPool[j].name.sin_family  = AF_INET;
  sckPool[j].name.sin_port  = htons(newpcb->local_port);
  memcpy( &(sckPool[j].name.sin_addr.s_addr), &(newpcb->local_ip), sizeof(struct ip_addr) );
  //ipint = (int *) &(newpcb->local_ip);      
     
  sckPool[j].tcppcb = newpcb;
  sckPool[j].nsndready = 1;
  sckPool[j].naccready = 1;

  sckPool[j].initialized = TRUE;
  tcp_arg(sckPool[j].tcppcb, (void *) j);
  tcp_recv(sckPool[j].tcppcb, lwipTCPCallback);
  tcp_err( sckPool[j].tcppcb, lwipTCPErrorCallback );
  tcp_sent( sckPool[j].tcppcb, lwipTCPSentCallback );

  sckPool[j].sts = SOCK_ISCONN;
  
  if (bsd_debuglevel > 1) printf("lsnCallback socketnr(j) is %d naccready(j)=%d naccready(parent)=%d\n", j, sckPool[j].naccready, sckPool[parent].naccready);

  if (bsd_debuglevel) printf("sck %d parent %d tcpLsnCallback from port %d (iphex=%x)\n",
	  i,parent,port, ip);
    
  OSSemPost(socksem);
  OSMboxPost(mboxevent,(void*)1);

err:
  lastSocketError = cc;
  if (bsd_debuglevel) printf("tcplsnCallback : return <%d>\n",cc);
  return cc ? -1 : 0;
}


/*
sck [in] Descriptor identifying a bound, unconnected socket. 
backlog [in] Maximum length of the queue of pending connections. If set to SOMAXCONN, the underlying service provider responsible for socket s will set the backlog to a maximum reasonable value. There is no standard provision to obtain the actual backlog value. 
*/

int listen(SOCKET sck, int backlog)
{
  // ??? maybe we can delete the receive and send buffers because there are no
  // buffers needed for listening state 
  // SW! 22.04.04

  int i, cc=0;
  err_t err;
  struct tcp_pcb *temppcb;
  int optval;

  if (sck < 0 || sck >= MAX_NUM_SCK) ccerr(ENOTSOCK);
  sckPool[sck].tcpbacklog = backlog;
  sckPool[sck].naccready = 0;
  


  temppcb = tcp_listen( sckPool[sck].tcppcb );
  
  if (temppcb == NULL)
  {
   if (bsd_debuglevel > 1) printf("listen: Error allocating temppcb\n");
   ccerr(ENOMEM);
  }
  sckPool[sck].tcppcb = temppcb;
  tcp_arg( sckPool[sck].tcppcb, (void *) sck );
  tcp_accept( sckPool[sck].tcppcb, lwipLsnCallback);

 
err:
  lastSocketError = cc;
  if (bsd_debuglevel) printf("listen (%d, %d) tcppcb(new)=%x : return <%d>\n",sck,backlog,sckPool[sck].tcppcb, cc);
  return cc ? -1 : 0;
}

/*
sck   [in] Descriptor identifying a connected socket. 
buf   [out] Buffer for the incoming data. 
len   [in] Length of buf. 
flags [in] Flag specifying the way in which the call is made. 
*/

int recv(int sck, char *buf, int len, int flags)
{
  return recvfrom(sck,buf,len,flags,NULL,NULL);
}

/*
socket  [in] A descriptor identifying a bound socket. 
buf     [out] A buffer for the incoming data. 
len     [in] The length of buf. 
flags   [in] An indicator specifying the way in which the call is made. 
from    [out] An optional pointer to a buffer that will hold the source address upon return. 
fromlen [in/out] An optional pointer to the size of the from buffer. 
*/
int recvfrom(int sck, char *buf, int len, int flags, struct sockaddr *from, int *fromlen)
{
  int sckPtr, plen, cc=0;
  int bytesread=0;
  u32_t timeout = 1000;
  INT8U err;
  
  if (sck < 0 || sck >= MAX_NUM_SCK) ccerr(ENOTSOCK);

  if (!sckPool[sck].initialized)
  {
    if (sckPool[sck].typ == SOCK_DGRAM)
    {
     // if it's not initialized yet, then I haven't bound it ! 
     if ((cc=bind(sck,NULL,0)) != 0) ccerr(cc);
    }
    else
    {
     if ((cc=socketInit(sck)) != 0) ccerr(cc);
    } 
  }
  
 retry:
  if (sckPool[sck].nrcvready > 0)
  {
    sckPool[sck].nrcvready--;
    sckPtr = sckPool[sck].rcvBufferTail;
    plen = MIN(len,sckPool[sck].sckRcvPackets[sckPtr].bufMsgSize);
    if (bsd_debuglevel > 2)
      printf("sck %d ptr %d recvfrom %d bytes (min of %d and %d)from \n",
              sck,sckPtr,plen,len,sckPool[sck].sckRcvPackets[sckPtr].bufMsgSize );
    if (plen > 0) memcpy(buf,sckPool[sck].sckRcvPackets[sckPtr].buf,plen);
     
    if (fromlen != (int *)NULL && (unsigned)(*fromlen) < sizeof(struct sockaddr_in)) ccerr(ENOBUFS);	//271003, grev
    if (from != NULL) *from = *(struct sockaddr *)&sckPool[sck].sckRcvPackets[sckPtr].sckAddr;
    sckPool[sck].rcvBufferTail = (sckPool[sck].rcvBufferTail + 1) % sckPool[sck].numRcvBuffers;
    bytesread = plen;
  }
  else
  {
          if (!mboxevent)
     mboxevent = OSMboxCreate((void*)0);  
         
     OSMboxPend(mboxevent, timeout,&err);
     if (sckPool[sck].nrcvready > 0) goto retry;
    if (sckPool[sck].opt & FIONBIO) cc = EWOULDBLOCK; //sleep(250);
    // we're only going to support NON-BLOCKING IO  here (at least for now) 
  }
  
err:
  lastSocketError = cc;
  if (bsd_debuglevel > 2) printf("recvfrom : bytes %d return <%d> wouldblock=%d from host:%x :%d\n",bytesread,cc, EWOULDBLOCK,sckPool[sck].sckRcvPackets[sckPtr].sckAddr.sin_addr, sckPool[sck].sckRcvPackets[sckPtr].sckAddr.sin_port );
  return cc ? -1 : bytesread;
}

/*
sck     [in] A descriptor identifying a socket. 
buf     [in] A buffer containing the data to be transmitted. 
len     [in] The length of the data in buf. 
flags   [in] An indicator specifying the way in which the call is made. 
*/
int send(int sock1, char *buf1, int len1, int flags1)
{
  return sendto(sock1,buf1,len1,flags1,NULL,0);
}

/*
socket  [in] A descriptor identifying a socket. 
buf     [in] A buffer containing the data to be transmitted. 
len     [in] The length of the data in buf. 
flags   [in] An indicator specifying the way in which the call is made. 
to      [in] An optional pointer to the address of the target socket. 
tolen   [in] The size of the address in to. 
*/
int sendto (int sck, char *buf, int len, int flags, struct sockaddr *to, int tolen)
{
  int sckPtr, cc=0;
  int bytessent=0;
  u_long ipto;
  u8_t resultfree;


  // lwip functions 
  struct ip_addr ip;
  struct pbuf *pbuffer;

  // save old values 
  struct ip_addr rem_ip;
  u16_t remote_port;
  struct sockaddr_in *sa = (struct sockaddr_in *)to;
  err_t tcpwriteerr;
  err_t tcpoutputerr;
  u16_t tcp_sndbufsize;
  
  
  
  if (sck < 0 || sck >= MAX_NUM_SCK) ccerr(ENOTSOCK);

  if (sckPool[sck].sts == SOCK_ISAVAILABLE) ccerr(ESHUTDOWN);

  if (!sckPool[sck].initialized)
  {
   if (sckPool[sck].typ == SOCK_DGRAM)
   {
    /* if it's not initialized yet, then I haven't bound it ! */
    if ((cc=bind(sck,NULL,0)) != 0) ccerr(cc);
   }
   else
   {
    if ((cc=socketInit(sck)) != 0) ccerr(cc);
   }
  } 

  switch (sckPool[sck].typ)
  {
    case SOCK_DGRAM:
           sckPtr = sckPool[sck].sndBufferHead = (sckPool[sck].sndBufferHead + 1) % sckPool[sck].numSndBuffers;
           if (sa == NULL) sa = &sckPool[sck].sckRcvPackets[sckPtr].sckAddr;

              ipto = ntohl( sa->sin_addr.s_addr);
            /*
               future: this should go into a send queue which gets checked regularly.
               the tail should be incremented following a successful send
               and the head shouldn't be incremented unless there's room
               Right now, we're just sending it out as it comes and hoping for the best ...
            */
           if (bsd_debuglevel > 2)
           {
             printf("send to %s:%d (%x %d) on socket %d\n",
	           inet_ntoa( sa->sin_addr ),
	           ntohs(sa->sin_port),
	           ipto, 
	           ntohs(sa->sin_port),
	           sck);
           }
           sckPool[sck].sndBufferTail = sckPool[sck].sndBufferHead;


           memcpy( &rem_ip, &sckPool[sck].udppcb->remote_ip, sizeof(rem_ip) );
           remote_port = sckPool[sck].udppcb->remote_port;

           // allocate a pbuf
           pbuffer = pbuf_alloc(PBUF_TRANSPORT, len, PBUF_RAM);
           if (pbuffer == NULL) 
           {
            if (bsd_debuglevel) printf("Error allocating pbuffer in sendto\n");
            ccerr(ENOMEM);
           }
           memcpy( pbuffer->payload, (const void *) buf, len);

          //if (bsd_debuglevel > 0) printf("buf[0] =%x buf[1]=%x buf[2]=%x pl[0]=%x pl[1]=%x\n", buf[0], buf[1], buf[2], ((char *)pbuffer->payload)[0], ((char *)pbuffer->payload)[1] );

           if (sa != NULL) 
           {
             ip.addr =  sa->sin_addr.s_addr;
            if (bsd_debuglevel > 2) printf(" ip :%xh port :%d sizeof=%d\n",ip, sa->sin_port,sizeof(ip));
            udp_connect( sckPool[sck].udppcb, &ip,ntohs(sa->sin_port));
           } 
           udp_send( sckPool[sck].udppcb, pbuffer);

           if (sa != NULL)
           {
            // restore old values
			     if ((rem_ip.addr == 0) && (remote_port == 0)) 
			       udp_disconnect( sckPool[sck].udppcb ); 
			    else
			       udp_connect( sckPool[sck].udppcb, &rem_ip, ntohs(remote_port) );
           }  

          resultfree = pbuf_free( pbuffer );
          if (bsd_debuglevel>2) printf("resultfree pbuf udp %d\n", resultfree);

          bytessent = len;
      break;
    case SOCK_STREAM:
/*
          while( 1 == 1)
          {
           tcp_sndbufsize = tcp_sndbuf(sckPool[sck].tcppcb);
           if (sckPool[sck].sts == SOCK_ISAVAILABLE) break;
           if (len > tcp_sndbufsize) 
           {
            tcp_output( sckPool[sck].tcppcb );
            printf("sento: len=%d sndbufsize=%d\n", len, tcp_sndbufsize );
            sleep(150);
           }
           else break;
           if (tcp_sndbufsize >= 1023) break;
          } 
*/
          if (sckPool[sck].sts == SOCK_ISAVAILABLE) ccerr(ESHUTDOWN);
           
          //len = tcp_sndbufsize;
        OSSchedLock();
          
          tcpwriteerr = tcp_write( sckPool[sck].tcppcb, buf, len, 1); // SW!!! 1 last argument means copy data 
          if (bsd_debuglevel > 2) printf("sending for stream: tcp_sndbufsize=%d, len = %d, tcpwriteerr=%d\n", tcp_sndbufsize, len, tcpwriteerr );
          if (tcpwriteerr != ERR_OK) { if (bsd_debuglevel) printf("sento: ERR on tcp_write %d\n", tcpwriteerr); OSSchedUnlock(); ccerr(ECONNABORTED); }

          // this is not documented, but has to be called !! SW! 30.4.04
          //if (len == tcp_sndbufsize)
          //{
         
               tcpoutputerr = tcp_output( sckPool[sck].tcppcb );
           if (tcpoutputerr != ERR_OK) { printf("sendto: ERR on tcp_output %d\n", tcpoutputerr ); }

        OSSchedUnlock();
          // if (tcpoutputerr != ERR_OK) { if (bsd_debuglevel) printf("sendto: ERR on tcp_output %d\n", tcpoutputerr ); }
          //} 


          bytessent = len; 
          sckPool[sck].sent_pending += len;
          
          //bytessent = 0;
          
          break; 
    default:
      ccerr(ENOPROTOOPT);
  }

err:
  if (cc) perror("send_to");
  if (bsd_debuglevel > 1) printf("sendto : bytes %d return <%d>\n",bytessent,cc);
  lastSocketError = cc;
  return cc ? -1 : bytessent;
}




void doLWIPInit()
{
        INT8U err;

        int sck;
//
        // do socket init
        for (sck=0;sck<MAX_NUM_SCK;sck++)
        {
         sckPool[sck].sts = SOCK_ISAVAILABLE;
         sckPool[sck].initialized = 0;
        }
      
}



