#include "nios.h"
#include "stdio.h"
#include <time.h>
#include <sys/time.h>

#include <ucosii/os_cfg.h>
#include <ucosii/os_cpu.h>


/* we aren't doing any file IO so dummy these routines for now ... */
int _open(const char *filename,int oflag,int pmode)
{
  return -1; /* return failure */
}
int _unlink(const char *filename)
{
  return 0;
}
int _link(const char *filename)
{
  return -1;
}
int nr_fprintf(FILE *fp, const char *fmt, ... )
{
	return 0; /* return failure */
}
/* These two functions below are important ! */

long time(long *lptime)
{
  static INT32U firsttime;
  INT32U currtime;
  static int done=0;

  if (done == 0)
  {
   done = 1;
   firsttime = OSTimeGet();
  }
  
  currtime = OSTimeGet();
  if (firsttime > currtime) firsttime = currtime;

  if (lptime != NULL) *lptime = (currtime-firsttime) / OS_TICKS_PER_SEC;

  return( (currtime-firsttime) / OS_TICKS_PER_SEC );
}

// get current usec fraction for gettimeofday
long timeusec(long *lptime)
{
  static INT32U firsttime;
  INT32U currtime;
  static int done=0;

  if (done == 0)
  {
   done = 1;
   firsttime = OSTimeGet();
  }
  
  currtime = OSTimeGet();
  if (firsttime > currtime) firsttime = currtime;

  if (lptime != NULL) *lptime = (((currtime-firsttime) % OS_TICKS_PER_SEC)*1000000) / OS_TICKS_PER_SEC;

  return( (((currtime-firsttime) % OS_TICKS_PER_SEC)*1000000) / OS_TICKS_PER_SEC );
}


struct timeval *_gettimeofday(struct timeval *tv,struct timezone *tz)
{
 tv->tv_sec = time(NULL);
 tv->tv_usec = timeusec(NULL);

 return( tv );
}

/* running count since last boot */
/* later either use:
   1. TINE timestamp synchronization to apply an adjustment or
   2. port the rdate daemon from VxWorks to NIOS
*/

/*
  static int tsec = 0;  // adjusted offset for potential wrapping of tmsec 
  static int tmsec = 0; // result of most recent call 
  int nt = nr_timer_milliseconds(); // this call 
  if (nt < tmsec) tsec += tmsec/1000; // it has wrapped 
  tmsec = nt;
  if (tv != NULL)
  {
    tv->tv_sec = tsec + tmsec/1000;
    tv->tv_usec = (tmsec % 1000) * 1000;
  }
  return tv;
*/

