#include "nios.h"
#include "stdio.h"
#include <time.h>
#include <sys/time.h>

/* we aren't doing any file IO so dummy these routines for now ... */
int _open(const char *filename,int oflag,int pmode)
{
  return -1; /* return failure */
}
int _unlink(const char *filename)
{
  return 0;
}
int _link(const char *filename)
{
  return -1;
}
int nr_fprintf(FILE *fp, const char *fmt, ... )
{
	return 0; /* return failure */
}
/* These two functions below are important ! */

/* These two functions below are important ! */
long time(long *lptime)
{
  struct timeval tv;
  gettimeofday(&tv,(struct timezone *)NULL);
  return tv.tv_sec;
}
/* running count since last boot */
/* later either use:
   1. TINE timestamp synchronization to apply an adjustment or
   2. port the rdate daemon from VxWorks to NIOS
*/
struct timeval *_gettimeofday(struct timeval *tv,struct timezone *tz)
{
  static int tsec = 0;  /* adjusted offset for potential wrapping of tmsec */
  static int tmsec = 0; /* result of most recent call */
  int nt = nr_timer_milliseconds(); /* this call */
  if (nt < tmsec) tsec += tmsec/1000; /* it has wrapped */
  tmsec = nt;
  if (tv != NULL)
  {
    tv->tv_sec = tsec + tmsec/1000;
    tv->tv_usec = (tmsec % 1000) * 1000;
  }
  return tv;
}
/* provide these routines for possible use ... */
void *SystemCalloc(size_t nr, size_t size)
{
  size_t fullsize = nr*size;
  void *ptr;
  ptr = malloc(fullsize);
  if (ptr == NULL) printf("malloc null %x (size=%d)\n", ptr, fullsize);
  if (ptr != NULL) memset( ptr, 0, fullsize );
  return( ptr );
}
void *SystemMalloc( size_t fullsize )
{
  void *ptr;
  ptr = malloc( fullsize );
  if (ptr == NULL) printf("malloc null %x (size=%d)\n", ptr, fullsize);
  return( ptr );
}
void SystemFree( void *ptr )
{
  if (ptr == NULL) printf("free null %x\n", ptr);
  free( ptr );
}
