#include <_ansi.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "stdio.h"
#include <time.h>
#include <sys/time.h>
#include "includes.h"
#include <os_cpu.h>
#include <os_cfg.h>
#include <stdlib.h>
#include <string.h>


/*********************************************/
/* home-made clock routines ...              */
/*********************************************/
long nr_clockOffset = 0;

long timezone;   /* normally in time.h */

void tzset(void) /* normally in time.h */
{
  /* fill this in some day ...*/
}

/* These two functions below are important ! */
/*long time(long *lptime)
{
  struct timeval tv;
  gettimeofday(&tv,(struct timezone *)NULL);
  if (lptime != NULL) *lptime = tv.tv_sec;
  return tv.tv_sec;
}
*/

void bothtime( long *sec, long *usec)
{
  static INT32U firsttime;
  INT32U currtime;
  static int done=0;

  if (done == 0)
  {
   done = 1;
   firsttime = OSTimeGet();
  }
  
  currtime = OSTimeGet();
  if (firsttime > currtime) firsttime = currtime;

  if (sec != NULL) *sec = nr_clockOffset+((currtime-firsttime) / OS_TICKS_PER_SEC);
  if (usec != NULL) *usec = (((currtime-firsttime) % (1L*OS_TICKS_PER_SEC))*1000000) / (1L*OS_TICKS_PER_SEC);
}

long time(long *lptime)
{
  static INT32U firsttime;
  INT32U currtime;
  static int done=0;

  if (done == 0)
  {
   done = 1;
   firsttime = OSTimeGet();
  }
  
  currtime = OSTimeGet();
  //  printf("time: firsttime=%d currtime=%d\n",firsttime,currtime);
  if (firsttime > currtime) firsttime = currtime;

  if (lptime != NULL) *lptime = nr_clockOffset + ((currtime-firsttime) / OS_TICKS_PER_SEC);

  return( nr_clockOffset+((currtime-firsttime) / OS_TICKS_PER_SEC) );
}

// get current usec fraction for gettimeofday
long timeusec(long *lptime)
{
  static INT32U firsttime;
  INT32U currtime;
  static int done=0;

  if (done == 0)
  {
   done = 1;
   firsttime = OSTimeGet();
  }
  
  currtime = OSTimeGet();
  if (firsttime > currtime) firsttime = currtime;

  if (lptime != NULL) *lptime = (((currtime-firsttime) % OS_TICKS_PER_SEC)*1000000) / OS_TICKS_PER_SEC;

  return( (((currtime-firsttime) % OS_TICKS_PER_SEC)*1000000) / OS_TICKS_PER_SEC );
}


int gettimeofday12345(struct timeval *tv,struct timezone *tz)
{
 if (tv != NULL) bothtime( &(tv->tv_sec), &(tv->tv_usec) );
 return( 0 );
}


/* running count since last boot */
/*int _gettimeofday(struct timeval *tv,struct timezone *tz)
{
  static int tsec = 0;  // adjusted offset for potential wrapping of tmsec 
  static int tmsec = 0; // result of most recent call 
  int nt = nr_timer_milliseconds(); // this call 
  if (nt < tmsec) 
  {
    tsec += tmsec/1000; // it has wrapped 
    nr_clockOffset += tsec;
  }
  tmsec = nt;
  if (tv != NULL)
  {
    tv->tv_sec = nr_clockOffset + tmsec/1000;
    tv->tv_usec = (tmsec % 1000) * 1000;
  }
  return 0;
}
*/
/* function to 'set the clock' ... */
int nr_setclock(long tgtTime)
{
  INT32U dt, tnow, tst;
  tnow = time(NULL);
  tst = OSTimeGet();
  dt = tgtTime - tnow;
 // OSTimeSet(tgtTime);  //vahan
  nr_clockOffset += dt;
  if (dt > 10 || dt < -10)
  {
    printf("nr_setclock: major time jump %d to %d tst=%d\n",tnow,tgtTime,tst);
  }
  return dt;
}

/*********************************************/
/* cover routines for file IO ...            */
/*********************************************/
int _open(const char *filename,int oflag,int pmode)
{
  return -1; /* return failure */
}
int _unlinknios(const char *filename)
{
  return 0;
}
int _rename_( char *filename, char *filenamenew)
{
  return 0;
}
int _link(const char *filename)
{
  return -1;
}
int nr_fprintf(FILE *fp, const char *fmt, ... )
{
	return 0; /* return failure */
}

/*********************************************/
/* memory management routines ...            */
/*********************************************/

OS_EVENT	*_malloc_mutex;
int    _malloc_locks;


/* This should be called from main() after OSInit().  TaskPriority MUST be a
   priority (not already in use) that is higher than any task calling malloc() 
	or free().
*/
void MallocLockInit(INT8U prio)
{
//	INT8U	err;
//	_malloc_mutex=OSMutexCreate(prio,&err);
//#if 0
//	if (err != OS_NO_ERR)
//	  printf("Failed to create malloc lock.  err = %d\n", err);
//#endif	
//	_malloc_locks=0;
}

/* These routines are replacements for the null versions in newlib.  They are
   called by malloc() and free() to prevent pre-emption corruption of global
   data.
*/

//void
//__malloc_lock (ptr)
//struct _reent *ptr;
//{
//	INT8U	err;
//	int task_prio, mowner_prio, mutex_pip;
//
//    if (!_malloc_mutex) {
//#if 0
//  	  printf("Failed to lock malloc. err = %d\n", err);
//#endif	
//      return;
//    }
//    asm("PFX 8 \n WRCTL %g0;");        /* Disable interrupts                        */
//
//    /* get the task priority, owner priority and pip of the mutex */
//    task_prio = OSTCBCur->OSTCBPrio;
//    mowner_prio = (INT8U)(_malloc_mutex->OSEventCnt & 0x0FF);
//    mutex_pip = (INT8U)(_malloc_mutex->OSEventCnt >> 8);
//    
//    asm("PFX 9 \n WRCTL %g0;");        /* Enable  interrupts                        */
//    
//    /* check if we already own this mutex */
//    if ((mowner_prio == task_prio) || (mutex_pip == task_prio) ) {
//    	/* we do, just count */
//    	_malloc_locks++;
//    }
//    else {
//    	/* we don't own it, try to get it*/
//    	OSMutexPend(_malloc_mutex,0,&err);
//    	if (err != OS_NO_ERR)
//#if 0
//    	  printf("Failed to lock malloc. err = %d\n", err)
//#endif	
//          ;
//    	else 
//          _malloc_locks=1;
//   }
//}
//
//void
//__malloc_unlock (ptr)
//struct _reent *ptr;
//{
//   if( (--_malloc_locks) == 0 ) {
//      OSMutexPost(_malloc_mutex);
//   }
//}
//
///* This version of _sbrk() replaces the Altera libnios32 version.
//   _sbrk() allocates more heap space for malloc without overrunning the
//	stack.  In UC/OS, the startup heap (between end-of-program-data and
//	top-of-stack) is used by all tasks.  The upper limit of the heap is just
//	below the startup stack which will no longer be used by uC/OS tasks.
//*/
//caddr_t _sbrk(incr)
//int incr;
//{
//  extern char *RAMLimit;
//  char *prev_heap_end, *new_heap_end;
//
//  prev_heap_end = RAMLimit;
//  new_heap_end = prev_heap_end + incr + 3;
//  new_heap_end = (char*)((unsigned int)new_heap_end & (-4));
//
///* Original: the upper limit of the heap = current stack pointer
//  if ((unsigned int)new_heap_end > register(%sp)
//    return -1;
//*/
//
///* uC/OS: the upper limit of the heap is the top of the global stack less the
//   startup stack area which is no longer used.
//*/
//  if ((unsigned int)new_heap_end > (unsigned int)nasys_stack_top - 4096)
//    return (caddr_t)(-1);
//
//    
//  RAMLimit = new_heap_end;
//  return (caddr_t)prev_heap_end;
//}

///////////////////////////////////////////////////////////////////////////////////
// High level API for TINE protocol by Stefan Weisse / DESY Zeuthen
///////////////////////////////////////////////////////////////////////////////////

void *SystemCalloc(size_t nr, size_t size)
{
  size_t fullsize = nr*size;
  void *ptr;
  ptr = malloc(fullsize);
  if (ptr == NULL) printf("malloc null %x (size=%d)\n", ptr, fullsize);
  if (ptr != NULL) memset( ptr, 0, fullsize );
  return( ptr );
}
void *SystemMalloc( size_t fullsize )
{
  void *ptr;
  ptr = malloc( fullsize );
  if (ptr == NULL) printf("malloc null %x (size=%d)\n", ptr, (int)fullsize);
  return( ptr );
}
void SystemFree( void *ptr )
{
  if (ptr == NULL) printf("free null %x\n", ptr);
  free( ptr );
}
