# Makefile for tine client utilities
# Insert the defs for your machine
# SUN:    CC = CC         CCL = CC         LM = 
# SGI,OSF CC = cc         CCL = cc         LM = -lm
# LINUX   CC = cc         CCL = cc         LM = -lm
# ULT     CC = gcc -c -g  CCL = gcc -g     LM = 
# HP:     CC = cc -Aa     CCL = cc         LM = -lM
# SOL 2.6 CC = CC         CCL = CC         LM = -lsocket -lnsl

INCL = .
LIBS = .
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/srvcore.h \
	${INCL}/swaplib.h \
	${INCL}/hstlib.h \
	${INCL}/globals.h \
	${INCL}/dbtools.h \
	${INCL}/toolkit.h \
	${INCL}/errors.h \
	${INCL}/tinetype.h \
	${INCL}/tinedefs.h \
	${INCL}/almlib.h

PGMS = tget tsend tmonitor tservers tdevs tprops tproplist tdevlist tinfo thistory

CPP = CC -c -compat -I${INCL}
CC = cc -c -I${INCL}
CCL = cc
LM = -lm -lsocket -lnsl -lposix4

all: ${PGMS}

tget: tget.o clntools.o
	${CCL} -o tget tget.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x tget

tsend: tput.o clntools.o
	${CCL} -o tsend tput.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x tsend

thistory: thistory.o clntools.o
	${CCL} -o thistory thistory.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x thistory

tinfo: tinfo.o clntools.o
	${CCL} -o tinfo tinfo.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x tinfo

tdevs: tdevs.o clntools.o
	${CCL} -o tdevs tdevs.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x tdevs

tdevlist: tdevlist.o clntools.o
	${CCL} -o tdevlist tdevlist.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x tdevlist

tservers: tservers.o clntools.o
	${CCL} -o tservers tservers.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x tservers

tprops: tprops.o clntools.o
	${CCL} -o tprops tprops.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x tprops

tproplist: tproplist.o clntools.o
	${CCL} -o tproplist tproplist.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x tproplist

tmonitor: tmonitor.o clntools.o
	${CCL} -o tmonitor tmonitor.o clntools.o ${LIBS}/libtine.a ${LM}
	chmod a+x tget

tget.o: tget.c ${HDRS}
	${CC} tget.c

tput.o: tput.c ${HDRS}
	${CC} tput.c

tprops.o: tprops.c ${HDRS}
	${CC} tprops.c

tproplist.o: tproplist.c ${HDRS}
	${CC} tproplist.c

tservers.o: tservers.c ${HDRS}
	${CC} tservers.c

tdevs.o: tdevs.c ${HDRS}
	${CC} tdevs.c

tinfo.o: tinfo.c ${HDRS}
	${CC} tinfo.c

tmonitor.o: tmonitor.c ${HDRS}
	${CC} tmonitor.c

clntools.o: clntools.c ${HDRS}
	${CC} clntools.c

clean:
	rm *.o
