// pytine34.cpp : Defines the exported functions for the DLL application.
//

#ifdef WIN32
#include "stdafx.h"
#endif
#ifdef _DEBUG
# define DBG_BUILD_WINDOWS // the python distribution on windows doesn't have debug libraries!
#endif
#ifdef DBG_BUILD_WINDOWS
# undef _DEBUG //Prevent linking debug build of python in windows ...
#endif
#include <Python.h>
#ifdef DBG_BUILD_WINDOWS
# define _DEBUG 1
#endif
//#define USE_NUMPY
#ifdef USE_NUMPY
#define NPY_NO_DEPRECATED_API NPY_1_7_API_VERSION
#include <numpy/arrayobject.h>
#endif

#undef TINE_DECORATED_CONSTANTS
#undef tine_decorated_constants
#if PY_MINOR_VERSION > 4
#define HAVE_TIMEZONE
#define HAVE_GETTIMEOFDAY
#endif
#include "tine.h"
#include "tbufsrv.h"
#include "threader.h"
//#include "revision.h"

static int array_to_python(PyObject **o, void *data, int size, int format, char *tag, int use_bytearray);
static int acqInfo(int size,int format,char *typestr,char *tag,char *srv);

static time_t parseTimeString(char *ts)
{
  time_t t=time(NULL);
  int i, len;
  char *c,day[16],mon[64],year[16];
  char hr[64],mn[32],sec[16];
  struct tm tmts, *tnow;

  hr[0] = 0;
  tnow = localtime(&t);
  len = (int)strlen(ts);
  strupr(ts);
  for (i=0; i<len && isdigit(ts[i]); i++);  
  if (i == len) t = atoi(ts);
  else if (!strcmp(ts,"NOW")) t = time(NULL);
  else if ((c=strstr(ts,".")) != NULL) /* day.month.year format */
  {
    *c++ = 0;
    strncpy(day,ts,16);
    strncpy(mon,c,64);
    if ((c=strstr(mon,".")) != NULL)
    { 
      *c++ = 0;
      strncpy(year,c,16);
      if ((c=strstr(year,"_")) != NULL || (c=strstr(year," ")) != NULL)
      {
        *c++ = 0;
        strncpy(hr,c,64);
      }
    }
    else
    {
      sprintf(year,"%d",1900+tnow->tm_year);
      if ((c=strstr(mon,"_")) != NULL || (c=strstr(mon," ")) != NULL)
      {
        *c++ = 0;
        strncpy(hr,c,64);
      }
    }
    if (strlen(hr) > 0)
    {
      mn[0] = 0; sec[0] = 0;
      if ((c=strstr(hr,":")) != NULL)
      {     
        *c++ = 0;
        strncpy(mn,c,32);
        if ((c=strstr(mn,":")) != NULL)
        {
          *c++ = 0;
          strncpy(sec,c,16);
        }
      }
      tmts.tm_hour = atoi(hr);
      tmts.tm_min =  atoi(mn);
      tmts.tm_sec =  atoi(sec);
    }
    else
    {
      memset(&tmts,0,sizeof(struct tm));
    }
    tmts.tm_mon = (atoi(mon)+11)%12;
    tmts.tm_mday = atoi(day);
    tmts.tm_year = atoi(year);
	  if (tmts.tm_year < 100) tmts.tm_year += 2000;
    if (tmts.tm_year > 1900) tmts.tm_year -= 1900;
    tmts.tm_isdst = -1;
    t = mktime(&tmts);
  }
  return t;
}
static time_t parseDepthSting(char *ds)
{
  char *c=NULL;
  long depth = strtol(ds,&c,10);
  switch (tolower(*c))
  {
    case 'd': depth *= 86400; 
      break;
    case 'h': depth *= 3600; 
      break;
    case 'm':
      if (strnicmp(c,"min",3) == 0)
      {
        depth *= 60;
      }
      else if (strnicmp(c,"mon",3) == 0)
      {
        depth *= 86400 * 31;
      }
      break;
    case 'w':
      depth *= 86400 * 7;
      break;
    default:
    case 's': 
      break;
  }
  return (time_t)depth;
}
static int getArchivedData(char *dev,char *prp,time_t start,time_t *stop,int sample,int index,int format,void *data,int *num,int timeout)
{
  DTYPE din,dout;
  UINT32 startstopArray[4];
  char *c, asrv[STATUS_SIZE],aprp[PROPERTY_NAME_SIZE];
  int cc, needtag=FALSE,isSnapshot=FALSE;
  if (num == NULL || *num <= 0) return buffer_too_small;
  strncpy(asrv,dev,STATUS_SIZE); 
  strncpy(aprp,prp,PROPERTY_NAME_SIZE);
  if (strstr(asrv,"/HISTORY") == NULL)
  { // going for the local history
    needtag = TRUE;
    if ((c=strrchr(aprp,'.')) != NULL)
    {
      if (stricmp(c,".HIST") == 0 || stricmp(c,".HST") == 0) needtag = FALSE;
    }
    if (needtag && strlen(aprp) < 58) strcat(aprp,".HIST");
  }
  if (start == *stop) isSnapshot = TRUE;
  DTYPEZERO(dout); DTYPEZERO(din);
  startstopArray[0] = (UINT32)start;
  startstopArray[1] = (UINT32)*stop;
  startstopArray[2] = (UINT32)index;
  startstopArray[3] = (UINT32)sample;
  dout.dArrayLength = *num;
  dout.dFormat = format;
  dout.data.vptr = data;
  din.dArrayLength = isSnapshot ? 2 : 4;
  din.dFormat = CF_INT32;
  din.data.ulptr = startstopArray;
  if ((cc=ExecLinkEx(asrv,aprp,&dout,&din,CA_READ|CA_RETRY|CA_MUTABLE,timeout)) != 0) 
  {
    *num = 0;
  }
  else 
  {
    *num = (int)dout.dArrayLength;
    *stop = (UINT32)dout.dTimeStamp;
  }
  return cc;
}
//TODO:  hash this ...
typedef struct PrpInfoItem
{
  char srv[72];
  char prp[64];
  DTYPE dout;
  DTYPE din;
  struct PrpInfoItem *nxt;
} PrpInfoItem;
PrpInfoItem *prpLst = NULL;

void addPrpItem(char *srv, char *prp, DTYPE *dout, DTYPE *din)
{
  PrpInfoItem pii, *p;
  char *c;
  if (srv == NULL || prp == NULL) return;
  if (srv[0] != '/') return; // must be fully qualified
  memset(&pii,0,72+64);
  DTYPEZERO(pii.dout); DTYPEZERO(pii.din);
  strncpy(pii.srv,srv,72);
  if ((c=strchr(&pii.srv[1],'/')) == NULL) return; // must contain a server
  c++;
  if ((c=strchr(c,'/')) != NULL) *c = 0; // lop off the device name
  strncpy(pii.prp,prp,64);
  if (dout != NULL) memcpy(&pii.dout,dout,sizeof(DTYPE)); // never called with dout = NULL !
  if (din != NULL) memcpy(&pii.din,din,sizeof(DTYPE));

  for (p=prpLst; p != NULL; p = p->nxt)
  {
    if (strnicmp(p->srv,pii.srv,66)) continue;
    if (strnicmp(p->prp,pii.prp,64)) continue;
    return; // already there !
  }
  if ((p=(PrpInfoItem *)calloc(1,sizeof(PrpInfoItem))) == NULL) return;
  memcpy(p,&pii,sizeof(PrpInfoItem));
  p->nxt = prpLst;
  prpLst = p;

  switch (dout->dFormat)
  {
    case CF_STRUCT:
      if (strlen(dout->dTag) > 0) AcquireAndRegisterStruct(srv,dout->dTag,dout->dArrayLength);
      break;
    case CF_BITFIELD8:
    case CF_BITFIELD16:
    case CF_BITFIELD32:
    case CF_BITFIELD64:
      if (strlen(dout->dTag) > 0) AcquireAndRegisterBitfield(srv,dout->dTag);
      break;
    default:
      break;
  }
  if (din != NULL) switch (din->dFormat)
  {
    case CF_STRUCT:
      if (strlen(din->dTag) > 0 && strncmp(din->dTag,dout->dTag,TAG_NAME_SIZE) != 0) 
        AcquireAndRegisterStruct(srv,din->dTag,dout->dArrayLength);
      break;
    case CF_BITFIELD8:
    case CF_BITFIELD16:
    case CF_BITFIELD32:
    case CF_BITFIELD64:
      if (strlen(din->dTag) > 0 && strncmp(din->dTag,dout->dTag,TAG_NAME_SIZE) != 0) 
        AcquireAndRegisterBitfield(srv,din->dTag);
      break;
    default:
      break;
  }
}
void addUsrPrpItem(char *srv, char *prp, int size, int fmt, char *tag,int access)
{
  DTYPE dout, din; 
  DTYPEZERO(dout); DTYPEZERO(din);
  if (access & CA_READ)
  {
    dout.dArrayLength = (UINT32)size;
    dout.dFormat = fmt;
    if (tag != NULL) strncpy(dout.dTag,tag,TAG_NAME_SIZE);
  }
  if (access & CA_WRITE)
  {
    din.dArrayLength = (UINT32)size;
    din.dFormat = fmt;
    if (tag != NULL) strncpy(din.dTag,tag,TAG_NAME_SIZE);
  }
  addPrpItem(srv,prp,&dout,&din);
}
void addUsrPrpItemEx(char *srv, char *prp, int sizeOut, int fmtOut, char *tagOut, int sizeIn, int fmtIn, char *tagIn)
{
  DTYPE dout, din; 
  DTYPEZERO(dout); DTYPEZERO(din);
  dout.dArrayLength = (UINT32)sizeOut;
  dout.dFormat = fmtOut;
  if (tagOut != NULL) strncpy(dout.dTag,tagOut,TAG_NAME_SIZE);
  din.dArrayLength = (UINT32)sizeIn;
  din.dFormat = fmtIn;
  if (tagIn != NULL) strncpy(din.dTag,tagIn,TAG_NAME_SIZE);
  addPrpItem(srv,prp,&dout,&din);
}
PrpInfoItem *getPrpItem(char *srv, char *prp)
{
  PrpInfoItem *p;
  char *c, dev[72];
  if (srv == NULL || prp == NULL) return NULL;
  memcpy(dev,srv,72);
  if (dev[0] != '/') return NULL; // must be fully qualified
  if ((c=strchr(&dev[1],'/')) == NULL) return NULL; // must contain a server
  c++; if ((c=strchr(c,'/')) != NULL) *c = 0; // lop off the device name
  for (p=prpLst; p != NULL; p = p->nxt)
  {
    if (strnicmp(p->srv,dev,66)) continue;
    if (strnicmp(p->prp,prp,64)) continue;
    return p; // found it !
  }
  return NULL;
}
void freePrpItemList(void)
{
  PrpInfoItem *p, *pnxt;
  for (p=prpLst; p != NULL; p = pnxt)
  {
    pnxt = p->nxt;
    free(p);
  }
  prpLst = NULL;
}
static int tine_getpropertyinformation(char *server, char *property, int access, int *format, int *size, char *tag) 
{
  PrpInfoItem *pii;
  PrpQueryStruct p[10], *pqs = p;
  int pn = 10;
  char errstr[128],ltag[64];
  DTYPE dout, din;
  DTYPEZERO(dout); DTYPEZERO(din);

  if ((pii=getPrpItem(server,property)) != NULL)
  { // already known ?
    if (access == CA_WRITE)
    {
      *format = (int)pii->din.dFormat;
      *size = (int)pii->din.dArrayLength;
      if (tag != NULL) strncpy(tag,pii->din.dTag,TAG_NAME_SIZE);
    }
    else
    {
      *format = (int)pii->dout.dFormat;
      *size = (int)pii->dout.dArrayLength;
      if (tag != NULL) strncpy(tag,pii->dout.dTag,TAG_NAME_SIZE);
    }
    return 0;
  }
  if (access == CA_READ && getPropertyInfoFromListenerEx(server,property,size,format,ltag) == 0)
  { // is it known to an underlying listener ?
    dout.dArrayLength = (UINT32)*size;
    dout.dFormat = (short)*format;
    strncpy(dout.dTag,ltag,TAG_NAME_SIZE);
    addPrpItem(server,property,&dout,NULL);
    if (tag != NULL) strncpy(tag,ltag,TAG_NAME_SIZE);
    return 0; // we're done
  }
  int res = invalid_property;
  Py_BEGIN_ALLOW_THREADS;
  res = GetSystemPropertyInformation(server, property, &pqs, &pn);
  Py_END_ALLOW_THREADS;
  if (res == 0 && pn > 0) 
  { // info obtained from the target server
    int index = 0;
    int i = 0;
    if (access == CA_WRITE)
    {
      for (i; i < pn; i++)
      {
        if (LFMT(p[i].prpFormatIn) != CF_NULL)
        {
          index = i;
          break;
        }
      }
      *format = (int)LFMT(p[index].prpFormatIn);
      if (*size == 0) *size = p[index].prpSizeIn;
    }
    else
    {
      *format = (int)LFMT(p[index].prpFormat);
      if (*size == 0) *size = p[index].prpSize;
    }
    dout.dArrayLength = (UINT32)p[index].prpSize;
    dout.dFormat = (short)LFMT(p[index].prpFormat);
    strncpy(dout.dTag,p[index].prpTag,TAG_NAME_SIZE);
    din.dArrayLength = (UINT32)p[index].prpSizeIn;
    din.dFormat = (short)LFMT(p[index].prpFormatIn);
    strncpy(din.dTag,p[index].prpTagIn,TAG_NAME_SIZE);
    addPrpItem(server,property,&dout,&din);
    if (tag != NULL) strncpy(tag,dout.dTag,TAG_NAME_SIZE);
    return 0;
  } 
  else 
  {
    PyErr_Format(PyExc_RuntimeError, "tine: '%s': failed to obtain information for property '%s' (%s)",
                                     server, property, GetLastLinkError(res,errstr));
    return -1;
  }
}

static int tine_read(const char *server, const char *property, void *data, int *size, int format, int access, int timeout,DTYPE *res) 
{
  DTYPE dout;
  double ts;
  int cc, acc=CA_READ|CA_MUTABLE;
  PrpInfoItem *pii;
  DTYPEZERO(dout);
  dout.data.vptr    = data;
  dout.dArrayLength = *size;
  dout.dFormat      = format;
  switch (format)
  {
    case CF_STRUCT:
    case CF_BITFIELD8:
    case CF_BITFIELD16:
    case CF_BITFIELD32:
    case CF_BITFIELD64:
      pii = getPrpItem((char *)server,(char *)property);
      if (pii != NULL) strncpy(dout.dTag,pii->dout.dTag,TAG_NAME_SIZE);
      break;
    case CF_MDA:
      {
        pii = getPrpItem((char *)server,(char *)property);
        if (pii != NULL) strncpy(dout.dTag,pii->dout.dTag,TAG_NAME_SIZE);
        DMDA *mda = (DMDA *)data;
        mda->data.bptr = dout.data.bptr + MDA_HDR_SIZE + sizeof(size_t);
      }
    default:
      break;
  }
  acc |= access;
  cc = alsnExecLinkEx((char*)server, (char*)property, &dout, NULL, acc, timeout, &ts);
  if (cc == 0)
  {
    int sz = (int)dout.dArrayLength;
    if (dout.dFormat == CF_TEXT || dout.dFormat == CF_XML)
    { // special checking (doocs servers might reduce the returned data length)
      if (*size > sz) 
      { // make sure we're null-terminated ...
        dout.data.cptr[sz] = 0;
        if (dout.data.cptr[sz-1] != 0) sz++;
      }
    }
    *size = sz;
  }
  if (res != NULL) memcpy(res,&dout,sizeof(DTYPE));
  return cc;
}

static int tine_write(const char *server, const char *property, void *data, int size, int format, char *tag, int access, int timeout) 
{
  int acc = CA_READ|CA_WRITE;
  DTYPE din, dout;
  DTYPEZERO(din); DTYPEZERO(dout);

  din.data.vptr    = data;
  din.dArrayLength = size;
  din.dFormat      = format;
  if (tag != NULL) strncpy(din.dTag,tag,TAG_NAME_SIZE);

  acc |= access;
  // Some servers generate an error if one does not read back a value.
  // Thus dout and CA_READ was added, although, not really necessary.
  return ExecLinkEx((char*)server, (char*)property, &dout, &din, (short)acc, (unsigned short)timeout);
}

static int tine_acq(const char *server, const char *property, DTYPE *dout, DTYPE *din, int access, int timeout) 
{
  double ts;
  int cc;
  switch (din->dFormat)
  {
    case CF_MDA:
    case CF_IMAGE:
      ccerr(not_supported);
    default:
      break;
  }
  switch (dout->dFormat)
  {
    case CF_MDA:
      {
        DMDA *mda = (DMDA *)dout->data.vptr;
        mda->data.bptr = dout->data.bptr + MDA_HDR_SIZE + sizeof(size_t);
      }
    default:
      break;
  }
  cc = alsnExecLinkEx((char*)server, (char*)property, dout, din, access|CA_MUTABLE, timeout, &ts);
err:
  return cc;
}

static int tine_query(const char *server, const char *property,
                      void *data_in, int size_in, int format_in,
            		      void *data_out, int *size_out, int *format_out,
		                  int timeout) 
{
  DTYPE din;
  DTYPE dout;
  int result;

  memset(&din, 0, sizeof(din));
  memset(&dout, 0, sizeof(dout));

  din.data.vptr    = data_in;
  din.dArrayLength = size_in;
  din.dFormat      = format_in;

  dout.data.vptr    = data_out;
  dout.dArrayLength = *size_out;
  dout.dFormat      = *format_out;

  result = ExecLinkEx((char*)server, (char*)property,
		      &dout, &din, CA_READ | CA_WRITE | CA_MUTABLE, timeout);

  *size_out = dout.dArrayLength;
  *format_out = dout.dFormat; 

  return result;
}

static int tine_attach(const char *server, const char *property,
                       void *data, int size, int format, int mode, int interval,
                       void (*callback)(int, int, void*), void *p, int id) 
{
  DTYPE d;
  memset(&d, 0, sizeof(d));

  d.data.vptr    = data;
  d.dArrayLength = size;
  d.dFormat      = format;

  return AttachLinkEx2((char*)server, (char*)property, &d, NULL,
                       CA_READ, interval, callback, mode, id, p);
}

static int tine_attachEx(const char *server, const char *property,
                       DTYPE *dout, DTYPE *din, int mode, int interval,
                       void (*callback)(int, int, void*), void *p, int id) 
{
  return AttachLinkEx2((char*)server, (char*)property, dout, din,
                       CA_READ, interval, callback, mode, id, p);
}

static int tine_detach(int linkid) 
{
  return CloseLink(linkid);
}

// Py_BuildValue("s", (char*)data); expects a null-terminated string
static PyObject* data_to_python(void *data, int format,char *tag) 
{
  int slen = 16;
  switch (format) 
  {
    case CF_BOOLEAN:
      return PyBool_FromLong(*((int *)data));
    case CF_BYTE:
      return Py_BuildValue("B", *((BYTE *)data));
    case CF_INT16:
      return Py_BuildValue("h", *((short *)data));
    case CF_INT32:
      return Py_BuildValue("i", *((int *)data));
#   ifdef SINT64
    case CF_INT64:
      return Py_BuildValue("l", *((SINT64 *)data));
#   endif
    case CF_INTINT:
      {
        int *d = (int *)data;
        return Py_BuildValue("(ii)", d[0], d[1]);
      }
    case CF_INTINTINT:
      {
        int *d = (int *)data;
        return Py_BuildValue("(iii)", d[0], d[1], d[2]);
      }
    case CF_INTINTINTINT:
      {
        int *d = (int *)data;
        return Py_BuildValue("(iiii)", d[0], d[1], d[2], d[3]);
      }
    case CF_FLOAT:
      return Py_BuildValue("f", *((float *)data));
    case CF_FLTFLT:
      {
        float *d = (float *)data;
        return Py_BuildValue("(ff)", d[0], d[1]);
      }
    case CF_FLTINT:
      {
        float f = *(float *)data;
        int i = ((int *)data)[1];
        return Py_BuildValue("(fi)", f, i);
      }
    case CF_INTFLTINT:
      {
        float f = ((float *)data)[1];
        int *i = (int *)data;
        return Py_BuildValue("(ifi)", i[0], f, i[2]);
      }
    case CF_FLTFLTINT:
      {
        float *f = (float *)data;
        int *i = (int *)data;
        return Py_BuildValue("(ffi)", f[0], f[1], i[2]);
      }
    case CF_FLTINTINT:
      {
        float *f = (float *)data;
        int *i = (int *)data;
        return Py_BuildValue("(fii)", f[0], i[1], i[2]);
      }
    case CF_INTFLTFLTFLT:
      {
        float *f = (float *)data;
        int *i = (int *)data;
        return Py_BuildValue("(ifff)", i[0], f[1], f[2], f[3]);
      }
    case CF_INTINTFLTFLT:
      {
        float *f = (float *)data;
        int *i = (int *)data;
        return Py_BuildValue("(ifff)", i[0], i[1], f[2], f[3]);
      }
    case CF_FLTINTFLTINT:
      {
        float *f = (float *)data;
        int *i = (int *)data;
        return Py_BuildValue("(fifi)", f[0], i[1], f[2], i[3]);
      }
    case CF_DOUBLE:
      return Py_BuildValue("d", *((double *)data));
    case CF_DBLDBL:
      {
        double *d = (double *)data;
        return Py_BuildValue("(dd)", d[0], d[1]);
      }
    case CF_DBLDBLDBL:
      {
        double *d = (double *)data;
        return Py_BuildValue("(ddd)", d[0], d[1], d[2]);
      }
    case CF_KEYVALUE:
    case CF_STRING:
    case CF_XML:
    case CF_TEXT:
      return Py_BuildValue("s", (char *)data);
    case CF_NAME16:
    case CF_NAME32:
    case CF_NAME48:
    case CF_NAME64:
      slen = (int)MIN(fmtsizeof(format),strlen((char *)data));
      return Py_BuildValue("s#", (char *)data,slen);
    case CF_USTRING:
      {
        float *f = (float *)data;
        int *i = (int *)data;
        char s[84];
        strncpy(s,(char *)data + 16,80); s[80] = 0;
        return Py_BuildValue("iffis",i[0],f[1],f[2],i[3],s);
      }
    case CF_UNAME:
      {
        float *f = (float *)data;
        int *i = (int *)data;
        char s[20];
        strncpy(s,(char *)data + 16,20); s[16] = 0;
        return Py_BuildValue("ifffs",i[0],f[1],f[2],f[3],s);
      }
    case CF_NAME16I:
    case CF_NAME32I:
    case CF_NAME48I:
    case CF_NAME64I:
      {
        int flen = fmtsizeof(format), ival;
        char s[72]; memset(s,0,72);
        slen = flen - 4;
        memcpy(&ival,(BYTE *)data+flen-slen,4);
        strncpy(s,(char *)data,slen);
        slen = (int)MIN(slen,strlen(s));
        return Py_BuildValue("s#i", (char*)data,slen,ival);
      }
    case CF_NAME16FI:
      {
        char *s = (char *)data;
        float f = *(float *)(s + 16);
        int i = *(int *)(s + 20);
        return Py_BuildValue("s#fi", s,16,f,i);
      }
    case CF_NAME16II:
      {
        char *s = (char *)data;
        int *i = (int *)(s + 16);
        return Py_BuildValue("s#ii", s,16,i[0],i[1]);
      }
    case CF_NAME16DBLDBL:
    case CF_NAME32DBLDBL:
    case CF_NAME64DBLDBL:
      {
        int flen = fmtsizeof(format);
        char *s = (char *)data;
        double *d = (double *)(s + 16);
        slen = flen - 16;
        return Py_BuildValue("s#dd", s,slen,d[0],d[1]);
      }
    case CF_NAME64DBLDBLDBL:
      {
        char *s = (char *)data;
        double *d = (double *)(s + 16);
        return Py_BuildValue("s#ddd", s,64,d[0],d[1],d[2]);
      }
    case CF_BITFIELD8:
    case CF_BITFIELD16:
    case CF_BITFIELD32:
    case CF_BITFIELD64:
      {
        DBITFIELD *bf = findBitField(NULL,tag); // NULL out the server dependency
        struct bitfieldFormat *bff;
        if (bf == NULL) return PyErr_Format(PyExc_IOError, "bitfield %s is not registered",tag);
        PyObject *pdo = PyDict_New();
        PyObject *item;
        int ival;
        for (bff=bf->bfs; bff != NULL; bff=bff->nxt)
        {
          ival = GetFieldFromBitfield(NULL,tag,bff->field,*(int *)data);
          item = data_to_python(&ival,CF_INT32,NULL);
          if (item == NULL) return NULL;
          PyDict_SetItemString(pdo,bff->field,item);
        }
        return pdo;
      }
    case CF_STRUCT:
      {
        struct structStruct *ss = GetStructFromTag(tag);
        if (ss == NULL) return PyErr_Format(PyExc_IOError, "structure %s is not registered",tag);
        struct structFormat *sf;
        int i, nfields = 0;
        for (sf=ss->s; sf != NULL; sf=sf->nxt) nfields++;
        PyObject *pdo = PyDict_New();
        PyObject *item;
        BYTE *p;
        for (sf=ss->s, i=0; sf != NULL && i<nfields; sf=sf->nxt, i++) 
        {
          if (sf->fmt == CF_NULL) continue;
          p = (BYTE *)data + sf->addr;
          if (sf->siz == 1 || sf->fmt == CF_TEXT) 
          {
            item = data_to_python(p,sf->fmt,sf->stag);
          }
          else 
          {
            item = NULL;
            array_to_python(&item,p,sf->siz,sf->fmt,sf->stag, FALSE);
          }
          if (item == NULL) return NULL;
          PyDict_SetItemString(pdo,sf->field,item);
        }
        return pdo;
      }
    //case CF_IMAGE, CF_SPECTRUM, CF_MDA: // handled in array_to_python
    default:
      return NULL;
  }
}

static int array_to_pythonL(PyObject **o, void *data, int size, int format) 
{
  if (size <= 0) 
  {
    *o = NULL;
    return -1;
  } 
  else if (size == 1 && format != CF_TEXT) 
  {
    *o = data_to_python(data, format, NULL);
    return 0;
  } 
  else if (format == CF_TEXT) 
  {
    int total_size = fmtsizeof(format) * size;
    data = (char *) realloc(data, total_size + 1);
    ((char *) data)[total_size] = '\0';
    *o = data_to_python(data, format, NULL);
    return 0;
  
  } 
  else 
  {
    int i;
    *o = PyList_New(size);
    for (i = 0; i < size; ++i) 
    {
      void *p = (char*)data + i * fmtsizeof(format);

      PyObject *item = data_to_python(p, format, NULL);
      PyList_SetItem(*o, i, item);
    }
    return 0;
  }
}
void getMdaIndicies(int *ia,int ival,DMDA *mda)
{
  int i;
  for (i=mda->ndim-1; i>=0; i--)
  {
    ia[i] = ival % (mda->axis[i].len);
    ival /= mda->axis[i].len;
  }
}
int getAppendedImageWidth(const DIMAGE * const apImage)
{
  if (apImage->frameHeader.aoiWidth > 0)
    return apImage->frameHeader.aoiWidth;
  else
    return apImage->frameHeader.sourceWidth;
}
int getAppendedImageHeight(const DIMAGE * const apImage)
{
  if (apImage->frameHeader.aoiHeight > 0)
    return apImage->frameHeader.aoiHeight;
  else
    return apImage->frameHeader.sourceHeight;
}
static bool checkImageValidity(const DIMAGE * const apImage)
{
  // checks CF_IMAGE validity
  // taken out of VSv3 general source file DImageClass.cpp by StefanW on Sept 15, 2015
  // modified c&p'ed code to work with tinedefs.h constants
  // requires up-to-date tinedefs.h for constant definitions which have not been present before 
  if (apImage->sourceHeader.baseTag != CF_IMAGE_BASETAG) return false;
  if (apImage->frameHeader.sourceWidth < 1) return false;
  if (apImage->frameHeader.sourceHeight < 1) return false;
  if (apImage->frameHeader.aoiWidth < -1)  return false;
  if (apImage->frameHeader.aoiWidth > 0)
  {
    if ((apImage->frameHeader.aoiWidth + apImage->frameHeader.xStart) > apImage->frameHeader.sourceWidth) return false;
  }
  if (apImage->frameHeader.aoiHeight < -1)  return false;
  if (apImage->frameHeader.aoiHeight > 0)
  {
    if ((apImage->frameHeader.aoiHeight + apImage->frameHeader.yStart) > apImage->frameHeader.sourceHeight) return false;
  }
  if (apImage->frameHeader.xStart < 0) return false;
  if (apImage->frameHeader.xStart >= apImage->frameHeader.sourceWidth) return false;
  if (apImage->frameHeader.yStart < 0) return false;
  if (apImage->frameHeader.yStart >= apImage->frameHeader.sourceHeight) return false;
  if (apImage->frameHeader.bytesPerPixel < 1 || apImage->frameHeader.bytesPerPixel > 4) return false;
  // source-format: must be one of the supported formats
  if ((apImage->frameHeader.sourceFormat < 0) || (apImage->frameHeader.sourceFormat > IF_MAX)) return false;
  // image-format: must be one of the supported formats
  if ((apImage->frameHeader.imageFormat < 0) || (apImage->frameHeader.imageFormat > IF_MAX)) return false;
  if (apImage->frameHeader.appendedFrameSize > 0)
  {
    if (apImage->frameHeader.appendedFrameSize > (signed)apImage->frameBufferSize) return false;
    if (apImage->frameBuffer == NULL) return false;
    if (apImage->sourceHeader.totalLength != (sizeof(hdrIMAGE) + apImage->frameHeader.appendedFrameSize)) return false;
  }
  else
  {	// no appended frame so totalLength must be set to headersize
    if (apImage->sourceHeader.totalLength != sizeof(hdrIMAGE)) return false;
  }
  return true;
}
static bool imageInvalid(const char *reason, char *err)
{
  strncpy(err,reason,128);
  return false;
}
static bool checkRestrictedImageValidity(const DIMAGE  * const apImage, char *err)
{ // checks restricted CF_IMAGE validity
  // taken out of VSv3 general source file DImageClass.cpp by StefanW on Sept 15, 2015
  // modified c&p'ed code to work with tinedefs.h constants
  // requires up-to-date tinedefs.h for constant definitions which have not been present before 

  if (checkImageValidity(apImage) == false) return imageInvalid("image header invalid",err);
  if (apImage->frameHeader.imageFormat == IF_JPEG) return true;
  if ((apImage->frameHeader.imageFormat != IF_GRAY) &&
    //(m_Img.frameHeader.imageFormat != CDIMAGE::FORMAT_RGBA)	&&
      (apImage->frameHeader.imageFormat != IF_RGB)) return imageInvalid("image must be GRAY or RGB",err);
  if (apImage->frameHeader.imageFormat == IF_GRAY)
  {
    if ((apImage->frameHeader.bytesPerPixel < 1) || (apImage->frameHeader.bytesPerPixel > 2)) return imageInvalid("bytes per pixel must be 1 or 2",err);
    if (apImage->frameHeader.effectiveBitsPerPixel != -1)
    {
      if ((apImage->frameHeader.bytesPerPixel == 1) && (apImage->frameHeader.effectiveBitsPerPixel != 8))
        return imageInvalid("invalid bits per pixel",err);
      if (apImage->frameHeader.bytesPerPixel == 2)
      {
        if ((apImage->frameHeader.effectiveBitsPerPixel < 9) || (apImage->frameHeader.effectiveBitsPerPixel > 16))
            return imageInvalid("invalid bits per pixel",err);
      }
    }
  }
  if (apImage->frameHeader.imageFormat == IF_RGB)
  {
    if (apImage->frameHeader.bytesPerPixel != 3) return imageInvalid("invalid bytes per pixel",err);;
    if (apImage->frameHeader.effectiveBitsPerPixel != -1)
    {
      if (apImage->frameHeader.effectiveBitsPerPixel != 24) return imageInvalid("invalid bits per pixel",err);;
    }
  }
  if (apImage->frameHeader.appendedFrameSize > 0)
  {
    if ((getAppendedImageWidth(apImage)*
         getAppendedImageHeight(apImage)*
         apImage->frameHeader.bytesPerPixel) > apImage->frameHeader.appendedFrameSize) return imageInvalid("effective frame size > appended frame size",err);
  }
  return true;
}
#ifdef USE_NUMPY
static PyArrayObject *transcodeImageToPythonArray(const DIMAGE * const apImage)
{
  PyArrayObject *returnArray = NULL;
  bool bSuccessfullyTranscoded = false;
  bool bRestrictedValidityPassed = false;
  bool bTransformationUnimplemented = false;
  char errstr[128] = "";

  if (checkRestrictedImageValidity(apImage,errstr) == true)
  {
    bRestrictedValidityPassed = true;        
    if (apImage->frameHeader.imageFormat == IF_GRAY)
    {
      // FIXME area of interest (creation of black border video frame around small 
      // area of interest 'window') is not implemented yet, currently if an aoi is 
      // transported, the resulting image array will only contain the aoi StefanW Sept 15, 2015
      const int numDimensions = 2;
      const int dimensionY = getAppendedImageHeight(apImage);
      const int dimensionX = getAppendedImageWidth(apImage);
      int dims[numDimensions];
      dims[0] = dimensionY;
      dims[1] = dimensionX;
      int numPixels = dimensionX * dimensionY;
      if (apImage->frameHeader.bytesPerPixel == 1)
      {
        returnArray = (PyArrayObject *)PyArray_FromDims(numDimensions, dims, NPY_UINT8);
        if (returnArray != NULL)
        {
          unsigned char *pixels = (unsigned char *) apImage->frameBuffer;
          unsigned char *destPix = (unsigned char *)PyArray_DATA(returnArray);
          memcpy(destPix, pixels, numPixels);
          bSuccessfullyTranscoded = true;
        }
      }
      else if (apImage->frameHeader.bytesPerPixel == 2)
      {
        returnArray = (PyArrayObject *)PyArray_FromDims(numDimensions, dims, NPY_UINT16);
        if (returnArray != NULL)
        {
          unsigned short *pixels = (unsigned short *)apImage->frameBuffer;
          unsigned short *destPix = (unsigned short *)PyArray_DATA(returnArray);
          memcpy(destPix, pixels, numPixels * apImage->frameHeader.bytesPerPixel);
          bSuccessfullyTranscoded = true;
        }
      }
    }
    else if (apImage->frameHeader.imageFormat == IF_RGB)
    {
      if (apImage->frameHeader.bytesPerPixel == 3)
      {
        const int numDimensions = 3;
        const int dimensionY = getAppendedImageHeight(apImage);
        const int dimensionX = getAppendedImageWidth(apImage);
        int dims[numDimensions];
        dims[0] = dimensionY;
        dims[1] = dimensionX;
        dims[2] = 3; // 3 bytes: red, green, blue [0..255]
        int numPixels = dimensionX * dimensionY;
        returnArray = (PyArrayObject *)PyArray_FromDims(numDimensions, dims, NPY_UINT8);
        if (returnArray != NULL)
        {
          unsigned char *pixels = (unsigned char *)apImage->frameBuffer;
          unsigned char *destPix = (unsigned char *)PyArray_DATA(returnArray);
          memcpy(destPix, pixels, numPixels * apImage->frameHeader.bytesPerPixel);

          bSuccessfullyTranscoded = true;
        }
      }
    }
    else if (apImage->frameHeader.imageFormat == IF_JPEG)
    {
      const int numDimensions = 1;
      int dims[numDimensions];
      dims[0] = apImage->frameHeader.appendedFrameSize;
      returnArray = (PyArrayObject *)PyArray_FromDims(numDimensions, dims, NPY_UINT8);
      if (returnArray != NULL)
      {
        unsigned char *pixels = (unsigned char *)apImage->frameBuffer;
        unsigned char *destPix = (unsigned char *)PyArray_DATA(returnArray);
        memcpy(destPix, pixels, apImage->frameHeader.appendedFrameSize);

        bSuccessfullyTranscoded = true;
      }
    }
    else bTransformationUnimplemented = true;
  }
  if (bSuccessfullyTranscoded == false)
  {
    char sBuffer[300];
    const char sAlternative[] = "As an alternative, raw video frame bytes as 1-dimensional "
        "array will be delivered instead, but most probably this "
        "data will be useless.";
    if (bRestrictedValidityPassed == false)
    {
      snprintf(sBuffer, sizeof(sBuffer) - 1,
        "[%s:%d]: Frame header contents look inconsistent, did not pass restricted validity checks."
        " As a consequence, image data will not be decoded to image matrix (multidimensional array)."
        " %s", __FILE__, __LINE__, sAlternative);
    }
    else
    {
      if (bTransformationUnimplemented == true)
      {
        snprintf(sBuffer, sizeof(sBuffer) - 1,
          "[%s:%d]: Decoding to image array is not implemented for this type of image data."
          " %s", __FILE__, __LINE__, sAlternative);
      }
      else
      {
        snprintf(sBuffer, sizeof(sBuffer) - 1,
          "[%s:%d]: Decoding to image array failed for this image data."
          " %s", __FILE__, __LINE__, sAlternative);
      }
    }
    sBuffer[sizeof(sBuffer) - 1] = 0;
    PyErr_WarnEx(NULL, sBuffer, 1);

    if (apImage->frameHeader.appendedFrameSize > 0)
    {
      const int numDimensions = 1;
      const int dimensionA = apImage->frameHeader.appendedFrameSize;
      int dims[numDimensions];
      dims[0] = dimensionA;
      returnArray = (PyArrayObject *)PyArray_FromDims(numDimensions, dims, NPY_UINT8);
      if (returnArray != NULL)
      {
        unsigned char *arr = (unsigned char *)PyArray_DATA(returnArray);
        memcpy(arr, apImage->frameBuffer, apImage->frameHeader.appendedFrameSize);
      }
    }
    else
    {
      snprintf(sBuffer, sizeof(sBuffer) - 1,
        "[%s:%d]: Delivering alternative 1-dimensional array not possible. Reason: "
        "frameHeader.appendedFrameSize needs to be > 0, but appendedFrameSize is '%d'.",
        __FILE__, __LINE__, apImage->frameHeader.appendedFrameSize);
      sBuffer[sizeof(sBuffer) - 1] = 0;
      PyErr_WarnEx(NULL, sBuffer, 1);
    }
  }
  return returnArray;
}
#endif
static BYTE *getRawImageArray(const DIMAGE * const apImage, int *numBytes)
{
  if (apImage->frameHeader.appendedFrameSize <= 0) return NULL;
  if (numBytes != NULL) *numBytes = apImage->frameHeader.appendedFrameSize;
  return apImage->frameBuffer;
}
static int array_to_python(PyObject **o, void *data, int size, int format, char *tag, int use_bytearray) 
{
  if (size <= 0) 
  {
    *o = Py_BuildValue("");
    return -1;
  } 
  PyObject *item;
  BYTE *p;
  char *bd;
  int i;
  switch (format)
  {
    case CF_TEXT:
    case CF_XML:
      bd = (char *)data;
      if (bd[size-1] != 0) 
      {
        if ((bd=(char *)malloc(size+8)) == NULL)
        { // oops!  reset it and lop off the end
          bd = (char *)data;
          size--;
        }
        else
        {
          memcpy(bd,data,size);
        }
        bd[size] = 0;
      }
      *o = data_to_python(bd, format, tag);
      if (bd != data) free(bd);
      break;
    case CF_SPECTRUM:
      {
        hdrSPECTRUM *hdr = (hdrSPECTRUM *)data;
        PyObject *spect = PyList_New(size);
        p = (BYTE *)data + sizeof(hdrSPECTRUM);
        for (i=0; i < size; i++) 
        {
          item = data_to_python(p, CF_FLOAT, tag);
          PyList_SetItem(spect, i, item);
          p += sizeof(float);
        }
        *o = Py_BuildValue("{s:s,s:i,s:f,s:f,s:i,s:O}", 
          "comment",hdr->comment,"utc",hdr->tm,"start",hdr->s_start,"inc",hdr->s_inc,"status",hdr->status,
          "data",spect);
        Py_CLEAR(spect);
      }
      break;
    case CF_IMAGE:
      {
        DIMAGE *img = (DIMAGE *)data;
        p = img->frameBuffer;
        PyObject *srcHdr;
        PyObject *frmHdr;
        srcHdr = Py_BuildValue("{s:i,s:i,s:i,s:i,s:i,s:i,s:s}",
          "baseTag",img->sourceHeader.baseTag,
          "cameraPortId",img->sourceHeader.cameraPortId,
          "versionTag",img->sourceHeader.versionTag,
          "totalLength",img->sourceHeader.totalLength,
          "timestampSeconds",img->sourceHeader.timestampSeconds,
          "timestampMicroseconds",img->sourceHeader.timestampMicroseconds,
          "cameraPortName",img->sourceHeader.cameraPortName);
        frmHdr = Py_BuildValue("{s:i,s:i,s:i,s:i,s:i,s:i,s:i,s:i,s:i,s:i,s:i,s:i,s:i,s:i,s:f,s:f,s:f,s:f,s:f,s:f,s:i,s:i,s:i,s:i,s:i}",
          "sourceWidth",img->frameHeader.sourceWidth,
          "sourceHeight",img->frameHeader.sourceHeight,
          "aoiWidth",img->frameHeader.aoiWidth,
          "aoiHeight",img->frameHeader.aoiHeight,
          "xStart",img->frameHeader.xStart,
          "yStart",img->frameHeader.yStart,
          "bytesPerPixel",img->frameHeader.bytesPerPixel,
          "effectiveBitsPerPixel",img->frameHeader.effectiveBitsPerPixel,
          "horizontalBinning",img->frameHeader.horizontalBinning,
          "verticalBinning",img->frameHeader.verticalBinning,
          "sourceFormat",img->frameHeader.sourceFormat,
          "imageFormat",img->frameHeader.imageFormat,
          "frameNumber",img->frameHeader.frameNumber,
          "eventNumber",img->frameHeader.eventNumber,
          "xScale",img->frameHeader.xScale,
          "yScale",img->frameHeader.yScale,
          "imageRotation",img->frameHeader.imageRotation,
          "fspare1",img->frameHeader.fspare1,
          "fspare2",img->frameHeader.fspare2,
          "fspare3",img->frameHeader.fspare3,
          "imageFlags",img->frameHeader.imageFlags,
          "ispare1",img->frameHeader.ispare1,
          "ispare2",img->frameHeader.ispare2,
          "ispare3",img->frameHeader.ispare3,
          "appendedFrameSize",img->frameHeader.appendedFrameSize);
        // make the image from img->frameBuffer (appendedFrameSize bytes < img->frameBufferSize bytes)
#       ifdef USE_NUMPY
        PyArrayObject *imgArr = transcodeImageToPythonArray(img); 
        if (imgArr == NULL)
        {
          *o = Py_BuildValue("{s:O,s:O,s:s}",
              "sourceHeader", srcHdr, "frameHeader", frmHdr, "imageMatrix", "NULL");
        }
        else
        {
          *o = Py_BuildValue("{s:O,s:O,s:O}",
              "sourceHeader", srcHdr, "frameHeader", frmHdr, "imageMatrix", PyArray_Return(imgArr));
        }
#       else
        int nb = 0;
        BYTE *imgBytesArr = getRawImageArray(img, &nb);
        if (imgBytesArr == NULL) 
        {
          PyErr_SetString(PyExc_TypeError, "No image bytes returned");
          return -1;
        }
        *o = Py_BuildValue("{s:O,s:O,s:y#}",
            "sourceHeader", srcHdr, "frameHeader", frmHdr, "imageBytes",imgBytesArr,nb);
        Py_CLEAR(srcHdr);
        Py_CLEAR(frmHdr);
#       endif
      }
      break;
    case CF_MDA:
      { // tag will contain the canonical type (e.g. 'FLOAT')
        DMDA *mda = (DMDA *)data;
        PyObject *pdo = PyDict_New();
        PyObject *item;
        PyObject *oa[MAX_MDA_DIMS];
        int slen = (int)MIN(80,strlen(mda->cmt));
        item = Py_BuildValue("s#", mda->cmt,slen);
        PyDict_SetItemString(pdo,"description",item);
        int fmt = GetFormatFromString(tag);
        int siz = 1, fsiz = fmtsizeof(fmt);
        int ia[MAX_MDA_DIMS];
        for (i=0; i<mda->ndim; i++)
        { // the axis information ...
          item = Py_BuildValue("{s:i,s:i,s:s,s:f,s:f}",
            "dim",i,
            "len",mda->axis[i].len,
            "units",mda->axis[i].units,
            "min",mda->axis[i].min,
            "max",mda->axis[i].max);
          PyDict_SetItemString(pdo,mda->axis[i].label,item);
          siz *= mda->axis[i].len;
          oa[i] = NULL;
        }
        int in;
        p = mda->data.bptr;
        for (i=0; i<siz; i++)
        {
          getMdaIndicies(ia,i,mda);
          item = data_to_python(p, fmt, tag);
          p += fsiz;
          in = mda->ndim - 1;
          if (oa[in] == NULL) oa[in] = PyList_New(mda->axis[in].len);
          PyList_SetItem(oa[in], ia[in], item);
          while (in > 0 && ia[in] == mda->axis[in].len-1)
          {
            if (oa[in-1] == NULL) oa[in-1] = PyList_New(mda->axis[in-1].len);
            PyList_SetItem(oa[in-1], ia[in-1], oa[in]);
            oa[in] = NULL;
            in--;
          }
        }
        PyDict_SetItemString(pdo,"data",oa[0]);
        *o = pdo;
      }
      break;
    case CF_KEYVALUE:
    case CF_STRING:
      {
        char **s = (char **)data;
        if (size == 1) *o = data_to_python(s[0],format, tag);
        else
        {
          *o = PyList_New(size);
          for (i=0; i<size; i++)
          {
            item = data_to_python(s[i],format, tag);
            PyList_SetItem(*o, i, item);
          }
        }
        break;
      }
    default:
      int fsiz = fmtsizeof(format);
      if (format == CF_STRUCT) fsiz = GetStructSize(tag);
      if (size == 1)
      {
        *o = data_to_python(data, format, tag);
      }
      else if (use_bytearray)
      {
        int nb = size * fsiz;
        *o = Py_BuildValue("y#", ((BYTE *)data), nb);
      }
      else
      {
        *o = PyList_New(size);
        for (i=0; i<size; i++) 
        {
          p = (BYTE *)data + i*fsiz;
          item = data_to_python(p, format, tag);
          PyList_SetItem(*o, i, item);
        }
        break;
      }
  }
  return 0;
}

static int data_from_python(PyObject *o, void *data, int format, char *tag)
{
  char *tmp;
  int slen = 16;
  PyObject *tuple = Py_BuildValue("(O)", o);
  switch (format) 
  {
    case CF_BYTE:
      PyArg_ParseTuple(tuple, "B", (BYTE *)data);
      break;
    case CF_INT16:
      PyArg_ParseTuple(tuple, "h", (short *)data);
      break;
    case CF_BOOLEAN:
    case CF_INT32:
      PyArg_ParseTuple(tuple, "i", (int *)data);
      break;
    case CF_INTINT:
      {
        int *d = (int *)data;
        PyArg_ParseTuple(tuple, "(ii)", d, &d[1]);
        break;
      }
    case CF_INTINTINT:
      {
        int *d = (int *)data;
        PyArg_ParseTuple(tuple, "(iii)", d, &d[1], &d[2]);
        break;
      }
    case CF_INTINTINTINT:
      {
        int *d = (int *)data;
        PyArg_ParseTuple(tuple, "(iiii)", d, &d[1], &d[2], &d[3]);
        break;
      }
    case CF_FLOAT:
      PyArg_ParseTuple(tuple, "f", (float*)data);
      break;
    case CF_FLTFLT:
      {
        float *d = (float *)data;
        PyArg_ParseTuple(tuple, "(ff)", d, &d[1]);
        break;
      }
    case CF_FLTINT:
      {
        FLTINT *d = (FLTINT *)data;
        PyArg_ParseTuple(tuple,"(fi)", &d->fval, &d->ival);
        break;
      }
    case CF_INTFLTINT:
      {
        INTFLTINT *d = (INTFLTINT *)data;
        PyArg_ParseTuple(tuple,"(ifi)",&d->i1val,&d->fval,&d->i2val);
        break;
      }
    case CF_FLTFLTINT:
      {
        FLTFLTINT *d = (FLTFLTINT *)data;
        PyArg_ParseTuple(tuple,"(ffi)",&d->f1val,&d->f2val,&d->ival);
        break;
      }
    case CF_FLTINTINT:
      {
        FLTINTINT *d = (FLTINTINT *)data;
        PyArg_ParseTuple(tuple,"(fii)",&d->fval,&d->i1val,&d->i2val);
        break;
      }
    case CF_INTFLTFLTFLT:
      {
        DFILTER *d = (DFILTER *)data;
        PyArg_ParseTuple(tuple,"(ifff)",&d->ival,&d->f1val,&d->f2val,&d->f3val);
        break;
      }
    case CF_INTINTFLTFLT:
      {
        FWINDOW *d = (FWINDOW *)data;
        PyArg_ParseTuple(tuple,"(iiff)",&d->i1val,&d->i2val,&d->f1val,&d->f2val);
        break;
      }
    case CF_FLTINTFLTINT:
      {
        FLTINTFLTINT *d = (FLTINTFLTINT *)data;
        PyArg_ParseTuple(tuple,"(fifi)",&d->f1val,&d->i1val,&d->f2val,&d->i2val);
        break;
      }
    case CF_DOUBLE:
      PyArg_ParseTuple(tuple, "d", (double*)data);
      break;
    case CF_DBLDBL:
      {
        double *d = (double *)data;
        PyArg_ParseTuple(tuple, "(dd)", d, &d[1]);
        break;
      }
    case CF_DBLDBLDBL:
      {
        double *d = (double *)data;
        PyArg_ParseTuple(tuple, "(ddd)", d, &d[1], &d[2]);
        break;
      }
    case CF_KEYVALUE:
    case CF_STRING:
    case CF_XML:
    case CF_TEXT:
      if (PyArg_ParseTuple(tuple, "s", &tmp)) strcpy((char *)data, tmp);
      break;
    case CF_NAME16:
    case CF_NAME32:
    case CF_NAME48:
    case CF_NAME64:
      /* Python pre-allocates memory for the string. */
      slen = fmtsizeof(format);
      if (PyArg_ParseTuple(tuple, "s", &tmp)) strncpy((char *)data, tmp,slen);
      break;
    case CF_USTRING:
      {
        DUSTRING *d = (DUSTRING *)data;
        if (PyArg_ParseTuple(tuple,"(iffis)",&d->ival,&d->f1val,&d->f2val,&d->tm,&tmp))
          strncpy(d->str,tmp,80);
        break;
      }
    case CF_UNAME:
      {
        DUNAME *d = (DUNAME *)data;
        if (PyArg_ParseTuple(tuple,"(ifffs)",&d->ival,&d->f1val,&d->f2val,&d->f3val,&tmp))
          strncpy(d->name,tmp,16);
        break;
      }
    case CF_NAME16I:
    case CF_NAME32I:
    case CF_NAME48I:
    case CF_NAME64I:
      {
        int flen = fmtsizeof(format), ival;
        slen = flen - 4;
        if (PyArg_ParseTuple(tuple,"(si)",&tmp,&ival))
        {
          memcpy((BYTE *)data+flen-slen,&ival,sizeof(SINT32));
          slen = (int)MIN(slen,strlen(tmp));
          strncpy((char *)data,tmp,slen);
        }
        break;
      }
    case CF_NAME16FI:
      {
        float fval;
        int ival;
        if (PyArg_ParseTuple(tuple,"(sfi)",&tmp,&fval,&ival))
        {
          memcpy((BYTE *)data+16,&fval,sizeof(float));
          memcpy((BYTE *)data+20,&ival,sizeof(SINT32));
          slen = (int)MIN(slen,strlen(tmp));
          strncpy((char *)data,tmp,slen);
        }
        break;
      }
    case CF_NAME16II:
      {
        int i[2];
        if (PyArg_ParseTuple(tuple,"(sii)",&tmp,&i[0],&i[1]))
        {
          memcpy((BYTE *)data+16,i,2*sizeof(SINT32));
          slen = (int)MIN(slen,strlen(tmp));
          strncpy((char *)data,tmp,slen);
        }
        break;
      }
    case CF_NAME16DBLDBL:
    case CF_NAME32DBLDBL:
    case CF_NAME64DBLDBL:
      {
        int flen = fmtsizeof(format);
        slen = flen - 16;
        double d[2];
        if (PyArg_ParseTuple(tuple,"(sdd)",&tmp,&d[0],&d[1]))
        {
          memcpy((BYTE *)data+slen,d,2*sizeof(double));
          slen = (int)MIN(slen,strlen(tmp));
          strncpy((char *)data,tmp,slen);
        }
        break;
      }
    case CF_NAME64DBLDBLDBL:
      {
        double d[3];
        if (PyArg_ParseTuple(tuple,"(sddd)",&tmp,&d[0],&d[1],&d[2]))
        {
          slen = 64;
          memcpy((BYTE *)data+slen,d,3*sizeof(double));
          slen = (int)MIN(slen,strlen(tmp));
          strncpy((char *)data,tmp,slen);
        }
        break;
      }
    case CF_STRUCT:
      {
        if (!PyDict_Check(o))
        {
          PyErr_SetString(PyExc_TypeError, "dictionary expected for structure type");
          break;
        }
        PyObject *item;
        char s[128];
        struct structStruct *ss = GetStructFromTag(tag);
        if (ss == NULL) 
        {
          sprintf(s,"structure %s is not registered",tag);
          PyErr_SetString(PyExc_IOError, s);
          return -1;
        }
        BYTE *p;
        struct structFormat *sf;
        int nfields = 0;
        char fld[32]; memset(fld,0,32);
        for (sf=ss->s; sf != NULL; sf=sf->nxt) 
        {
          p = (BYTE *)data + sf->addr;
          strncpy(fld,sf->field,16); 
          item = PyDict_GetItemString(o, fld);
          if (item == NULL)
          {
            sprintf(s,"dictionary missing key: %.16s",fld);
            PyErr_SetString(PyExc_TypeError, s);
            break;
          }
          data_from_python(item,p,sf->fmt,sf->stag);
          nfields++;
        }
        break;
      }
    default:
      PyErr_SetString(PyExc_TypeError, "attempt to convert unhandled type (single element is not a supported type)");
      break;
  }
  Py_CLEAR(tuple);

  return PyErr_Occurred() == NULL ? 0 : -1;
}
static int array_length_from_python(PyObject *o)
{ // used to determine input length when not explicitly given
  if (o == NULL) return 0;
  if (PyBytes_Check(o)) return (int)PyBytes_Size(o);
  if (PyUnicode_Check(o)) return 1;  // 1 string 
  if (PyList_Check(o)) return (int)PyList_Size(o);
  return 1;
}
static void* array_from_python(PyObject *o, int *size, int format, char *tag) 
{
  if (PyDict_Check(o) && (tag == NULL || strlen(tag) == 0))
  { // a dictionary passed but it doesn't appear to be a structure
    o = PyDict_GetItemString(o, "data");
    if (o == NULL) 
    {
      PyErr_SetString(PyExc_TypeError, "no recognizable data passed !");
      return NULL;
    }
  }
  if (PyBytes_Check(o))
  {
    if (*size == 1) *size = (int)PyBytes_Size(o);
  }
  if (PyUnicode_Check(o))
  { // 1 string item passed
    int sz = (int)PyUnicode_GetSize(o);
    if (fmtsizeof(format) == 1)
    { // either CF_TEXT or CF_STRING
      if (*size < sz) *size = sz;
    }
    else
    { // input likely 1 NAME64, 1 USTRING, etc.
      if (*size < 1) *size = 1;
    }
  }
  if (PyLong_Check(o) || PyFloat_Check(o) || PyBytes_Check(o) || PyDict_Check(o) || PyUnicode_Check(o) || PyTuple_Check(o))
  {
    int total_size;
    total_size = *size * fmtsizeof(format);
    if (format == CF_TEXT || format == CF_STRING) total_size++;
    if (format == CF_STRUCT) total_size *= GetStructSize(tag);
    void *data = malloc(total_size);
    memset(data, 0, total_size);    
    if (data_from_python(o, data, format, tag) != 0) 
    {
      free(data);
      return NULL;
    }
    return data;
  } 
  if (PyList_Check(o)) 
  { // an array of something ...
    void *data, *p;
    PyObject *item;
    int i, dsize, imax = (int)PyList_Size(o);
    if (imax > *size) *size = imax;
    if (format == CF_STRING)
    { // special considerations ...
      dsize = 0;
      for (i = 0; i < imax; i++)
      {
        item = PyList_GetItem(o, i);
        if (PyUnicode_Check(item))
        { // this should be TRUE if format == CF_STRING!
          dsize += (int)(PyUnicode_GetSize(item)+1);
        }
        else
        {
          PyErr_SetString(PyExc_TypeError, "an array of strings was not passed!");
          return NULL;
        }
      }
    }
    else
    {
      dsize = imax * fmtsizeof(format);
    }
    data = malloc(dsize);
    int ptr = 0;
    for (i=0; i<imax; i++) 
    {
      //p = (char *)data + i * fmtsizeof(format);
      p = (char *)data + ptr;
      item = PyList_GetItem(o, i);
      ptr += (format == CF_STRING ? (int)(PyUnicode_GetSize(item) + 1) : fmtsizeof(format));
      if (data_from_python(item, p, format, tag)) 
      {
        free(data);
        return NULL;
      }
    }
    *size = imax;
    return data;
  } 
  else 
  {
    PyErr_SetString(PyExc_TypeError, "attempt to convert unhandled type (not a number, string, byte array, dictionary, or list)");
    return NULL;
  }
}

static PyObject* pytine_setAttribute(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *attr, *typestr = NULL;
  PyObject *value = NULL;
  void *data;
  int format = CF_INT32;
  int size=1,res;
  char errstr[128];
  static char *kwlist[] = {
        "attribute",
        "value",
        "format",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO|s",  kwlist, &attr, &value, &typestr)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.setAttribute(attribute='str',value=obj[,format='str')");    
  }
  if (typestr != NULL) format = (int)GetFormatFromString(typestr);

  data = array_from_python(value, &size, format, NULL);
  if (!data) return NULL;
  Py_BEGIN_ALLOW_THREADS;
  res = SetSystemAttribute(attr,data,format);
  Py_END_ALLOW_THREADS;
  free(data);
  if (res) return PyErr_Format(PyExc_IOError, "%s: setAttribute('%s'): %s",
                        "tine", attr, GetLastLinkError(res,errstr));
  Py_RETURN_NONE;
}
static PyObject* pytine_getAttribute(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *attr, *typestr = NULL;
  PyObject *value = NULL;
  BYTE data[64];
  int format = CF_INT32;
  int size=1,res;
  char errstr[128];
  static char *kwlist[] = {
        "attribute",
        "format",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s|s",  kwlist, &attr, &typestr)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.setAttribute(attribute='str'[,format='str')");    
  }
  if (typestr != NULL) format = (int)GetFormatFromString(typestr);

  Py_BEGIN_ALLOW_THREADS;
  res = GetSystemAttribute(attr,data,format);
  if (res == 0) array_to_python(&value, data, size, format, NULL, FALSE);
  Py_END_ALLOW_THREADS;
  if (res) return PyErr_Format(PyExc_IOError, "%s: getAttribute('%s'): %s",
                        "tine", attr, GetLastLinkError(res,errstr));
  return value;
}

#define BLOBSIZE 65536
BYTE dataBlob[BLOBSIZE];
static PyObject* pytine_get(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *server, *property = NULL, *typestr = NULL, *modestr = NULL;
  int timeout = 1000, sz=0, use_bytearray=FALSE;
  int maxsize= INT_MAX, mode = CM_TIMER, access = CA_READ;
  PyObject *value = NULL;
  PyObject *dtype = NULL;
  static char *kwlist[] = {
        "address",
        "property",
        "format",
        "size",
        "timeout",
        "mode",
        NULL
    };

  void *data;
  int size = 0, sizeBytes;
  int format = CF_NULL, fmt;
  int res;
  char *pc, tag[64];

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s|ssiis", kwlist, 
    &server, &property, &typestr, &size, &timeout, &modestr)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.get(address='str',property='str'[,format='str',size=val,timeout=val,mode='str')");    
  }
  if ((pc=strchr(server,'[')) != NULL) *pc++ = 0;
  if (property == NULL)
  {
    if (pc == NULL) return PyErr_Format(PyExc_ValueError, 
      "tine: address %s does not contain a property and no property provided as argument",server);
    property = pc;
    if ((pc=strchr(property,']')) != NULL) *pc = 0;
  }
  if (typestr != NULL) 
  {
    format = (int)GetFormatFromString(typestr);
    strupr(typestr);
    if (strstr(typestr,"BYTES") != NULL) use_bytearray = TRUE;
  }
  if (modestr != NULL) 
  {
    char mod[128];
    mode = (int)GetTransferMode(modestr); // just check CONNECT or NETWORK
    if (mode & CM_CONNECT) access |= CA_CONNECT;
    if (mode & CM_STREAM) access |= CA_STREAM;
    if (mode & CM_NETWORK) access |= CA_NETWORK;
    strncpy(mod,modestr,128); strupr(mod);
    if (strstr(mod,"WRITE") != NULL) access |= CA_WRITE;
    if (strstr(mod,"ASYNC") == NULL && strstr(mod,"SYNC") != NULL) access |= CA_SYNC;
  }
  if (acqInfo(size,format,typestr,tag,server))
  {
    sz = size;
    res = tine_getpropertyinformation(server, property, CA_READ, &format, &sz, tag);
    if (res != 0) return NULL;
    if (size == 0) size = sz;
  }
  else
  {
    if (getPrpItem(server,property) == NULL) addUsrPrpItem(server,property,size,format,tag,CA_READ);
  }
  fmt = (format == CF_MDA) ? GetFormatFromString(tag) : format;
  sizeBytes = fmtsizeof(fmt) * size;
  sizeBytes += getFormatHeaderSize(format);
  if (format == CF_STRUCT) sizeBytes = GetStructSize(tag) * size;
  if (format == CF_MDA) sizeBytes += sizeof(size_t);
  if (format == CF_IMAGE) sizeBytes += sizeof(int) + sizeof(size_t);
  if (format == CF_STRING) sizeBytes = size * sizeof(char *);
  data = malloc(sizeBytes);
  if (data == NULL)
  {
     return PyErr_Format(PyExc_MemoryError, "cannot allocate %d bytes",sizeBytes);
  }
  if (format == CF_IMAGE)
  { // make sure these parts of the 'embedded' DIMAGE are set properly
    ((DIMAGE *)data)->frameBufferSize = size;
    ((DIMAGE *)data)->frameBuffer = ((BYTE *)data) + getFormatHeaderSize(CF_IMAGE) + sizeof(int) + sizeof(size_t);
  }
  DTYPE d; DTYPEZERO(d);
  Py_BEGIN_ALLOW_THREADS;
  res = tine_read(server, property, data, &size, format, access, timeout, &d);
  Py_END_ALLOW_THREADS;
  int isErr = FALSE;
  char errstr[128];
  if (HAS_DATA(res)) array_to_python(&value, data, size, format, d.dTag, use_bytearray); else isErr = TRUE;
  free(data);
  if (isErr) return PyErr_Format(PyExc_IOError, "%s: get('%s', '%s'): %s",
                        "tine", server, property,  GetLastLinkError(res,errstr));
  double ts = d.dTimeStamp;
  dtype = Py_BuildValue("{s:i,s:d,s:i,s:i,s:s,s:O}",
    "status",res,"timestamp",ts,"sysstamp",d.sysStamp,"usrstamp",d.dStamp,"timestring",GetDataTimeString(ts,FALSE),"data",value);
  Py_CLEAR(value);
  return dtype;
}

static PyObject* pytine_set(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *server, *property, *typestr = NULL, *modestr = NULL;
  PyObject *value = NULL;
  int timeout = 10000;
  void *data;
  int size = 0;
  int format = CF_NULL, access = CA_WRITE;
  int res;
  char *pc, errstr[128], tag[64];
  static char *kwlist[] = {
        "address",
        "property",
        "input",
        "format",
        "size",
        "timeout",
        "mode",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s|sOsiis",  kwlist, &server, &property, &value, &typestr, &size, &timeout, &modestr)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.set(address='str',property='str'[,input=obj,format='str',size=val,timeout=val,mode='str')");    
  }
  if ((pc=strchr(server,'[')) != NULL) *pc++ = 0;
  if (property == NULL)
  {
    if (pc == NULL) return PyErr_Format(PyExc_ValueError, 
      "tine: address %s does not contain a property and no property provided as argument",server);
    property = pc;
    if ((pc=strchr(property,']')) != NULL) *pc = 0;
  }
  if (typestr != NULL) format = (int)GetFormatFromString(typestr);
  if (modestr != NULL) 
  {
    int m = (int)GetTransferMode(modestr); // just check CONNECT or NETWORK
    if (m & CM_CONNECT) access |= CA_CONNECT;
    if (m & CM_STREAM) access |= CA_STREAM;
  }

  if (value) 
  { // value given ...
    if (acqInfo(size,format,typestr,tag,server))
    {
      res = tine_getpropertyinformation(server, property, CA_WRITE, &format, &size, tag);
      if (res) return NULL;
    }
    else
    {
      if (getPrpItem(server,property) == NULL) addUsrPrpItem(server,property,size,format,tag,CA_WRITE);
    }
    /* After this call, size may be smaller as before, e.g. if a list
       contains fewer elements than the server accepts. */
    data = array_from_python(value, &size, format, tag);
    if (!data) return NULL;
    Py_BEGIN_ALLOW_THREADS;
    res = tine_write(server, property, data, size, format, tag, access, timeout);
    Py_END_ALLOW_THREADS;
    free(data);
  } 
  else
  { // If no value was given, this is a trigger without data.
    res = tine_write(server, property, NULL, 0, CF_NULL, NULL, access, timeout);
  }
  if (res) return PyErr_Format(PyExc_IOError, "%s: set('%s', '%s'): %s",
                        "tine", server, property,  GetLastLinkError(res,errstr));
  Py_RETURN_NONE;
}

static PyObject* pytine_call(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *server, *property, *typeOutStr=NULL, *typeInStr=NULL, *modestr=NULL;
  int timeout = 1000, sz = 0;
  int maxsize= INT_MAX;
  PyObject *value = NULL;
  PyObject *dtype = NULL;
  void *dataOut, *dataIn = NULL;
  int sizeOut = 0, sizeIn = 0, sizeBytes;
  int formatOut = CF_NULL, formatIn = CF_NULL, fmt;
  int res, mode = CM_TIMER, access = CA_READ, use_bytearray = FALSE;
  char *pc, tagOut[64] = "", tagIn[64] = "", mod[128];
  static char *kwlist[] = {
        "address",
        "property",
        "input",
        "mode",
        "format",
        "size",
        "inputformat",
        "inputsize",
        "timeout",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s|sOssisii", kwlist, &server, &property, 
    &value, &modestr, &typeOutStr, &sizeOut, &typeInStr, &sizeIn, &timeout)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.call(address='str',property='str'[,input=obj,format='str',size=val,inputformat='str',inputsize=val,timeout=val,mode='str')");    
  }
  if ((pc=strchr(server,'[')) != NULL) *pc++ = 0;
  if (property == NULL)
  {
    if (pc == NULL) return PyErr_Format(PyExc_ValueError, 
      "tine: address %s does not contain a property and no property provided as argument",server);
    property = pc;
    if ((pc=strchr(property,']')) != NULL) *pc = 0;
  }
  if (typeOutStr != NULL) 
  {
    formatOut = (int)GetFormatFromString(typeOutStr);
    strupr(typeOutStr);
    if (strstr(typeOutStr,"BYTES") != NULL) use_bytearray = TRUE;
  }
  if (typeInStr != NULL) formatIn = (int)GetFormatFromString(typeInStr);
  if (modestr != NULL) 
  {
    mode = (int)GetTransferMode(modestr); // just check CONNECT or NETWORK
    if (mode & CM_CONNECT) access |= CA_CONNECT;
    if (mode & CM_STREAM) access |= CA_STREAM;
    if (mode & CM_NETWORK) access |= CA_NETWORK;
    strncpy(mod,modestr,128); strupr(mod);
    if (strstr(mod,"WRITE") != NULL) access |= CA_WRITE;
    if (strstr(mod,"SYNC") != NULL) access |= CA_SYNC;
  }
  if (value) 
  { // value given ...
    if (typeInStr == NULL) typeInStr = typeOutStr;
    if (acqInfo(sizeIn,formatIn,typeInStr,tagIn,server))
    {
      if (sizeIn == 0) sizeIn = array_length_from_python(value);
      sz = sizeIn;
      res = tine_getpropertyinformation(server, property, access, &formatIn, &sz, tagIn);
      if (res != 0) return NULL;
      if (sizeIn == 0) sizeIn = sz;
    }
    dataIn = array_from_python(value, &sizeIn, formatIn, tagIn);
    if (!dataIn) return NULL;
  }
  if (acqInfo(sizeOut,formatOut,typeOutStr,tagOut,server))
  {
    sz = sizeOut;
    res = tine_getpropertyinformation(server, property, CA_READ, &formatOut, &sz, tagOut);
    if (res != 0) return NULL;
    if (sizeOut == 0) sizeOut = sz;
  }
  if (getPrpItem(server,property) == NULL) addUsrPrpItemEx(server,property,sizeOut,formatOut,tagOut,sizeIn,formatIn,tagIn);
  fmt = (formatOut == CF_MDA) ? GetFormatFromString(tagOut) : formatOut;
  sizeBytes = fmtsizeof(fmt) * sizeOut;
  sizeBytes += getFormatHeaderSize(formatOut);
  if (formatOut == CF_STRUCT) sizeBytes = GetStructSize(tagOut) * sizeOut;
  if (formatOut == CF_MDA) sizeBytes += sizeof(size_t);
  dataOut = malloc(sizeBytes);
  if (dataOut == NULL)
  {
     return PyErr_Format(PyExc_MemoryError, "cannot allocate %d bytes",sizeBytes);
  }
  DTYPE dout, din; 
  DTYPEZERO(dout); DTYPEZERO(din);
  dout.dArrayLength = (UINT32)sizeOut; dout.dFormat = formatOut;
  strncpy(dout.dTag,tagOut,TAG_NAME_SIZE);
  dout.data.vptr = dataOut;
  din.dArrayLength = (UINT32)sizeIn; din.dFormat = formatIn;
  strncpy(din.dTag,tagIn,TAG_NAME_SIZE);
  din.data.vptr = dataIn;
  Py_BEGIN_ALLOW_THREADS;
  res = tine_acq(server, property, &dout, &din, access, timeout);
  Py_END_ALLOW_THREADS;
  int isErr = FALSE;
  char errstr[128];
  if (HAS_DATA(res)) array_to_python(&value, dataOut, (int)dout.dArrayLength, formatOut, dout.dTag, use_bytearray); else isErr = TRUE;
  free(dataOut);
  if (isErr) return PyErr_Format(PyExc_IOError, "%s: call('%s', '%s'): %s",
                        "tine", server, property, GetLastLinkError(res,errstr));
  double ts = dout.dTimeStamp;
  dtype = Py_BuildValue("{s:i,s:d,s:i,s:i,s:s,s:O}",
    "status",res,"timestamp",ts,"sysstamp",dout.sysStamp,"usrstamp",dout.dStamp,"timestring",GetDataTimeString(ts,FALSE),"data",value);
  Py_CLEAR(value);
  return dtype;
}

static PyObject* pytine_hist(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *server, *property, *stop = NULL, *depth = NULL, *flags = NULL;
  int cc, timeout = 1000, depthsecs = 1000;
  PyObject *value = NULL;
  void *data;
  PyObject *dtype = NULL;
  int num = 0, smpl = 0, indx = 0;
  int format = CF_NULL, fmt;
  int acqSysStamp=FALSE, acqSnapshot=FALSE;
  time_t stopt=time(NULL), startt;
  char *pc, flgstr[128];
  static char *kwlist[] = {
        "address",
        "property",
        "stop",
        "depth",
        "flags",
        "timeout",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s|ssssi", kwlist, &server, &property, 
    &stop, &depth, &flags, &timeout)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.hist(address='str',property='str'[,stop='str',depth='str',flags='str',timeout=val)");    
  }
  if ((pc=strchr(server,'[')) != NULL) *pc++ = 0;
  if (property == NULL)
  {
    if (pc == NULL) return PyErr_Format(PyExc_ValueError, 
      "tine: address %s does not contain a property and no property provided as argument",server);
    property = pc;
    if ((pc=strchr(property,']')) != NULL) *pc = 0;
  }
  if (stop != NULL) stopt = parseTimeString(stop);
  if (depth != NULL) 
  {
    if (strstr(depth,"SNAP") != NULL || strstr(depth,"snap") != NULL)
    {
      acqSnapshot = TRUE;
      startt = stopt;
    }
    else
    {
      depthsecs = (int)parseDepthSting(depth);
      startt = stopt - depthsecs;
    }
  }

  if (flags != NULL)
  {
    strncpy(flgstr,flags,128); strupr(flgstr);
    if (strstr(flgstr,"SYSSTAMP") != NULL) acqSysStamp = TRUE;
    else if (strstr(flgstr,"SYSTEMSTAMP") != NULL) acqSysStamp = TRUE;
    else if (strstr(flgstr,"CYCLENUMBER") != NULL) acqSysStamp = TRUE;
    else if (strstr(flgstr,"PULSENUMBER") != NULL) acqSysStamp = TRUE;
    else if (strstr(flgstr,"EVENTNUMBER") != NULL) acqSysStamp = TRUE;
  }
  if (acqSnapshot)
  {
    cc = tine_getpropertyinformation(server, property, CA_READ, &format, &num, NULL);
    if (cc != 0) return NULL;
    data = calloc(num,fmtsizeof(format));
    fmt = format;
  }
  else if (acqSysStamp)
  {
    num = 1000;
    data = calloc(1000,sizeof(DBLDBLDBL));
    fmt = CF_DBLDBLDBL;
  }
  else
  {
    num = 1000;
    data = calloc(1000,sizeof(DBLDBL));
    fmt = CF_DBLDBL;
  }
  if (data == NULL)
  {
     return PyErr_Format(PyExc_MemoryError, "cannot allocate memory for history call");
  }
  if (timeout < 100) timeout = 100;
  Py_BEGIN_ALLOW_THREADS;
  cc = getArchivedData(server,property,startt,&stopt,smpl,indx,fmt,data,&num,timeout);
  Py_END_ALLOW_THREADS;
  if (cc == 0) array_to_python(&value, data, num, fmt, NULL, FALSE);
  free(data);
  if (cc) 
  {
    char errstr[128];
    return PyErr_Format(PyExc_IOError, "%s : hist('%s','%s') : %s","tine",server,property,GetLastLinkError(cc,errstr));
  }
  if (acqSnapshot)
  {
    dtype = Py_BuildValue("{s:s,s:d,s:O}","timestamp",GetDataTimeString((double)stopt,FALSE),"utc",(double)stopt,"data",value);
    Py_CLEAR(value);
  }
  else
  {
    dtype = value;
  }

  return dtype;
}

static PyObject* pytine_list(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *context=NULL, *server=NULL, *property=NULL, *device=NULL, *structtag=NULL, dev[132], tag[64];
  char *lbl1=NULL, *lbl2=NULL;
  int timeout = 1000;
  PyObject *value = NULL, *value2 = NULL;
  PyObject *dtype = NULL;
  NAME64 *n64 = NULL;
  NAME32 *n32 = NULL;
  int num;
  int cc, nlists = 1;
  char errstr[128];
  static char *kwlist[] = {
        "context",
        "server",
        "device",
        "property",
        "structure",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|sssss", kwlist, &context, &server, &device, &property, &structtag)) return NULL;
  if (context == NULL || strlen(context) == 0) 
  { // no context given -> get the available contexts
    num = 1024;
    if ((n32=(NAME32 *)calloc(num,32)) == NULL) return NULL;
    lbl1 = "contexts";
    Py_BEGIN_ALLOW_THREADS;
    cc = GetSystemContexts(n32,&num);
    Py_END_ALLOW_THREADS;
    if (!HAS_DATA(cc))
    {
      return PyErr_Format(PyExc_IOError, "%s : list() : %s","tine",GetLastLinkError(cc,errstr));
    }
    array_to_python(&value, n32, num, CF_NAME32, NULL, FALSE);
  }
  else if (server == NULL || strlen(server) == 0)
  { // no server given -> get the available servers for the context given
    num = 1024;
    if ((n32=(NAME32 *)calloc(num,32)) == NULL) return NULL;
    lbl1 = "servers";
    Py_BEGIN_ALLOW_THREADS;
    cc = GetSystemServers(context,n32,&num);
    Py_END_ALLOW_THREADS;
    if (!HAS_DATA(cc))
    {
      return PyErr_Format(PyExc_IOError, "%s : list('%s') : %s","tine",context,GetLastLinkError(cc,errstr));
    }
    array_to_python(&value, n32, num, CF_NAME32, NULL, FALSE);
  }
  else
  { // directed query for properties or devices
    sprintf(dev,"/%.32s/%.32s",context,server);
    if (structtag != NULL && strlen(structtag) > 0)
    { // here a query for structure fields
      if (GetStructFromTag(structtag) == NULL) AcquireAndRegisterStruct(dev,structtag,10);
      goto struct_query;
    }
    num = 2048;
    if ((n64=(NAME64 *)calloc(num,64)) == NULL) return NULL;
    if (device != NULL && strlen(device) > 0) 
    { // a device was specified -> get the targeted properties
      strcat(dev,"/"); strcat(dev,device);
      goto prps_query;
    }
    Py_BEGIN_ALLOW_THREADS;
    cc = GetSystemDevices(dev,property,n64,&num);
    Py_END_ALLOW_THREADS;
    if (!HAS_DATA(cc)) 
    {
      if (property == NULL) 
        return PyErr_Format(PyExc_IOError, "%s : list('%s','%s') : %s","tine",context,server,GetLastLinkError(cc,errstr));
      return PyErr_Format(PyExc_IOError, "%s : list('%s','%s','%s') : %s","tine",context,server,property,GetLastLinkError(cc,errstr));
    }
    if (cc != 0)
    { // is property oriented
      goto prps_query;
    }
    else
    {
      lbl1 = "devices";
      array_to_python(&value, n64, num, CF_NAME64, NULL, FALSE);
    }
prps_query:
    if (property != NULL && strlen(property) > 0) 
    { // a property was specified
      if (lbl1 == NULL)
      { // and a device was also specified !
        int format = CF_NULL;
        cc = tine_getpropertyinformation(server, property, CA_READ, &format, &num, tag);
        if (format == CF_STRUCT)
        {
          structtag = tag;
          goto struct_query;
        }
      }
      goto done; 
    }
    num = 2048;
    Py_BEGIN_ALLOW_THREADS;
    cc = GetSystemProperties(dev,n64,&num);
    Py_END_ALLOW_THREADS;
    if (!HAS_DATA(cc))
    {
      if (device == NULL)
        return PyErr_Format(PyExc_IOError, "%s : list('%s','%s') : %s","tine",context,server,GetLastLinkError(cc,errstr));
      return PyErr_Format(PyExc_IOError, "%s : list('%s','%s','%s') : %s","tine",context,server,device,GetLastLinkError(cc,errstr));
    }
    if (lbl1 == NULL) 
    { // no device list
      array_to_python(&value, n64, num, CF_NAME64, NULL, FALSE);
      lbl1 = "properties"; 
    }
    else 
    { // there is a device list 
      if (cc != 0) goto done; // property query function-> just dump the devices ...
      array_to_python(&value2, n64, num, CF_NAME64, NULL, FALSE);
      lbl2 = "properties";
      nlists = 2;
    }
    goto done;
struct_query:
    struct structStruct *ss = GetStructFromTag(structtag);
    if (ss == NULL) return PyErr_Format(PyExc_IOError, "structure %s is not registered",structtag);
    struct structFormat *sf;
    int i, nfields = 0;
    for (sf=ss->s; sf != NULL; sf=sf->nxt) if (sf->fmt != CF_NULL) nfields++;
    if ((n64=(NAME64 *)calloc(nfields,64)) == NULL)
    {
      return PyErr_Format(PyExc_MemoryError, "cannot allocated structure space");
    }
    for (sf=ss->s, i=0; sf != NULL && i<nfields; sf=sf->nxt, i++) 
    {
      if (sf->fmt == CF_NULL) continue;
      strncpy(n64[i].name,sf->field,FIELD_NAME_SIZE);
    }
    array_to_python(&value, n64, nfields, CF_NAME64, NULL, FALSE);
    lbl1 = "fields";
  }
done:
  if (n32 != NULL) free(n32);
  if (n64 != NULL) free(n64);
  if (nlists == 1 && lbl1 != NULL)
  {
    dtype = Py_BuildValue("{s:O}",lbl1,value);
    Py_CLEAR(value);
  }
  else if (lbl1 != NULL && lbl2 != NULL)
  {
    dtype = Py_BuildValue("{s:O,s:O}",lbl1,value,lbl2,value2);
    Py_CLEAR(value); Py_CLEAR(value2);
  }
  if (dtype == NULL)
    return PyErr_Format(PyExc_AttributeError, "nothing to list (arguments fully specified)!");
  return dtype;
}

static PyObject* pytine_tty(PyObject *self, PyObject *args) 
{
  char *cmd;
  if (!PyArg_ParseTuple(args, "s", &cmd)) return NULL;

  if (strlen(cmd) > 0) SystemInterpretConsoleCommand(cmd);

  Py_RETURN_NONE;
}
/**
 * import tine
 * valuelist = tine.query(server, property, value, timeout = 10000)
 */
static PyObject* pytine_query(PyObject *self, PyObject *args) 
{
  char *server, *property;
  PyObject *value_in = NULL;
  PyObject *value_out = NULL;
  long timeout = 10000;

  void *data_in;
  int size_in;
  int format_in;
  void *data_out = NULL;
  int size_out;
  int format_out;
  int res;
  char errstr[128], tagOut[64], tagIn[64];

  if (!PyArg_ParseTuple(args, "ssO|l", &server, &property, &value_in, &timeout)) return NULL;

  res = tine_getpropertyinformation(server, property, CA_WRITE, &format_in, &size_in, tagIn);
  if (res) return NULL;

  res = tine_getpropertyinformation(server, property, CA_READ, &format_out, &size_out, tagOut);
  if (res) return NULL;

  /* After this call, size may be smaller as before, e.g. if a list
     contains less elements than the server accepts. */
  data_in = array_from_python(value_in, &size_in, format_in, NULL);
  if (!data_in) return NULL;

  data_out = malloc(fmtsizeof(format_out) * size_out);

  Py_BEGIN_ALLOW_THREADS;
  res = tine_query(server, property, data_in, size_in, format_in, 
		               data_out, &size_out, &format_out, timeout);
  Py_END_ALLOW_THREADS;

  if (res != 0) 
  {
    free(data_in);
    free(data_out);
    return PyErr_Format(PyExc_IOError, "%s: query('%s', '%s'): %s",
			"tine", server, property,  GetLastLinkError(res,errstr));
  }

  array_to_python(&value_out, data_out, size_out, format_out, tagOut, FALSE);

  free(data_in);
  free(data_out);

  return value_out;
}

struct callback 
{
  PyObject *callable;
  void *data;
  size_t size;
  int format;
  int mode;
  int use_bytearray;
  char tag[TAG_NAME_SIZE];
};
typedef struct pyMonLnk
{
  char key[200];
  int lid; // link id
  int cbid; // callback id
  struct callback *cb;
  struct pyMonLnk *nxt;
} PyMonLnk; // Python monitor link
PyMonLnk *monLnks = NULL;

PyMonLnk *getMonLnk(int lid)
{
  PyMonLnk *lnk;
  for (lnk=monLnks; lnk != NULL; lnk=lnk->nxt)
  {
    if (lnk->lid == lid) return lnk;
  }
  return NULL;
}

void addMonLnk(int lid,int cbid,struct callback *cb,char *key)
{
  PyMonLnk *lnk;
  for (lnk=monLnks; lnk != NULL; lnk=lnk->nxt)
  {
    if (lnk->lid == lid) return; // already in list
  }
  if ((lnk=(PyMonLnk *)calloc(1,sizeof(PyMonLnk))) == NULL) return;
  lnk->lid = lid;
  lnk->cbid = cbid;
  lnk->cb = cb;
  strncpy(lnk->key,key,200);
  lnk->nxt = monLnks;
  monLnks = lnk;
  return;
}
void rmvMonLnk(int lid)
{
  PyMonLnk *lnk, *lnkp=NULL, *lnkn=NULL;
  for (lnk=monLnks; lnk != NULL; lnk=lnk->nxt)
  {
    lnkn = lnk->nxt;
    if (lnk->lid == lid)
    { // remove this one
      if (lnk == monLnks) monLnks = lnkn; else lnkp->nxt = lnkn;
      if (lnk->cb != NULL)
      {
        if (lnk->cb->data != NULL) free(lnk->cb->data);
        Py_XDECREF(lnk->cb->callable);
        free(lnk->cb);
        lnk->cb = NULL;
      }
      break;
    }
    lnkp = lnk;
  }
}

static void _callback_handler(int id, int cc, void *p) 
{
  PyGILState_STATE gstate;

  struct callback *cb = (struct callback*)p;
  PyObject *data = NULL, *result = NULL;
  PyMonLnk *lnk = getMonLnk(id);
  int cbid = lnk != NULL ? lnk->cbid : id;
  gstate = PyGILState_Ensure();

  array_to_python(&data, cb->data, (int)cb->size, cb->format, cb->tag, FALSE);

	PyObject *args = Py_BuildValue("(iiN)", cbid, cc, data);
	PyObject *kwargs = Py_BuildValue("",  NULL);
	result = PyObject_Call(cb->callable, args, kwargs);

	Py_XDECREF(args);
	Py_XDECREF(kwargs);
	Py_XDECREF(data);
	if (result != NULL) Py_XDECREF(result);

  PyGILState_Release(gstate);
}
static void _datacallback_handler(int id, int cc, void *p) 
{
  PyGILState_STATE gstate;

  struct callback *cb = (struct callback*)p;
  PyObject *data = NULL, *dtype = NULL, *result = NULL;
  PyMonLnk *lnk = getMonLnk(id);
  int cbid = lnk != NULL ? lnk->cbid : id;
  gstate = PyGILState_Ensure();
  int csiz = GetCompletionDataSize(id);
  if (csiz <= 0) csiz = (int)cb->size;
  array_to_python(&data, cb->data, csiz, cb->format, cb->tag, cb->use_bytearray); // always fill in regardless of cc
  DTYPE d; DTYPEZERO(d);
  UpdateDataStampsFromLinkId(id,&d);
  double ts = d.dTimeStamp;
  dtype = Py_BuildValue("{s:i,s:d,s:i,s:i,s:s,s:O}",
    "status",cc,"timestamp",ts,"sysstamp",d.sysStamp,"usrstamp",d.dStamp,"timestring",GetDataTimeString(ts,FALSE),"data",data);

	PyObject *args = Py_BuildValue("(iiN)", cbid, cc, dtype);
	PyObject *kwargs = Py_BuildValue("",  NULL);
	result = PyObject_Call(cb->callable, args, kwargs);

	Py_XDECREF(args);
	Py_XDECREF(kwargs);
	Py_XDECREF(data);
	Py_XDECREF(dtype);
	if (result != NULL) Py_XDECREF(result);  else PyErr_SetString(PyExc_TypeError, "unable to call data callback handler");

  PyGILState_Release(gstate);
}
static void _groupcallback_handler(int id, int cc, void *p) 
{
  PyGILState_STATE gstate;
  PyObject *data = NULL, *dtype = NULL, *result = NULL;
  GrpTblEntry *g=GetCallbackGroup((size_t)_groupcallback_handler);
  GrpMember *mbr;
  PyMonLnk *lnk;
  struct callback *cb = (struct callback*)p;
  int lid, csiz, mcc, n;
  double ts;
  DTYPE d; DTYPEZERO(d);
  if (g == NULL)
  { //TODO: throw an exception?  This shouldn't be possible
    return;
  }
  g->members = GetGroupMemberList(g);
  gstate = PyGILState_Ensure();
  PyObject *gtype = PyList_New(g->numInGrp);
  for (mbr=g->members,n=0; mbr != NULL && n < g->numInGrp; mbr=mbr->nxt, n++)
  {
    lid = mbr->conTblId;
    if ((lnk=getMonLnk(lid)) == NULL) continue;
    cb = lnk->cb;
    csiz = GetCompletionDataSize(lid);
    mcc = GetCurrentLinkStatus(lid);
    if (HAS_DATA(mcc)) array_to_python(&data, cb->data, csiz, cb->format, cb->tag, cb->use_bytearray);
    UpdateDataStampsFromLinkId(lid,&d);
    ts = d.dTimeStamp;
    dtype = Py_BuildValue("{s:i,s:s,s:i,s:d,s:i,s:i,s:O}",
      "id",lnk->cbid,"key",lnk->key,"status",cc,"timestamp",ts,
      "sysstamp",d.sysStamp,"usrstamp",d.dStamp,"data",data);
    PyList_SetItem(gtype, n, dtype);
  }
  PyObject *pdo = PyDict_New();
  PyDict_SetItemString(pdo,"members",gtype);
  PyDict_SetItemString(pdo,"synchronized",Py_BuildValue("i",(g->grpSyncLevel == GRP_SYNC_INSYNC?1:0)));
  PyDict_SetItemString(pdo,"timestring", Py_BuildValue("s",GetDataTimeString(ts,FALSE)));
  PyDict_SetItemString(pdo,"timestamp", Py_BuildValue("d",ts));
  PyDict_SetItemString(pdo,"systemstamp", Py_BuildValue("i",g->grpSysStamp));
	PyObject *args = Py_BuildValue("(iiN)", g->grpId, g->grpCc, pdo);
	PyObject *kwargs = Py_BuildValue("",  NULL);
	result = PyObject_Call(cb->callable, args, kwargs);

	Py_XDECREF(args);
	Py_XDECREF(kwargs);
	Py_XDECREF(data);
	Py_XDECREF(dtype);
	if (result != NULL) Py_XDECREF(result);  else PyErr_SetString(PyExc_TypeError, "unable to call group callback handler");

  PyGILState_Release(gstate);
}

static int acqInfo(int size,int format,char *typestr,char *tag,char *srv)
{
  if (size == 0) return TRUE;
  switch (format)
  {
    case CF_NULL:
    case CF_DEFAULT:
      return TRUE;
      break;
    case CF_STRUCT:
    case CF_BITFIELD8:
    case CF_BITFIELD16:
    case CF_BITFIELD32:
    case CF_BITFIELD64:
      {
        char *tagstr = strchr(typestr,'.');
        if (tagstr != NULL) strncpy(tag,++tagstr,TAG_NAME_SIZE); else return TRUE;
        if (GetStructFromTag(tag) == NULL) AcquireAndRegisterStruct(srv,tag,size);
        break;
      }
    default:
      break;
  }
  return FALSE;
}
static PyObject* pytine_attach(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *server, *property, *modestr = NULL, *tolstr = NULL;
  PyObject *callable, *value = NULL;
  int id = 0, interval = 1000, sz = 0;
  struct callback *cb;
  int formatOut = CF_NULL, sizeOut = 0, mode = CM_TIMER, use_bytearray = FALSE;
  int formatIn = CF_NULL, sizeIn = 0;
  char *pc, *typestrOut = NULL, *typestrIn = NULL, tagOut[64], tagIn[64] = "";
  void *dataIn = NULL;
  int cc=0, lid;
  static char *kwlist[] = {
        "address",
        "property",
        "callback",
        "input",
        "format",
        "size",
        "inputformat",
        "inputsize",
        "interval",
        "mode",
        "id",
        "tolerance",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "ssO|Osisiisis", kwlist,
    &server, &property, &callable, 
    &value, &typestrOut, &sizeOut, &typestrIn, &sizeIn, &interval, &modestr, &id, &tolstr)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.attach(address='str',property='str',callback=obj[,input=obj,format='str',size=val,inputformat='str',inputsize=val,interval=val,mode='str',id=val,tolerance='str')");    
  }
  if ((pc=strchr(server,'[')) != NULL) *pc++ = 0;
  if (property == NULL)
  {
    if (pc == NULL) return PyErr_Format(PyExc_ValueError, 
      "tine: address %s does not contain a property and no property provided as argument",server);
    property = pc;
    if ((pc=strchr(property,']')) != NULL) *pc = 0;
  }
  if (!PyCallable_Check(callable))
    return PyErr_Format(PyExc_ValueError, "%s: attach('%s', '%s'): %s",
                        "tine", server, property, "object not callable");
  if (value) 
  { // value given ...
    if (typestrIn == NULL) typestrIn = typestrOut;
    if (acqInfo(sizeIn,formatIn,typestrIn,tagIn,server))
    {
      sz = sizeIn;
      cc = tine_getpropertyinformation(server, property, CA_WRITE, &formatIn, &sz, tagIn);
      if (cc != 0) return NULL;
      if (sizeIn == 0) sizeIn = sz;
    }
    if (sizeIn == 0) 
    { // value give but info query didn't deliver ....
      sizeIn = 1; formatIn = CF_INT32;
    }
    dataIn = array_from_python(value, &sizeIn, formatIn, tagIn);
    if (!dataIn) return NULL;
  }
  if (typestrOut != NULL) 
  {
    formatOut = (int)GetFormatFromString(typestrOut);
    strupr(typestrOut);
    if (strstr(typestrOut,"BYTES") != NULL) use_bytearray = TRUE;
  }
  if (modestr != NULL) 
  {
    mode = (int)GetTransferMode(modestr);
  }
  if (tolstr != NULL && strlen(tolstr) > 0) mode |= CM_NODUPLICATES;
  int isGrouped = (mode & CM_GROUPED || mode & CM_SYNCGROUP) ? TRUE : FALSE;
  if (acqInfo(sizeOut,formatOut,typestrOut,tagOut,server))
  {
    sz = sizeOut;
    cc = tine_getpropertyinformation(server, property, CA_READ, &formatOut, &sz, tagOut);
    if (cc != 0) return NULL;
    if (sizeOut == 0) sizeOut = sz;
  }
  else
  {
    if (getPrpItem(server,property) == NULL) addUsrPrpItem(server,property,sizeOut,formatOut,tagOut,CA_READ);
  }
  int sizeBytes = fmtsizeof(formatOut) * sizeOut;
  sizeBytes += getFormatHeaderSize(formatOut);
  if (formatOut == CF_STRUCT) sizeBytes = GetStructSize(tagOut) * sizeOut;
  if (formatOut == CF_IMAGE) sizeBytes += sizeof(int) + sizeof(size_t);

  if ((cb=(struct callback *)malloc(sizeof(struct callback))) == NULL) 
    return PyErr_Format(PyExc_MemoryError, "cannot allocate %d bytes for callback",sizeof(struct callback));
  cb->callable = callable;
  cb->data     = malloc(sizeBytes);
  cb->size     = sizeOut;
  cb->format   = formatOut;
  cb->mode     = mode;
  cb->use_bytearray = use_bytearray;
  strncpy(cb->tag,tagOut,TAG_NAME_SIZE);

  if (cb->data == NULL) 
  {
    free(cb);
    return PyErr_Format(PyExc_MemoryError, "cannot allocate %d bytes for data",sizeBytes);
  }
  if (formatOut == CF_IMAGE)
  { // make sure these parts of the 'embedded' DIMAGE are set properly
    ((DIMAGE *)cb->data)->frameBufferSize = sizeOut;
    ((DIMAGE *)cb->data)->frameBuffer = ((BYTE *)cb->data) + getFormatHeaderSize(CF_IMAGE) + sizeof(int) + sizeof(size_t);
  }
  DTYPE dout, din;
  DTYPEZERO(dout); DTYPEZERO(din);
  dout.dArrayLength = (UINT32)sizeOut;
  dout.dFormat = formatOut;
  strncpy(dout.dTag,tagOut,TAG_NAME_SIZE);
  dout.data.vptr = cb->data;
  din.dArrayLength = sizeIn;
  din.dFormat = formatIn;
  strncpy(din.dTag,tagIn,TAG_NAME_SIZE);
  din.data.vptr = dataIn;
  /* Increase the refernce counter to let the Python know,
     that we need to keep this around. */
  Py_INCREF(cb->callable); // decrement this when we remove the monitor link
  XTCBFCNP cbfcn = isGrouped ? _groupcallback_handler : _datacallback_handler;
  Py_BEGIN_ALLOW_THREADS;
  lid = tine_attachEx(server, property, &dout, &din, cb->mode, interval, 
                    cbfcn, cb, UNASSIGNED_CALLBACKID);
  Py_END_ALLOW_THREADS;

  if (lid < 0) 
  {
    cc = -lid;
    PyErr_Format(PyExc_ConnectionError, "cannot attach to /%s[%s] (%.32s)",server,property,cc2str(cc));
  }
  else if (tolstr != NULL)
  {
    char tolStr[128];
    float tolAbs = 0, tolRel = 0, fv;
    strncpy(tolStr,tolstr,128); tolStr[127] = 0;
    if ((pc=strchr(tolStr,'+')) != NULL)
    {
      *pc++ = 0;
      fv = (float)strtod(pc,NULL);
      if (strchr(pc,'%') != NULL) tolRel = (float)(fv/100.0); else tolAbs = fv;
    }
    fv = (float)strtod(tolStr,NULL);
    if (strchr(tolStr,'%') != NULL) tolRel = (float)(fv/100.0); else tolAbs = fv;
    SetNotificationTolerance(lid, tolAbs, tolRel);
  }
  char key[200];
  sprintf(key,"%.132s[%.64s]",server,property);
  addMonLnk(lid,id,cb,key);
  return Py_BuildValue("i", lid);
}

/**
 * import tine
 * linkid = tine.attach(server, property, callable, id = 0, timeout = 10000)
 * # ...
 * tine.detach(linkid)
 */
static PyObject* pytine_detach(PyObject *self, PyObject *args) 
{
  int id;
  char errstr[128];

  if (!PyArg_ParseTuple(args, "i", &id)) return NULL;
  int res = tine_detach(id);
  rmvMonLnk(id);
  if (res != 0) return PyErr_Format(PyExc_IOError, "%s: detach(%d): %s",
                        "tine", id, GetLastLinkError(res,errstr));
  Py_RETURN_NONE;
}

static PyObject* pytine_strerror(PyObject *self, PyObject *args) 
{
  int cc;
  char errstr[128];
  if (!PyArg_ParseTuple(args, "i", &cc)) return NULL;
  return Py_BuildValue("s",  GetLastLinkError((short)cc,errstr));
}
static PyObject* pytine_version(PyObject *self, PyObject *args) 
{
  return PyBytes_FromFormat("TINE %s", GetSystemVersionString());
}

char gSrvEqm[16] = "";
static PyObject* pytine_register_fec(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *fec=NULL, *sub="MISC", *ctx="TEST", *dsc=NULL, *loc=NULL, *hdw="none", *rsp=NULL;
  int po = -1;
  int cc=0;
  static char *kwlist[] = {
        "name",
        "subsystem",
        "context",
        "description",
        "location",
        "hardware",
        "responsible",
        "port",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s|ssssssi", kwlist, &fec, &sub, &ctx, &dsc, &loc, &hdw, &rsp, &po)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.register_fec(name='str'[,subsystem='str',context='str',descripton='str',location='str',hardware='str',responsible='str',port=val])");    
  }
  if (po < 0) po = GetPortOffset(fec);
  cc = RegisterFecInformation(fec,sub,ctx,dsc,loc,hdw,rsp,po);
  return Py_BuildValue("i", cc);
}
static PyObject *pytine_clearAlarm(PyObject *self, PyObject *args, PyObject *kwargs)
{
  int cc = 0, nr = -1, code = 0;
  char *dev=NULL;
  static char *kwlist[] = {
        "code",
        "device",
        "devicenumber",
        "options",
        NULL
    };
  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|isi", kwlist, &code, &dev, &nr)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.clearalarm(code=val[,device='str',devicenumber=val,data=Object,options='str'])");    
  }
  if (nr == -1 && dev != NULL) nr = GetDeviceNumber(gSrvEqm,dev);
  if (dev != NULL && stricmp(dev, "ALL") == 0) nr = -1;
  if (code != 0 && nr < 0) ccerr(invalid_parameter);
  if (code == 0) ClearAlarm(gSrvEqm,nr); else RemoveAlarm(gSrvEqm,nr,code);
err:
  if (cc != 0)
  {
    char errstr[128];
    return PyErr_Format(PyExc_RuntimeError,"PyTine.clearalarm() cannot clear specific alarm for non-specified device! : %s",GetLastLinkError(cc,errstr));
  }
  return Py_BuildValue("i", cc);
}
static PyObject *pytine_setAlarm(PyObject *self, PyObject *args, PyObject *kwargs)
{
  PyObject *value = NULL;
  char *dev=NULL, optstr=NULL;
  int cc = 0, nr = 0, code = 0, flags = almNEWALARM;
  static char *kwlist[] = {
        "code",
        "device",
        "devicenumber",
        "data",
        "options",
        NULL
    };
  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "i|siOs", kwlist, &code, &dev, &nr, &value, &optstr)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.setalarm(code=val[,device='str',devicenumber=val,data=Object,options='str'])");    
  }
  BYTE *data = NULL;
  if (value != NULL)
  {
    ADS ads;
    if ((cc=GetAlarmDefinition(gSrvEqm,code,&ads)) == 0)
    {
      int sz = (int)ads.alarmDataArraySize;
      int fmt = (int)LFMT(ads.alarmDataFormat);
      data = (BYTE *)array_from_python(value, &sz, fmt, NULL);
      if (!data) ccerr(invalid_data);
    }
  }
  if (nr == 0 && dev != NULL) nr = GetDeviceNumber(gSrvEqm,dev);
  if (optstr != NULL)
  {
    char s[128];
    strncpy(s,(const char *)optstr,128);
    if (strstr((const char *)s,"TRANSIENT") != NULL) flags |= almTRANSIENT;
  }
  SetAlarmEx(gSrvEqm,nr,code,data,flags);
err:
  if (cc != 0)
  {
    char errstr[128];
    return PyErr_Format(PyExc_RuntimeError,"PyTine.setalarm() : %s",GetLastLinkError(cc,errstr));
  }
  return Py_BuildValue("i", cc);
}
static PyObject* pytine_register_server(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *c, *srv=NULL, *ctx="TEST", *eqm="PYEQM", *fec=NULL, *sub="MISC", expstr[128], fecstr[64];
  int sz = 1000, po = 0;
  int cc=0;
  static char *kwlist[] = {
        "name",
        "context",
        "eqm",
        "capacity",
        "fec",
        "subsystem",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "s|ssiss", kwlist, &srv, &ctx, &eqm, &sz, &fec, &sub)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.register_server(name='str'[,context='str',eqm='str',capacity=val,fec='str',subsystem='str'])");    
  }
  if (!strcmp(GetExportedFecName(),FECNAME_UNKNOWN))
  { // fec name not yet known ...
    if (fec == NULL)
    { // and not specified ...
      memset(fecstr,0,64);
      strncpy(fecstr,ctx,2);
      if ((c=strchr(ctx,'.')) != NULL) strncat(fecstr,++c,2);
      else if ((c=strchr(ctx,'_')) != NULL) strncat(fecstr,++c,1);
      strncat(fecstr,srv,32);
      while ((c=strchr(fecstr,'.')) != NULL || (c=strchr(fecstr,'_')) != NULL || (c=strchr(fecstr,' ')) != NULL)
      { // remove any funny characters ...
        *c++ = 0;
        strcat(fecstr,c);
      }
      fecstr[16] = 0;
      fec = fecstr;
    }
    po = GetPortOffset(fec);
    char *rsp = NULL, *dsc = NULL;
    cc = RegisterFecInformation(fec,sub,ctx,dsc,NULL,"none",rsp,po);
  }
  sprintf(expstr,"%.32s/INIT=SRV|KEEP",srv);
  cc = AttachServerEx(expstr,eqm,sz,NULL,0);
  strncpy(gSrvEqm,eqm,EQM_NAME_SHORTSIZE);
  return Py_BuildValue("i", cc);
}
static PyObject* pytine_register_device(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *nam=NULL, *dsc=NULL, *loc=NULL, *rdr=NULL;
  PyObject *prpLst = NULL;
  float zpos = 0;
  int nr = 0;
  int cc=0;
  static char *kwlist[] = {
        "name",
        "number",
        "description",
        "location",
        "zposition",
        "redirection",
        "propertylist",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "si|ssfsO", kwlist, &nam, &nr, &dsc, &loc, &zpos, &rdr, &prpLst)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.register_device(name='str',number=val[,description='str',location='str',zposition=val,redirection='str',propertylist=Dict])");    
  }
  cc = RegisterDeviceName(gSrvEqm,nam,nr);
  if (cc == 0)
  {
     if (dsc != NULL) RegisterDeviceDescription(gSrvEqm,nam,dsc);
     if (loc != NULL) SetDeviceLocation(gSrvEqm,nam,loc);
     if (zpos != 0) SetDeviceZPosition(gSrvEqm,nam,zpos);
     if (prpLst != NULL)
     {
       if (!PyDict_Check(prpLst))
       {
         return PyErr_Format(PyExc_TypeError, "dictionary expected for property list!");
       }
       if (PyDict_Size(prpLst) < 1)
       {
         return PyErr_Format(PyExc_TypeError, "property list dictionary is empty !");
       }
       PyObject *key, *value;
       Py_ssize_t pos = 0;
       PyDict_Next(prpLst, &pos, &key, &value);
       void *data;
       int lsz = 1;
       if ((data = array_from_python(value, &lsz, CF_NAME64, NULL)) != NULL)
       {
         char keyStr[512];
         data_from_python(key, (void *)keyStr, CF_TEXT, NULL);
         cc = AssignPropertyList(gSrvEqm, nam, keyStr, lsz, (NAME64 *)data);
       }
     }
  }
  return Py_BuildValue("i", cc);
}
static PyObject* pytine_register_property(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *nam=NULL, *tag=NULL, *dsc=NULL, *egu=NULL, *modstr=NULL, *fmtstr=NULL;
  PyObject *devLst = NULL;
  float max = 0, min = 0;
  int sz=0, szIn=0, fmt=CF_NULL, fmtIn=CF_NULL, acc=CA_READ;
  int cc=0;
  static char *kwlist[] = {
        "name",
        "size",
        "format",
        "mode",
        "min",
        "max",
        "units",
        "description",
        "devicelist",
    NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sis|sffssO", kwlist, &nam, &sz, &fmtstr, &modstr, &min, &max, &egu, &dsc, &devLst)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.register_property(name='str',size=val,format='str'[,mode='str,min=val,max=val,units='str',description='str',devicelist=Dict])");    
  }
  int atyp = AT_UNKNOWN;
  if (fmtstr != NULL) 
  {
    fmt = (int)GetFormatFromString(fmtstr);
    if (strchr(fmtstr,'.') != NULL) atyp = GetArrayTypeFromString(fmtstr);
  }
  if (atyp == AT_UNKNOWN) atyp = AT_SPECTRUM;
  if ((tag=strchr(fmtstr,'.')) != NULL) tag++;
  if (modstr != NULL) 
  {
    char mod[128];
    strncpy(mod,modstr,128); strupr(mod);
    if (strstr(mod,"WRITE") != NULL) acc |= CA_WRITE;
    if (strstr(mod,"NETWORK") != NULL) acc |= CA_NETWORK;
    if (strstr(mod,"HIST") != NULL) acc |= CA_HIST;
  }
  if (acc & CA_WRITE && sz > 0) 
  {
    szIn = 1;
    fmtIn = fmt;
  }
  cc = RegisterBufferedPropertyEx2(nam,szIn,fmtIn,tag,sz,fmt,tag,max,min,egu,acc,dsc,-1,atyp,sz); 
  if (devLst != NULL)
  {
    if (!PyDict_Check(devLst))
    {
      return PyErr_Format(PyExc_TypeError, "dictionary expected for device list!");
    }
    if (PyDict_Size(devLst) < 1)
    {
      return PyErr_Format(PyExc_TypeError, "device list dictionary is empty !");
    }
    PyObject *key, *value;
    Py_ssize_t pos = 0;
    PyDict_Next(devLst, &pos, &key, &value);
    void *data;
    int lsz = 1;
    if ((data = array_from_python(value, &lsz, CF_NAME64, NULL)) != NULL)
    {
      cc = AssignDeviceListToProperty(gSrvEqm, nam, (NAME64 *)data, lsz);
    }
  }

  return Py_BuildValue("i", cc);
}
static PyObject* pytine_attach_server(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *srv=NULL, *eqm=NULL;
  int sz = 0;
  int cc=0;
  static char *kwlist[] = {
        "server",
        "eqm",
        "capacity",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "|ssi", kwlist, &srv, &eqm, &sz)) 
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.attach_server(server='str',eqm='str',capacity=val)");    
  }
  if (srv == NULL && eqm == NULL)
  {
    cc = AttachServerFromFecXml();
  }
  else
  {
    char srvStr[64], eqmStr[64], *psrv=NULL, *peqm=NULL;
    if (srv != NULL)
    {
      sprintf(srvStr,"%.32s/INIT=KEEP",srv);
      psrv = srvStr;
    }
    else if (eqm != NULL)
    {
      sprintf(eqmStr,"%.6s",eqm);
      if (srv == NULL) strcat(eqmStr,"/INIT=KEEP");
      peqm = eqmStr;
    }
    cc = AttachServerEx(psrv,peqm,sz,NULL,0); 
  }
  strncpy(gSrvEqm,GetEquipmentModuleName(),EQM_NAME_SHORTSIZE);
  return Py_BuildValue("i", cc);
}
static PyObject* pytine_pushdata(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  PyObject *value = NULL;
  char *c, *prp=NULL, *dev=NULL;
  int nr = 0, sz = 1, lsz = 1, schd = 0, syss = 0, usrs = 0;
  double ts = 0;
  int cc=0, szOut, fmt;
  char devName[64], fmtStr[128], tag[64];
  BYTE *data, *pdata;
  char **sa = NULL;
  static char *kwlist[] = {
        "property",
        "data",
        "device",
        "devicenumber",
        "size",
        "scheduled",
        "timestamp",
        "systemstamp",
        "userstamp",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO|siiidii", kwlist, &prp, &value, &dev, &nr, &sz, &schd, &ts, &syss, &usrs)) 
  {
     return PyErr_Format(PyExc_SyntaxError, 
       "PyTine.pushdata(property='str',data=object,device='str',devicenumber=val,size=val,scheduled=val,timestamp=val)");    
  }

  cc = GetRegisteredPropertyInformation(gSrvEqm,prp,NULL,NULL,NULL,&szOut,NULL,fmtStr,NULL,NULL);
  if (cc != 0) goto err;
  fmt = GetFormatFromString(fmtStr);
  if ((c=strchr(fmtStr,'.')) != 0) strncpy(tag,++c,TAG_NAME_SIZE); else tag[0] = 0;

  data = (BYTE *)array_from_python(value, &lsz, fmt, tag);
  if (sz == 1) sz = lsz;
  if (!data) ccerr(invalid_data);
  if (sz < szOut) SetBufferedDataSize(prp,sz); else SetBufferedDataSize(prp,0);
  if (nr == 0 && dev != NULL) nr = GetDeviceNumber(gSrvEqm,dev);
  sprintf(devName,"#%d",nr);
  if (ts > 1000 && schd == 0) schd = (int)ts;
  pdata = data;
  if (fmt == CF_STRING)
  { // gotta find the strings ...
    int p = 0;
    sa = (char **)alloca(sz * sizeof(char *));
    if (sa == NULL) ccerr(out_of_local_memory);
    for (int i = 0; i < sz; i++)
    {
      sa[i] = (char *)&data[p];
      p += (int)(strlen(sa[i])+1);
    }
    pdata = (BYTE *)sa;
  }
  Py_BEGIN_ALLOW_THREADS;
  cc = pushBufferedDataEx(prp,devName,pdata,sz,schd,ts,syss,usrs);
  Py_END_ALLOW_THREADS;
  free(data);
err:
  if (cc != 0)
  {
    char errstr[128];
    return PyErr_Format(PyExc_RuntimeError,"PyTine.pushdata(%s) : %s",prp,GetLastLinkError(cc,errstr));
  }
  return Py_BuildValue("i", cc);
}

int prpHdlr(char *prp,char *dev, void *ref)
{
  PyGILState_STATE gstate;
  PyObject *callable = (PyObject *)ref;
  PyObject *data = Py_None, *dtype = NULL;

  gstate = PyGILState_Ensure();
  int szIn=0;
  char *c, fmtStr[128], tag[64];
  int cc = GetRegisteredPropertyInformation(gSrvEqm,prp,NULL,NULL,NULL,NULL,&szIn,NULL,fmtStr,NULL);
  if (cc != 0) ccerr(cc);
  if (szIn > 0)
  {
    int fmt = GetFormatFromString(fmtStr);
    if ((c=strchr(fmtStr,'.')) != 0) strncpy(tag,++c,TAG_NAME_SIZE);
    int fsiz = fmtsizeof(fmt);
    if (fmt == CF_STRUCT) fsiz = GetStructSize(tag);
    fsiz *= szIn;
    fsiz += getFormatHeaderSize(fmt);
    BYTE *rbdata = (BYTE *)malloc(fsiz);
    if (!rbdata) return out_of_server_memory;
    cc = pullBufferedData(prp,dev,rbdata,szIn);
    if (cc == 0) array_to_python(&data,rbdata,szIn,fmt,tag, FALSE);
    free(rbdata);
  }
  else
  {
    data = Py_None;
  }
  if (cc == 0)
  {
    int nr = GetDeviceNumberEx(gSrvEqm,dev,prp);
    dtype = Py_BuildValue("{s:s,s:s,s:i,s:s,s:O}","property",prp,"device",dev,"devicenumber",nr,"caller",c=GetCaller(gSrvEqm),"data",data);

	  PyObject *args = Py_BuildValue("(N)", dtype);
	  PyObject *kwargs = Py_BuildValue("",  NULL);
	  PyObject *result = PyObject_Call(callable, args, kwargs);
    data_from_python(result,&cc,CF_INT32,NULL);

	  Py_XDECREF(args);
	  Py_XDECREF(kwargs);
	  Py_XDECREF(data);
	  Py_XDECREF(dtype);
    if (result != NULL) Py_XDECREF(result); else PyErr_SetString(PyExc_TypeError, "unable to call property handler");
  }
err:
  PyGILState_Release(gstate);
  return cc;
}
static PyObject* pytine_attach_handler(PyObject *self, PyObject *args, PyObject *kwargs) 
{
  char *property;
  PyObject *handler, *value = NULL;
  int id = 0, interval = 1000, sz = 0;
  int cc=0;
  static char *kwlist[] = {
        "property",
        "handler",
        NULL
    };

  if (!PyArg_ParseTupleAndKeywords(args, kwargs, "sO", kwlist, &property, &handler))
  {
     return PyErr_Format(PyExc_SyntaxError, "PyTine.attach(property='str',handler=obj)");    
  }
  if (!PyCallable_Check(handler))
    return PyErr_Format(PyExc_ValueError, "tine: attach_handler('%s'): %s",
                        property, "object not callable");

  /* Increase the refernce counter to let the Python know,
     that we need to keep this around. */
  Py_INCREF(handler);
  Py_BEGIN_ALLOW_THREADS;
  cc = RegisterServerCallbackEx(property, prpHdlr, handler);
  Py_END_ALLOW_THREADS;

  return Py_BuildValue("i", cc);
}

struct module_state {
    PyObject *error;
};
static PyMethodDef tine_methods[] = {
  { "get_attribute", (PyCFunction)pytine_getAttribute, METH_VARARGS|METH_KEYWORDS, "'attribute'[,'format']" },
  { "set_attribute", (PyCFunction)pytine_setAttribute, METH_VARARGS|METH_KEYWORDS, "'attribute',value[,'format']" },
  { "get", (PyCFunction)pytine_get, METH_VARARGS|METH_KEYWORDS, "'address','property'[,'format',size,timeout,'mode']" },
  { "set", (PyCFunction)pytine_set, METH_VARARGS|METH_KEYWORDS, "'address','property'[,input,'format',size,timeout,'mode']" },
  { "call",(PyCFunction)pytine_call,METH_VARARGS|METH_KEYWORDS, "'address','property'[,input,'mode','format',size,'inputformat',inputsize,timeout]" },
  { "query",    pytine_query,    METH_VARARGS, "" },
  { "attach", (PyCFunction)pytine_attach,METH_VARARGS|METH_KEYWORDS,"'address','property',callback[,input,'format',size,'inputformat',inputsize,interval,'mode',id,'tolerance']" },
  { "detach",   pytine_detach,   METH_VARARGS, "linkid" },
  { "list", (PyCFunction)pytine_list, METH_VARARGS|METH_KEYWORDS, "[context,server,device,property,structure]" },
  { "history",(PyCFunction)pytine_hist,METH_VARARGS|METH_KEYWORDS, "address,property[,'stop','depth','flags',timeout]" },
  { "attach_server", (PyCFunction)pytine_attach_server,METH_VARARGS|METH_KEYWORDS,"['server','eqm',capacity]" },
  { "pushdata", (PyCFunction)pytine_pushdata,METH_VARARGS|METH_KEYWORDS,"property, data, (device, devicenumber) [,size, scheduled, timestamp" },
  { "attach_handler", (PyCFunction)pytine_attach_handler,METH_VARARGS|METH_KEYWORDS,"'property',handler" },
  { "register_fec", (PyCFunction)pytine_register_fec,METH_VARARGS|METH_KEYWORDS,"'name',['subsystem','context','description','location','hardware','responsible',port]" },
  { "register_server", (PyCFunction)pytine_register_server,METH_VARARGS|METH_KEYWORDS,"'name'[,'context','eqm',capacity,'fec','subsystem']" },
  { "register_device", (PyCFunction)pytine_register_device,METH_VARARGS|METH_KEYWORDS,"'name',number,['description','location','hardware','responsible',zposition,'redirection',propertylist]" },
  { "register_property", (PyCFunction)pytine_register_property,METH_VARARGS|METH_KEYWORDS,"'name',size,'format',['mode',min,max,'units','description',devicelist]" },
  { "setalarm", (PyCFunction)pytine_setAlarm,METH_VARARGS|METH_KEYWORDS,"'code'[,('device',devicenumber),data,'options']" },
  { "clearalarm", (PyCFunction)pytine_clearAlarm,METH_VARARGS|METH_KEYWORDS,"['code',('device',devicenumber)]" },
  { "strerror", pytine_strerror, METH_VARARGS, "error code" },
  { "version",  pytine_version,  METH_NOARGS,  "" },
  { "debug",    pytine_tty,      METH_VARARGS, "debug command"},
  { NULL,       NULL,      0,            NULL }
};

#define GETSTATE(m) ((struct module_state*)PyModule_GetState(m))

static int myextension_traverse(PyObject *m, visitproc visit, void *arg) 
{
    Py_VISIT(GETSTATE(m)->error);
    return 0;
}

static int myextension_clear(PyObject *m) 
{
    Py_CLEAR(GETSTATE(m)->error);
    return 0;
}

static struct PyModuleDef tine_module = {
        PyModuleDef_HEAD_INIT,
        "tine",
        NULL,
        sizeof(struct module_state),
        tine_methods,
        NULL,
        myextension_traverse,
        myextension_clear,
        NULL
};


PyMODINIT_FUNC PyInit_PyTine (void) 
{
  PyEval_InitThreads();

  PyObject *module = PyModule_Create(&tine_module);

# ifdef USE_NUMPY
  import_array1(NULL);
# endif

  SetConnectionTableCapacity(5000);
  SetUserType("PyTine");
  SystemStartCycleTimer();
  Py_AtExit(SystemKillCycleTimer);
  return module;
}



