#ifndef _SHMALLOC_H_
#define _SHMALLOC_H_
#include "prolog.h"

#define MMF_MSGLOOP

#define hSHARE INVALID_HANDLE_VALUE

#define WM_REQ_LCL        (WM_USER+100)
#define WM_RCV_LCL        (WM_USER+101)
#define WM_STOP_LCL       (WM_USER+102)

#define WORK_BUFFER_SIZE 0x10000 //0x2000
#define SHM_BUFFER_SIZE WORK_BUFFER_SIZE
extern UINT32 gShmBufferSize;

typedef struct 
{
  char dataTag[16];
  int  dirty;
  int  size;
} shmDataGram;

#define shmPayload(d) ((BYTE *)(d) + sizeof(shmDataGram))

extern HWND gInLclAdr;
extern HWND hShmWnd;
extern HINSTANCE hParent;
extern int gForceShmDatagrams;

HANDLE mmfalloc(char *tag,int SizeInBytes,BYTE **lpView,int *mmfFlag);
int mmfInit(void);
shmDataGram *shmGetDataGram(char *tag,int size,HANDLE *h);
int shmSndDataGram(ClnHdr *cln,char *tag,BYTE *data,int size,HANDLE *h,UINT iMessage);
void shmFreeDataGram(shmDataGram *dg,HANDLE h);
BYTE *shmDataBlockAlloc(char *tag,int size,HANDLE *hBlock);
void shmDataBlockFree(BYTE *d,HANDLE hBlock);
int CreateShmWindow(void);
int shmStart(void);
int shmStop(void);
void DestroyShmWindow(void);
TINE_EXPORT void SetForceShmDatagrams(int value);
int sendShmData(ClnHdr *cln,BYTE *data,int size,UINT iMessage);
void DoEvents(int maxevents);
void DoClientEvents(int maxevents);
void DoServerEvents(int maxevents);
TINE_EXPORT void SetMMFMessageSize(int sizeInBytes);

#endif /* _SHMALLOC_H_ */
