#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "tine.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
int talarms(char *srv,char *dev);
int ReportError(int cc);

char *usageTxt[] = {
  "\nRetrieves the current list of alarms for the given device server and device\n",
  "talarms <device server> <device>",
  "e.g. talarms /HERA/PBLM",
  "\nor\n      talarms /HERA/PBLM/WL167",
  "\nSee also: 'tservers', 'tdevlist' for retrieving information",
};

#define nUsageLines (int)(sizeof(usageTxt)/sizeof(char *))

int main(int argc, char *argv[])
{
  int i;
  char *pdev = "*";
  if (argc < 2) 
  {
    for (i=0; i<nUsageLines; i++)
    {
      printf(i == 1 ? "Usage : " : "        ");
      printf("%s\n",usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  if (argc > 2) pdev = argv[2];
  MaxNumConnections = 10;
  gListenForGlobals = gListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 200;
  nofeclog = TRUE;
  SetUserType("CMDLINE");
  printf("\n");
  return ReportError(talarms(argv[1], pdev));
}
