#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "tine.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
extern int displayErrorMessages;
int tprops(char *dev);
int tproplist(char *dev);
int ReportError(int cc);
char *usageTxt[] = {
  "\nRetrieves a list of registered properties for the given device server\n",
  "tproplist /<context/<server>[/<device>] [/e=<TRUE,FALSE> /d=<debug level>]",
  "e.g. tproplist /HERA/HEPBLM",
  "  or tproplist /HERA/HEPBLM/WL105K1",
  "\nIf you specify a specific device name and it contains blanks use \"\"",
  "e.g. tproplist \"/HERA/HEPBPM/WL197 MX\"",
  "\nUse /e=TRUE or FALSE to display error messages when the call is not successfull (default=TRUE)",
  "\nSee also: 'tservers', 'tdevlist' for retrieving information",
};

#define nUsageLines (int)(sizeof(usageTxt)/sizeof(char *))

int main(int argc, char *argv[])
{
  char *c, scratch[256];
  int i;
  if (argc < 2) 
  {
dumpUsage:
    for (i=0; i<nUsageLines; i++)
    {
      printf(i == 1 ? "Usage : " : "        ");
      printf("%s\n",usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  if (*(argv[1]) == '?' || !strncmp(argv[1],"/?",2)) goto dumpUsage;
  for (i=2; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'e':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          strncpy(scratch, c, 32);
          displayErrorMessages = strtobool(scratch);
        }
        continue;
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
          foregroundTTY = TRUE;
        }
        continue;
      case '?': goto dumpUsage;
      default:
        continue;
    }
  }  
  MaxNumConnections = 10;
  gListenForGlobals = gListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 50;
  nofeclog = TRUE;
  SetUserType("CMDLINE");
  printf("\n");
  return ReportError(tproplist(argv[1]));
}
